/*'SMOO-CLASS.*/
#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "player.h"

char golem_ranks[11][20] =
{"",
 "Rok", "Anhk",  "Mith", "Surreal", "Tith",
 "Lark","Mentro","Hard", "Soft",    "Tiny"};

void emerald_convert(CHAR_DATA *);
void obsidian_convert(CHAR_DATA *);
void crystal_convert(CHAR_DATA *);

#define SS(skill) skill_lookup((skill))
#define COMBO(gsn,dam) \
	{if (!ch->fighting) {stc("You aren't fighting anybody..\n\r",ch);return;}\
	if (number_range(1,100) <= 19) {damage(ch, ch->fighting, 0, \
	SS(gsn));}else {\
	damage(ch, ch->fighting, dam, SS(gsn));\
	WAIT_STATE(ch, skill_table[SS(gsn)].beats);}}	

#define IS_MOVE(ch, move) (ch)->moves & (move)
#define SET_MOVE(ch, move) (ch)->moves |= (move)


void do_sumosplash(CHAR_DATA *ch, char *argument)
{
 int dam = number_range(250,500);
 if (IS_STONE(ch)) dam *= 2.3;
 if (!IS_CLASS(ch, CLASS_GOLEM)) {do_huh(ch,"");return;}

 COMBO("sumosplash", dam)

 if (IS_MOVE(ch,OBSIDIAN_MOVE2))
    SET_MOVE(ch,OBSIDIAN_MOVE3);
 else if (IS_MOVE(ch,EMERALD_MOVE2))
    {ch->moves = 0;emerald_convert(ch);}
 else {ch->moves = 0;SET_MOVE(ch,EMERALD_MOVE1);}

 return;
}

void do_bazmapunch(CHAR_DATA *ch, char *argument)
{
 int dam = number_range(250,500);
 if (IS_STONE(ch)) dam *= 2.3;
 if (!IS_CLASS(ch, CLASS_GOLEM)) {do_huh(ch,"");return;}

 COMBO("bazmapunch", dam)

 if (IS_MOVE(ch, CRYSTAL_MOVE2))
    {ch->moves = 0;crystal_convert(ch);}
 else if (IS_MOVE(ch,OBSIDIAN_MOVE3))
    {SET_MOVE(ch,OBSIDIAN_MOVE4);}
 else if (IS_MOVE(ch,EMERALD_MOVE1))
    {SET_MOVE(ch,EMERALD_MOVE2);}
 else ch->moves = 0;

 return;
}

void do_neckcrack(CHAR_DATA *ch, char *argument)
{
 int dam = number_range(250,500);
 if (IS_STONE(ch)) dam *= 2.3;
 if (!IS_CLASS(ch, CLASS_GOLEM)) {do_huh(ch,"");return;}

 COMBO("neckcrack", dam)

if (IS_MOVE(ch, OBSIDIAN_MOVE5))
{ch->moves = 0;obsidian_convert(ch);}
else if (IS_MOVE(ch, OBSIDIAN_MOVE4))
SET_MOVE(ch,OBSIDIAN_MOVE5);
else
 {ch->moves = 0;}

 return;
}

void do_backslash(CHAR_DATA *ch, char *argument)
{
 int dam = number_range(50,700);
 if (IS_STONE(ch)) dam *= 2.3;
 if (!IS_CLASS(ch, CLASS_GOLEM)) {do_huh(ch,"");return;}

 COMBO("backslash", dam)

 {ch->moves = 0;SET_MOVE(ch,OBSIDIAN_MOVE1);}

 return;
}

void do_elbowbash(CHAR_DATA *ch, char *argument)
{
 int dam = number_range(350,625);
 if (IS_STONE(ch)) dam *= 2.3;
 if (!IS_CLASS(ch, CLASS_GOLEM)) {do_huh(ch,"");return;}

 COMBO("elbowbash", dam)

if (IS_MOVE(ch,OBSIDIAN_MOVE1))
 SET_MOVE(ch,OBSIDIAN_MOVE2);
else
 {ch->moves = 0; SET_MOVE(ch, CRYSTAL_MOVE1);}

 return;
}

void do_groinkick(CHAR_DATA *ch,char *argument)
{
 int dam = number_range(450,725);
 if (IS_STONE(ch)) dam *= 1.89;
 if (!IS_CLASS(ch, CLASS_GOLEM)) {do_huh(ch,"");return;}

 if (ch->fighting && ch->fighting->sex == SEX_FEMALE)
{
  stc("They don't have the proper groin mechanisms to make that HURT!\n\r", ch);
}else
  COMBO("groinkick", dam)

 if (IS_MOVE(ch, CRYSTAL_MOVE1))
     SET_MOVE(ch, CRYSTAL_MOVE2);
 else ch->moves = 0;

 return;
}


void crystal_convert( CHAR_DATA * ch)
{
 act("$n's body glows brightly..",ch,0x0,0x0,TO_ROOM);
 act("Your body glows brightly..",ch,0x0,0x0,TO_CHAR);
 if (IS_STONE(ch)) {ch->countdown = 1; crystal_change(ch);} else
 ch->countdown = 4;
 ch->convert_to = GOLEM_CRYSTAL;

 return;
}

void crystal_change(CHAR_DATA *ch)
{
 char buf[200];
 if ((!ch->fighting || ch->position != POS_FIGHTING) &&
!IS_SET(ch->pcdata->powers[0], GOLEM_CRYSTAL))
 {
    ch->countdown = 0;ch->convert_to = 0;
    return;
 }
if (ch->countdown <= 0 && !IS_SET(ch->pcdata->powers[0],GOLEM_CRYSTAL))
    return;

 if (IS_SET(ch->pcdata->powers[0], GOLEM_CRYSTAL))
 {
     if (ch->wait2 > 0) return;
     act("#5The crystal shell surrounding $n shatters and $e pops back to life!#n",ch,0x0,0x0,TO_ROOM);
     act("#5The crystal shell surrounding your shatters and you pop back to life!#n",ch,0x0,0x0,TO_CHAR);
     REMOVE_BIT(ch->pcdata->powers[0],GOLEM_CRYSTAL);
     return;
 }

 if (--ch->countdown > 0)
 {
    sprintf(buf,"#%d$n's body glows even brighter..",ch->countdown);
    act(buf,ch,0x0,0x0,TO_ROOM);
    sprintf(buf,"#%dYour body glows even brighter..",ch->countdown);
    act(buf,ch,0x0,0x0,TO_CHAR);
 }
 else
 {if (IS_STONE(ch)) NO_STONE(ch);
    act("#6Your body unleashes a BURST of bright energy and you solidify into a crystal!#n",ch,0x0,0x0,TO_CHAR);
    act("#6$n's body unleashes a BURST of bright energy and $e solidifies into a crystal!#n",ch,0x0,0x0,TO_ROOM);
    SET_BIT(ch->pcdata->powers[0], GOLEM_CRYSTAL);
    ch->wait2 += PULSE_VIOLENCE *7;
   WAIT_STATE(ch->fighting, PULSE_VIOLENCE *2);
 }

return;
}

void emerald_convert( CHAR_DATA * ch)
{
 act("#2$n bursts in a bright green light and then as $e dims, $e turns into a bright green rock!#n",
 	ch,0x0,0x0,TO_ROOM);
 act("#2You burst with a bright green light, then you dim and become solidified.#n",
	ch,0x0,0x0,TO_CHAR);
 NO_STONE(ch);
 SET_BIT(ch->pcdata->powers[0], GOLEM_EMERALD);
 ch->wait2 += 5 * PULSE_VIOLENCE;
 return;
}

void emerald_change( CHAR_DATA * ch)
{
 if (IS_SET(ch->pcdata->powers[0], GOLEM_EMERALD))
 {
     if (ch->wait2 > 0) return;
    act("#2$n's green hue fades slowly as he become more vulnerable.#n",
	ch,0x0,0x0,TO_ROOM);
    act("#2Your green hue fades slowly and you become more vulnerable.#n",
	ch,0x0,0x0,TO_CHAR);
     NO_STONE(ch);
     return;
 }
return;
}


void obsidian_convert( CHAR_DATA * ch)
{
 act("$n's body fades..",ch,0x0,0x0,TO_ROOM);
 act("Your body fades..",ch,0x0,0x0,TO_CHAR);
 if (IS_STONE(ch)) {ch->countdown = 1; obsidian_change(ch);} else
 ch->countdown = 10;
 ch->convert_to = GOLEM_OBSIDIAN;

 return;
}



void obsidian_change(CHAR_DATA *ch)
{
 char buf[200];
 if ((!ch->fighting || ch->position != POS_FIGHTING) &&
!IS_SET(ch->pcdata->powers[0], GOLEM_OBSIDIAN))
 {
    ch->countdown = 0;ch->convert_to = 0;
    return;
 }
if (ch->countdown <= 0 && !IS_SET(ch->pcdata->powers[0],GOLEM_OBSIDIAN))
    return;

 if (IS_SET(ch->pcdata->powers[0], GOLEM_OBSIDIAN))
 {
     if (ch->wait2 > 0) return;
     act("$n suddenly appears more visable..",ch,0x0,0x0,TO_ROOM);
     act("Your eyes suddenly make everything appear much brighter..",
	ch,0x0,0x0,TO_CHAR);
     REMOVE_BIT(ch->pcdata->powers[0],GOLEM_OBSIDIAN);
     return;
 }

 if (--ch->countdown > 0)
 {
    sprintf(buf,"#%d$n's body fades away..",ch->countdown);
    act(buf,ch,0x0,0x0,TO_ROOM);
    sprintf(buf,"#%dYour body fades away..",ch->countdown);
    act(buf,ch,0x0,0x0,TO_CHAR);
 }
 else
 {if (IS_STONE(ch)) NO_STONE(ch);
    act("$n's black hands harden and become deadly fists, $m body hardens making him look like a rock.",
	ch,0x0,0x0,TO_ROOM);
    act("Your black hands harden and become deadly fists, your body hardens and you feel invincible.",
	ch,0x0,0x0,TO_CHAR);

    SET_BIT(ch->pcdata->powers[0], GOLEM_OBSIDIAN);
    ch->wait2 += PULSE_VIOLENCE *8;

   WAIT_STATE(ch->fighting, PULSE_VIOLENCE *2);
 }

return;
}

