/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/
 
 #if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "merc.h"

/* I ripped this out of low4 though I don't remember where it originally 
 * came from.  Props to whoever wrote it. Guess what ctc is a macro for?
 * just put the following somewhere in merc.h #define ctc centered_to_char
 * Oh, and it was cent_to_char in low4's comm.c -- I like centered better.
*/
void centered_to_char(char *txt, CHAR_DATA *ch)
{
    int len,pos;
    char buf[MAX_STRING_LENGTH];

    len = (80 - col_str_len(txt)) / 2;
    for (pos = 0; pos < len; pos++)
    {
	buf[pos] = ' ';
    }
    buf[pos]= '\0';
    send_to_char(buf, ch);
    send_to_char(txt, ch);
    send_to_char("\n\r",ch);
}


void do_detox(CHAR_DATA *ch, char *argument) 
{
  if (IS_NPC(ch)) return;
  if (!IS_NPC(ch))
  {
  do_clearstats(ch,"");
  ch->class = 0;
  clearshit(ch);
  ch->paths[PATH_DEAD] = 0;
  ch->paths[PATH_WEREBEAST] = 0;
  ch->paths[PATH_RIGHTEOUS] = 0;
  ch->paths[PATH_FORMLESS]  = 0;
  ch->paths[PATH_MYTHICAL]  = 0;
  ch->paths[PATH_EVIL]      = 0;
  ch->paths[PATH_METAL]     = 0;
  send_to_char("You have detoxified\n\r", ch);
  return;
}
}
void clearshit(CHAR_DATA *ch)
{
  int sn;

  ch->extra                           = 0;
  ch->exp                             = 0;
  ch->practice                          = 0;
  ch->special                         = 0;
  ch->newbits                         = 0;
  ch->newbits2                        = 0;
  ch->elkor			      = 0;
  ch->insanity			      = 0;
  ch->max_hit                         = 5000;
  ch->max_mana                        = 5000;
  ch->max_move                        = 5000;
  ch->hit                         = 5000;
  ch->mana                        = 5000;
  ch->move                        = 5000;
  ch->generation                  = 6;
   ch->pcdata->familiar                = NULL;
   ch->pcdata->chobj                   = NULL;
    ch->pcdata->memorised               = NULL;
   ch->pcdata->smite                    = str_dup( "" );
        ch->pcdata->dragonaff           = 0;/*dragons*/
        ch->pcdata->dragonage           = 0;/*dragons*/
        ch->pcdata->hatch                       = 0;/*dragons*/
    ch->pcdata->breath[0]               = str_dup("");
    ch->pcdata->breath[1]               = str_dup("");
    ch->pcdata->breath[2]               = str_dup("");
    ch->pcdata->breath[3]               = str_dup("");
    ch->pcdata->breath[4]               = str_dup("");
    ch->pcdata->disc_research           = -1;
    ch->lord                            = str_dup( "" );
    ch->morph                           = str_dup( "" );
    ch->pload                           = str_dup( "" );
    ch->poweraction                     = str_dup( "" );
    ch->powertype                       = str_dup( "" );
    ch->hunting                         = str_dup( "" );
    ch->pcdata->followers               = 0;
    ch->spectype                        = 0;
    ch->specpower                       = 0;
    ch->mounted                         = 0;
    ch->home                            = 3001;
    ch->vampgen_a                       = 0;
    ch->paradox[0]                      = 0;    /* Total paradox */
    ch->paradox[1]                      = 0;    /* Current Paradox */
    ch->paradox[2]                      = 0;    /* Paradox Ticker */
    ch->damcap[0]                       = 1000;
    ch->damcap[1]                       = 0;
    ch->vampaff_a                       = 0;
    ch->itemaffect                      = 0;
    ch->vamppass_a                      = -1;
    ch->polyaff                         = 0;
    ch->immune                          = 0;
    ch->race                            = 0;
    ch->form                            = 32767;
    ch->beast                           = 15;
    for( sn=0 ; sn < 13 ; sn ++ )
        ch->loc_hp[sn]                  = 0;
    for( sn=0 ; sn < 15 ; sn++ )
         ch->wpn[sn]                    = 0;
    for( sn=0 ; sn < 11 ; sn++ )
         ch->spl[sn] = 4; 
    for( sn=0 ; sn < 13 ; sn++ )
         ch->cmbt[sn]                   = 0;
    for( sn=0 ; sn < 13 ; sn++ )
         ch->cmbt[sn]                   = 0;
   ch->pcdata->followers               = 0;
    ch->pcdata->perm_str                = 13;
    ch->pcdata->perm_int                = 13;
    ch->pcdata->perm_wis                = 13;
    ch->pcdata->perm_dex                = 13;
    ch->pcdata->perm_con                = 13;
    ch->pcdata->wolf                    = 0;
    ch->pcdata->rank                    = 0;
    ch->pcdata->language[0]             = 0;
    ch->pcdata->language[1]             = 0;
    ch->pcdata->stage[0]                = 0;
    ch->pcdata->stage[1]                = 0;
    ch->pcdata->stage[2]                = 0;
    ch->pcdata->wolfform[0]             = 1;
    ch->pcdata->wolfform[1]             = 1;
    ch->pcdata->score[0]                = 0;
    ch->pcdata->score[1]                = 0;
    ch->pcdata->score[2]                = 0;
    ch->pcdata->score[3]                = 0;
    ch->pcdata->score[4]                = 0;
    ch->pcdata->score[5]                = 0;
    for( sn=0 ; sn < 11 ; sn++ )
         ch->pcdata->disc_a[sn]         = 0;
    for( sn=0 ; sn < 10 ; sn++ )
         ch->pcdata->genes[sn]          = 0;
    for ( sn=0 ; sn < 20 ; sn++)
        ch->pcdata->powers[sn]          = 0;
    for ( sn=0 ; sn < 12 ; sn++)
        ch->pcdata->stats[sn]           = 0;
    for  ( sn=0; sn < 17; sn++)
        ch->stance[sn]                  = 0;
    for  ( sn=17; sn < 24; sn++)
        ch->stance[sn]                  = -1;
    for  ( sn=0; sn < 44; sn++)
        ch->power[sn]                   = -2;
    ch->pcdata->fake_skill              = 0;
    ch->pcdata->fake_stance             = 0;
    ch->pcdata->fake_hit                = 0;
    ch->pcdata->fake_dam                = 0;
    ch->pcdata->fake_ac                 = 0;
    ch->pcdata->fake_hp                 = 0;
    ch->pcdata->fake_mana               = 0;
    ch->pcdata->fake_move               = 0;
    ch->pcdata->obj_vnum                = 0;
    ch->pcdata->condition[COND_THIRST]  = 48;
    ch->pcdata->condition[COND_FULL]    = 48;
    ch->pcdata->stat_ability[STAT_STR]  = 0;
    ch->pcdata->stat_ability[STAT_END]  = 0;
    ch->pcdata->stat_ability[STAT_REF]  = 0;
    ch->pcdata->stat_ability[STAT_FLE]  = 0;
    ch->pcdata->stat_amount[STAT_STR]   = 0;
    ch->pcdata->stat_amount[STAT_END]   = 0;
    ch->pcdata->stat_amount[STAT_REF]   = 0;
    ch->pcdata->stat_amount[STAT_FLE]   = 0;
    ch->pcdata->stat_duration[STAT_STR] = 0;
    ch->pcdata->stat_duration[STAT_END] = 0;
    ch->pcdata->stat_duration[STAT_REF] = 0;
    ch->pcdata->stat_duration[STAT_FLE] = 0;
    ch->pcdata->exhaustion              = 0;
  return;
}

void do_choosepath(CHAR_DATA *ch, char *argument) 
{
char arg[MAX_STRING_LENGTH];
char buf[MAX_STRING_LENGTH];
argument = one_argument( argument, arg );

if (IS_NPC(ch))return;

	if (!IS_NPC(ch) ||
	ch->paths[PATH_DEAD] == 0 ||
	ch->paths[PATH_RIGHTEOUS] == 0 ||
	ch->paths[PATH_FORMLESS] == 0 ||
	ch->paths[PATH_MYTHICAL] == 0 ||
	ch->paths[PATH_EVIL] == 0 ||
	ch->paths[PATH_METAL] == 0)

{ 
if ( arg[0] == '\0' )
{
send_to_char("#GPaths to choose from:#n\n\r", ch);
send_to_char("#oDead, Righteous, Formless, Mythical, Evil, Metal.#n\n\r", ch);
return;
}
if (!str_cmp(arg,"evil")) 
{
if (ch->paths[PATH_EVIL] >= MAX_PATH_EVIL)
{
send_to_char("You already completed that path!\n\r",ch);
return;
}
ch->class = CLASS_DEMON;
set_learnable_disciplines(ch);
sprintf(buf, "#y%s has chosen to follow the path of #LEVIL!#n\n\r",ch->name);
do_info(ch,buf);
}
else if (!str_cmp(arg,"dead")) 
{
if (ch->paths[PATH_DEAD] >= MAX_PATH_DEAD)                                      
{                                                                               
send_to_char("You already completed that path!\n\r",ch);                               
return;                                                                         
}                                                                               
ch->class = CLASS_UNDEAD_KNIGHT; 
sprintf(buf, "#y%s has chosen to follow the path of the #LDEAD!#n\n\r",ch->name); 
do_info(ch,buf);
}
else if (!str_cmp(arg,"metal"))
{
if (ch->paths[PATH_METAL] >= MAX_PATH_METAL)                                      
{                                                                               
send_to_char("You already completed that path!\n\r",ch);                        
return;                                                                         
}                                                                               
ch->class = CLASS_CYBORG;
sprintf(buf, "#y%s has chosen to follow the path of #LMETAL!#n\n\r",ch->name);
do_info(ch,buf);
}
else if (!str_cmp(arg,"formless"))
{
if (ch->paths[PATH_FORMLESS] >= MAX_PATH_FORMLESS)                                      
{                                                                               
send_to_char("You already completed that path!\n\r",ch);                        
return;                                                                         
}                                                                               
ch->class = CLASS_SHAPE;
sprintf(buf, "#y%s has chosen the path of the #LFORMLESS!#n\n\r",ch->name);
do_info(ch,buf);
}
else if (!str_cmp(arg,"righteous"))
{
if (ch->paths[PATH_RIGHTEOUS] >= MAX_PATH_RIGHTEOUS)                                      
{                                                                               
send_to_char("You already completed that path!\n\r",ch);                        
return;                                                                         
}                                                                               
ch->class = CLASS_MONK;
sprintf(buf, "#y%s has chosen the path of the #LRIGHTEOUS!#n\n\r",ch->name);
do_info(ch,buf);
}
else if (!str_cmp(arg,"mythical"))        
{
if (ch->paths[PATH_MYTHICAL] >= MAX_PATH_MYTHICAL)                                      
{                                                                               
send_to_char("You already completed that path!\n\r",ch);                        
return;                                                                         
}                                                                               
ch->class = CLASS_DRAGON;
sprintf(buf,"#y%s has chosen the #LMYTHICAL PATH!#n\n\r",ch->name);
do_info(ch,buf);
}                                                                               
return;
}
}
