/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/


#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include "merc.h"

void do_bet(CHAR_DATA *ch, char *argument)
 {
 char arg[MAX_INPUT_LENGTH]; 
 char buf[MAX_STRING_LENGTH]; 
 int wager; 

 argument = one_argument(argument, arg); 

 if(argument[0] == '\0' || !is_number(arg))
  {
  send_to_char("Syntax: BET [amount]\n\r",ch); 
  return;
  }
  if(ch->pcdata->plr_wager != NULL)
  {
  send_to_char("You have already placed your bet.\n\r",ch);
  return;
  }
 if(!str_prefix("-",arg))
  {
  send_to_char("Error: Invalid argument!\n\r",ch); 
  return; 
  }
 wager   = atoi(arg);
 if(wager > 5000 || wager < 1)
  {
  send_to_char("Bets are only between 1 and 5000qp\n\r",ch);
  return; 
  }
 if(wager > ch->quest)
  {
  send_to_char("You can't bet qp you don't have!\n\r",ch); 
  return; 
  }
  ch->pcdata->plr_wager = wager;
  sprintf(buf,"Okay, you have bet %dqp. Let's play blackjack!\n\r",
        wager);
send_to_char(buf,ch);
return; 
}
