/***************************************************************************
 * This code is the property of Alexis Lee.                                *
 * lxs@innocent.com                                                        *
 * All rights reserved 1998, 1999.                                         *
 * Have fun *=)                                                            *
 *                                                                         *
 ***************************************************************************
 * Some of this code is KaVirs:                                            *
 *                                                                         *
 *  God Wars Mud improvements copyright (C) 1994, 1995, 1996 by Richard    *
 *  Woolcock.  This mud is NOT to be copied in whole or in part, or to be  *
 *  run without the permission of Richard Woolcock.  Nobody else has       *
 *  permission to authorise the use of this code.                          *
 ***************************************************************************
 * Permission for use of this class given to Wolfman. All reworks and fixes*
 * are done with permission as long as the original copyright remains.     *
 * Rework on this version of fae by Wolfman, 2001.			   *
 ***************************************************************************/

#if defined(macintosh) 
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "player.h" 
#include "fae.h"

void do_faepowers( CHAR_DATA *ch, char *argument ) 
{
	if (IS_NPC(ch)) return;
	if (!IS_CLASS(ch, CLASS_FAE))
	{
	send_to_char("Huh?\n\r",ch);
	return;
	}

	send_to_char("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\r", ch);
	send_to_char("                         ~~ Powers of the Dweomerborn ~~\n\r", ch);
	send_to_char("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\r\n\r", ch);
	if (HAS_FPOW(ch, FPOW_FORCE, 1))
		send_to_char("    Force: The power of destruction, through speed and strength.\n\r", ch);
		switch (FPOW(ch, FPOW_FORCE)) {
		default: break;
		case 1: case 2: case 3: case 4: case 5:
			send_to_char("    Force: Twistweave.\n\r", ch); break;
		}
	if (HAS_FPOW(ch, FPOW_LIFEWISH, 1))
		send_to_char(" Lifewish: The primal well of life which replenishes your power.\n\r", ch);
		switch (FPOW(ch, FPOW_LIFEWISH)) {
		default: break;
		case 5:
			send_to_char(" Lifewish: Surge.\n\r", ch); break;
		}
    if (HAS_FPOW(ch, FPOW_TOUGH, 1))
        send_to_char("Toughness: Unnatural resistance to harm.\n\r", ch);
    if (HAS_FPOW(ch, FPOW_DWEOMER, 1))
        switch (FPOW(ch, FPOW_DWEOMER)) {
        default: break;
        case 1: send_to_char("  Dweomer: Incant\n\r", ch); break;
        case 2: send_to_char("  Dweomer: Incant BLADE\n\r", ch); break;
        case 3: send_to_char("  Dweomer: Incant BLADE SHIFT\n\r", ch); break;
        case 4: send_to_char("  Dweomer: Incant BLADE SHIFT WEAVE\n\r", ch); break;
        }
    if (HAS_FPOW(ch, FPOW_BLADE, 1))
        switch (FPOW(ch, FPOW_DWEOMER)) {
        default: break;
	case 1: send_to_char("    Blade: A Faeblade will come to your hand.\n\r", ch);
		break;
	case 2: send_to_char("    Blade: A Faeblade will come to your hand.\n\r", ch);
		send_to_char("         : The blade will give sanctuary from harm.\n\r",ch);
		break;
	case 3: send_to_char("    Blade: A Faeblade will come to your hand.\n\r", ch);
		send_to_char("         : The blade will give sanctuary from harm.\n\r",ch);
		send_to_char("         : Your opponents sight will be obscured.\n\r", ch);
		break;
	case 4: send_to_char("    Blade: A Faeblade will come to your hand.\n\r", ch);
		send_to_char("         : The blade will give sanctuary from harm.\n\r",ch);
		send_to_char("         : Your opponents sight will be obscured.\n\r", ch);
		send_to_char("         : Your weapon gains the ability to shift.\n\r", ch);
		break;
	}
    if (HAS_FPOW(ch, FPOW_SHIFT, 1))
        switch (FPOW(ch, FPOW_SHIFT)) {
        default: break;
        case 1: send_to_char("    Shift: PHOENIX CAT.\n\r", ch);
            break;
        case 2: send_to_char("    Shift: (PHOENIX CAT) Imitate.\n\r", ch);
            break;
        case 3: send_to_char("    Shift: (PHOENIX CAT) Imitate Morph.\n\r", ch);
            break;
        case 4: send_to_char("    Shift: (PHOENIX CAT) Imitate Morph Weaverblade.\n\r", ch);
            break;
        case 5: send_to_char("    Shift: (PHOENIX PANTHER) Imitate Morph Weaverblade Heartgate.\n\r", ch);
            break;
        }
    if (HAS_FPOW(ch, FPOW_WEAVE, 1)) {
        send_to_char("    Weave: Power to experience the hidden, and to become part of it.\n\r", ch);
        switch (FPOW(ch, FPOW_WEAVE)) {
        default: break;
        case 1: send_to_char("         : Hide Intuit.\n\r", ch);
            break;
        case 2: send_to_char("         : (Hide Intuit) Analyse.\n\r", ch);
            break;
        case 3: send_to_char("         : (Hide Intuit) Analyse Sending.\n\r", ch);
            break;
        case 4: send_to_char("         : (Hide Intuit) Analyse Sending Shield.\n\r", ch);
            break;
        case 5: send_to_char("         : (Hide Intuit) Analyse Sending Shield Semblance.\n\r", ch);
            break;
        }
    }
    if (HAS_FPOW(ch, FPOW_PHOENIX, 1))
        switch (FPOW(ch, FPOW_PHOENIX)) {
        default: break;
        case 1: send_to_char("  Phoenix: Shift.\n\r", ch);
            break;
        case 2: send_to_char("  Phoenix: Shift Cast.\n\r", ch);
            break;
        case 3: send_to_char("  Phoenix: Shift Cast Incant.\n\r", ch);
            break;
        case 4: send_to_char("  Phoenix: Shift Cast Incant Die.\n\r", ch);
            break;
        case 5: send_to_char("  Phoenix: Shift Cast Incant Die Supernova.\n\r", ch);
            break;
        }
    if (HAS_FPOW(ch, FPOW_CAT, 1))
        switch (FPOW(ch, FPOW_CAT)) {
        default: break;
        case 1: send_to_char("  Panther: Shift.\n\r", ch);
            break;
        case 2: send_to_char("  Panther: Shift BREATH.\n\r", ch);
            break;
        case 3: send_to_char("  Panther: Shift BREATH Tongues.\n\r", ch);
            break;
        case 4: send_to_char("  Panther: Shift BREATH Tongues Agility.\n\r", ch);
            break;
        case 5: send_to_char("  Panther: Shift BREATH Tongues Agility Wrath.\n\r", ch);
            break;
        }
    if (HAS_FPOW(ch, FPOW_BREATH, 1))
        if (HAS_FPOW(ch, FPOW_BREATH, 1))
			send_to_char("   Breath: BSelect.\n\r", ch);
        switch (FPOW(ch, FPOW_BREATH)) {
        default: break;
        case 1: send_to_char("   Breath: Acid.\n\r", ch);
            break;
        case 2: send_to_char("   Breath: Acid Dark.\n\r", ch);
            break;
        case 3: send_to_char("   Breath: Acid Dark Fire.\n\r", ch);
            break;
        case 4: send_to_char("   Breath: Acid Dark Fire Lightning.\n\r", ch);
            break;
        case 5: send_to_char("   Breath: Acid Dark Fire Lightning Aether.\n\r", ch);
            break;
        }
    if (HAS_FPOW(ch, FPOW_ORION, 1) && IS_FFORM(ch, FFORM_CAT))
        switch (FPOW(ch, FPOW_ORION)) {
		default: send_to_char(" Maturity: You are barely grown, still playful and young.\n\r", ch); break;
		case 1: send_to_char(" Maturity: 4' at the shoulder, and almost as strong as you are proud.\n\r",ch); break;
		case 2: send_to_char(" Maturity: 5' tall, you are stronger than any natural panther.\n\r",ch); break;
		case 3: send_to_char(" Maturity: 6' tall, you are the Lord of the Forest.\n\r", ch); break;
		case 4: send_to_char(" Maturity: At 7', you rule all of Nature.\n\r",ch); break;
		case 5: send_to_char(" Maturity: You stand 8' high, and speak ancient wisdom.\n\r",ch); break;
		case 6: send_to_char(" Maturity: Prophets seek you out as the Voice of Truth.\n\r", ch); break;
		case 7: send_to_char(" Maturity: You stand 10' high, and see the meaning of everything.\n\r",ch); break;
		case 8: send_to_char(" Maturity: Every action is graceful, every word filled with Truth.\n\r", ch); break;
		case 9: send_to_char(" Maturity: Saying nothing, standing still, your wisdom and agility awe the Gods.\n\r",ch); break;
        }
        send_to_char("You have no Fae powers as yet. Check 'dweomer' to see what you can buy.\n\r", ch);

    send_to_char("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\r", ch);
    return;
}

void do_faeshift( CHAR_DATA *ch, char *argument ) {
    OBJ_DATA *obj;			// Used for 2+ different things
    OBJ_DATA *obj_next;
    CHAR_DATA *victim;
    char arg [MAX_INPUT_LENGTH]; 
    char vict [MAX_INPUT_LENGTH]; 
    // char buf [MAX_INPUT_LENGTH]; 
    // char buf2[MAX_INPUT_LENGTH]; 
	AFFECT_DATA *caf;
	int haf, maf, vaf;
	haf = maf = vaf = 0;

    argument = one_argument(argument, arg); 
    argument = one_argument(argument, vict); 

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char("Huh?\n\r",ch);
        return;
    }

    if (!HAS_FPOW(ch, FPOW_SHIFT, 1)) {
        send_to_char("Formshifting is beyond your reach at the moment.\n\r",ch);
        return;
    }

    if (IS_SET(ch->more, MORE_ASHES)) {
        send_to_char("Your Weave is scattered and dead... you must first reincarnate yourself.\n\r", ch);
        return;
    }

	// Attempt some self-fixing
	if (!IS_FFORM(ch, FFORM_GATE) && !IS_FFORM(ch, FFORM_BLADE) &&
	  (ch->pcdata->chobj != NULL || IS_SET(ch->extra, EXTRA_OSWITCH))) {
		if (ch->in_room->vnum == ROOM_VNUM_IN_OBJECT) {
			char_from_room(ch);
			char_to_room(ch, get_room_index(ch->home));
		}
		if ((obj = ch->pcdata->chobj) != NULL) {
			obj->chobj = NULL;
			extract_obj(obj);
		}
		ch->pcdata->obj_vnum = 0;
		ch->pcdata->chobj = NULL;
		REMOVE_BIT(ch->extra, EXTRA_OSWITCH);
	}
	if (IS_FFORM(ch, FFORM_WEAVE) && !IS_SET(ch->affected_by, AFF_ETHEREAL))
		SET_BIT(ch->affected_by, AFF_ETHEREAL);

    if ( arg[0] == '\0' ) {
        send_to_char( "You can shift between the following forms:\n\r  ", ch);
        if (HAS_FPOW(ch, FPOW_CAT, 1))
            send_to_char( "Panther, ", ch);
        send_to_char( "Fae", ch);
        if (HAS_FPOW(ch, FPOW_PHOENIX, 1))
            send_to_char( ", Phoenix", ch);
		if (ch->fighting == NULL) {
			if (HAS_FPOW(ch, FPOW_DWEOMER, 4))
				send_to_char( ", Weave", ch);
			if (HAS_FPOW(ch, FPOW_SHIFT, 4))
				send_to_char( ", Weaverblade", ch);
			if (HAS_FPOW(ch, FPOW_SHIFT, 5))
				send_to_char( ", Heartgate", ch);
			send_to_char( ".\n\r", ch);
		
			if (HAS_FPOW(ch, FPOW_SHIFT, 3))
				send_to_char( "You can also shift your body to resemble anothers with 'shift <name>'.\n\r", ch);
			else if (HAS_FPOW(ch, FPOW_SHIFT, 2))
				send_to_char( "You can also shift your major features to resemble anothers with 'shift <name>'.\n\r", ch);
		}
        return;
    }

	if (strncmp(arg, "fae", 3) && strncmp(arg, "pan", 3) && strncmp(arg, "cat", 3)
	  && strncmp(arg, "pho", 3) && ch->fighting != NULL) {
		send_to_char("Not while fighting!\n\r", ch);
		return;
	}
	if (ch->fighting != NULL && IS_SET(ch->pcdata->fflags, FAE_AUTOCAT) && strncmp(arg, "cat", 3) && strncmp(arg, "pan", 3)) {
		send_to_char("The Hunter rules you for now.\n\r", ch);
		return;
	}

	/*
	if (ch->pcdata->fpow[FPOW_GLAMOUR] > 10) {
		if (strncmp(arg, "fae", 3))
			ch->pcdata->fpow[FPOW_GLAMOUR] -= 10;
	} else {
		send_to_char("The world weighs too heavily on you.\n\r", ch);
		return;
	}
	if (ch->pcdata->fpow[FPOW_GLAMOUR] <= 20)
		send_to_char("Mundanity crushes down on your spirit.\n\r", ch);
	*/

    if (IS_SET(ch->vampaff, VAM_OBFUSCATE)) {
        send_to_char("You fade back into existence.\n\r", ch);
        act("$n forms out of thin air.\n\r", ch, NULL, NULL, TO_ROOM);
        REMOVE_BIT(ch->vampaff, VAM_OBFUSCATE);
    }

    if (!IS_FFORM(ch, FFORM_FAE) && str_cmp(arg, "fae")) {
        do_faeshift(ch, "fae");
    }

    if (!str_cmp(arg, "fae")) {
        if (IS_FFORM(ch, FFORM_FAE)) {
            send_to_char("You're already in your natural form!\n\r", ch);
            return;
        }
		free_string(ch->morph);
		ch->morph = str_dup("");
		REMOVE_BIT(ch->affected_by, AFF_POLYMORPH);

		if (IS_FFORM(ch, FFORM_PHOENIX)) {
            if (!IS_SET(ch->pcdata->fflags, FAE_FIREIMM))
                REMOVE_BIT(ch->immune, IMM_HEAT);
			ch->pcdata->atm = 0;
			haf = 0; maf = 0; vaf = 0;
			caf = ch->affected;
			while (caf) {
				if (caf->type == APPLY_HIT) haf += caf->modifier;
				if (caf->type == APPLY_MANA) maf += caf->modifier;
				if (caf->type == APPLY_MOVE) vaf += caf->modifier;
				caf = caf->next;
			}
			ch->max_hit = ch->pcdata->fae_hmm[0] + haf;
			ch->max_mana = ch->pcdata->fae_hmm[1] + maf;
			ch->max_move = ch->pcdata->fae_hmm[2] + vaf;
			ch->hit = ((ch->pcdata->fae_hmm[0] + haf) * ch->hit) / (ch->pcdata->phoenix_hmm[0] + haf);
			ch->move = ((ch->pcdata->fae_hmm[1] + vaf) * ch->move) / (ch->pcdata->phoenix_hmm[1] + vaf);
			ch->mana = ((ch->pcdata->fae_hmm[2] + maf) * ch->mana) / (ch->pcdata->phoenix_hmm[2] + maf);
			if (ch->hit < 1) ch->hit = 1;
			if (ch->move < 1) ch->move = 1;
			if (ch->mana < 1) ch->mana = 1;
            act("A sharp flash of rainbow light bursts from $n's body as $e reverts to $s natural form.\n\r", ch, NULL, NULL, TO_ROOM);
        } else if (IS_FFORM(ch, FFORM_CAT)) {
			haf = 0; maf = 0; vaf = 0;
			caf = ch->affected;
			while (caf) {
				if (caf->type == APPLY_HIT) haf += caf->modifier;
				if (caf->type == APPLY_MANA) maf += caf->modifier;
				if (caf->type == APPLY_MOVE) vaf += caf->modifier;
				caf = caf->next;
			}
			ch->max_hit = ch->pcdata->fae_hmm[0] + haf;
			ch->max_mana = ch->pcdata->fae_hmm[1] + maf;
			ch->max_move = ch->pcdata->fae_hmm[2] + vaf;
			ch->hit = ((ch->pcdata->fae_hmm[0] + haf) * ch->hit) / (ch->pcdata->cat_hmm[0] + haf);
			ch->move = ((ch->pcdata->fae_hmm[1] + vaf) * ch->move) / (ch->pcdata->cat_hmm[1] + vaf);
			ch->mana = ((ch->pcdata->fae_hmm[2] + maf) * ch->mana) / (ch->pcdata->cat_hmm[2] + maf);
			if (ch->hit < 1) ch->hit = 1;
			if (ch->move < 1) ch->move = 1;
			if (ch->mana < 1) ch->mana = 1;
            act("A sharp flash of rainbow light bursts from $n's body as $e reverts to $s natural form.\n\r", ch, NULL, NULL, TO_ROOM);
        } else if (IS_FFORM(ch, FFORM_WEAVE)) {
            REMOVE_BIT(ch->affected_by, AFF_ETHEREAL);
            act("$n appears in a flash of rainbow light.", ch, NULL, NULL, TO_ROOM);
        } else if (IS_FFORM(ch, FFORM_BLADE)) {
            if (ch->in_room->vnum == ROOM_VNUM_IN_OBJECT) {
                char_from_room(ch);
                char_to_room(ch, get_room_index(ch->home));
            }
            if ((obj = ch->pcdata->chobj) == NULL)
                send_to_char("Blade->fae bugged, ch->pcdata->chobj == NULL", ch);
            obj->chobj = NULL;
            extract_obj(obj);
            ch->pcdata->obj_vnum = 0;
            ch->pcdata->chobj = NULL;
            REMOVE_BIT(ch->extra, EXTRA_OSWITCH);
            act("$n appears in a flash of rainbow light.", ch, NULL, NULL, TO_ROOM);
        } else if (IS_FFORM(ch, FFORM_GATE)) {
            if (ch->in_room->vnum == ROOM_VNUM_IN_OBJECT) {
                char_from_room(ch);
                char_to_room(ch, get_room_index(ch->home));
            }
            if ((obj = ch->pcdata->chobj) == NULL)
                send_to_char("Gate->fae bugged, ch->pcdata->chobj == NULL", ch);
            obj->chobj = NULL;
            extract_obj(obj);
            ch->pcdata->obj_vnum = 0;
            ch->pcdata->chobj = NULL;
            REMOVE_BIT(ch->extra, EXTRA_OSWITCH);
            act("$n appears in a flash of rainbow light.", ch, NULL, NULL, TO_ROOM);
        } else send_to_char( "You're bugged! Please tell an implementor.\n\r", ch);

		ch->pcdata->fform = FFORM_FAE;
        act("Your Weave reverts to its natural pattern in a sharp flash of rainbow light.", ch, NULL, NULL, TO_CHAR);
		for ( obj = ch->carrying; obj != NULL; obj = obj_next ) {
			obj_next = obj->next_content;
			if (obj->wear_loc != WEAR_NONE
			  && !(obj->spectype == SITEM_FAE && obj->item_type == ITEM_WEAPON)) {
				obj_from_char(obj);
				obj_to_char(obj,ch);
			}
		}
    } else if (!strncmp(arg, "pho", 3)) {
        if (!HAS_FPOW(ch, FPOW_PHOENIX, 1)) {
            send_to_char("Your Weave refuses to twist into that form.\n\r", ch);
            return;
        }
        if (IS_FFORM(ch, FFORM_PHOENIX)) {
            send_to_char( "You're already in Phoenix form!\n\r", ch);
            return;
        }
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
        act( "Flames burst from your body as your Weave changes to that of a Phoenix.", ch, NULL, NULL, TO_CHAR );
        act( "Flames burst from $n's body as $e changes into a Phoenix.", ch, NULL, NULL, TO_ROOM );
        ch->pcdata->fform = FFORM_PHOENIX;
        SET_BIT(ch->affected_by, AFF_POLYMORPH);
        free_string( ch->morph );
        ch->morph = str_dup( "a majestic phoenix" );

        if (IS_SET(ch->immune, IMM_HEAT)) SET_BIT(ch->pcdata->fflags, FAE_FIREIMM);
        SET_BIT(ch->immune, IMM_HEAT);
		ch->pcdata->atm = 10* FPOW(ch, FPOW_PHOENIX);
		for ( obj = ch->carrying; obj != NULL; obj = obj_next ) {
			obj_next = obj->next_content;
			if (obj->wear_loc != WEAR_NONE) {
				obj_from_char(obj);
				obj_to_char(obj,ch);
			}
		}
		haf = 0; maf = 0; vaf = 0;
		caf = ch->affected;
		while (caf) {
			if (caf->type == APPLY_HIT) haf += caf->modifier;
			if (caf->type == APPLY_MANA) maf += caf->modifier;
			if (caf->type == APPLY_MOVE) vaf += caf->modifier;
			caf = caf->next;
		}
        ch->max_hit = ch->pcdata->phoenix_hmm[0] + haf;
        ch->max_mana = ch->pcdata->phoenix_hmm[1] + maf;
        ch->max_move = ch->pcdata->phoenix_hmm[2] + vaf;
		ch->hit = ((ch->pcdata->phoenix_hmm[0] + haf) * ch->hit) / (ch->pcdata->fae_hmm[0] + haf);
		ch->move = ((ch->pcdata->phoenix_hmm[1] + vaf) * ch->move) / (ch->pcdata->fae_hmm[1] + vaf);
		ch->mana = ((ch->pcdata->phoenix_hmm[2] + maf) * ch->mana) / (ch->pcdata->fae_hmm[2] + maf);
		if (ch->hit < 1) ch->hit = 1;
		if (ch->move < 1) ch->move = 1;
		if (ch->mana < 1) ch->mana = 1;
    } else if (!strncmp(arg, "pan", 3) || !strncmp(arg, "cat", 3)) {
        if (!HAS_FPOW(ch, FPOW_CAT, 1)) {
            send_to_char("Your Weave refuses to twist into that form.\n\r", ch);
            return;
        }
        if (IS_FFORM(ch, FFORM_CAT)) {
            send_to_char( "You're already in cat form!\n\r", ch);
            return;
        }
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
        act( "Your body bursts outwards in an explosion of growth, as your Weave shifts to that of a panther.", ch, NULL, NULL, TO_CHAR );
        act( "$n's body almost explodes with growth, becoming in moments that of a panther.", ch, NULL, NULL, TO_ROOM );
        ch->pcdata->fform = FFORM_CAT;
        SET_BIT(ch->affected_by, AFF_POLYMORPH);
        free_string( ch->morph );
		switch (FPOW(ch, FPOW_ORION)) {
		default:	ch->morph = str_dup("a Cheshire Cat");	break;
		case 0:	ch->morph = str_dup("a fierce kitten");	break;
		case 1:	ch->morph = str_dup("a strong panther");	break;
		case 2:	ch->morph = str_dup("a huge panther");	break;
		case 3:	ch->morph = str_dup("a fearsome panther");	break;
		case 4:	ch->morph = str_dup("a Gaiato");	break;
		case 5:	ch->morph = str_dup("a learned Gaiato");	break;
		case 6:	ch->morph = str_dup("a Catspeaker");	break;
		case 7:	ch->morph = str_dup("a Streamseer");	break;
		case 8:	ch->morph = str_dup("a Swiftcat");	break;
		case 9:	ch->morph = str_dup("a Taigan");	break;
        }

		for ( obj = ch->carrying; obj != NULL; obj = obj_next ) {
			obj_next = obj->next_content;
			if (obj->wear_loc != WEAR_NONE
			  && !(obj->spectype == SITEM_FAE && obj->item_type == ITEM_WEAPON)) {
				obj_from_char(obj);
				obj_from_char(obj);
				obj_to_char(obj,ch);
			}
		}
		haf = 0; maf = 0; vaf = 0;
		caf = ch->affected;
		while (caf) {
			if (caf->type == APPLY_HIT) haf += caf->modifier;
			if (caf->type == APPLY_MANA) maf += caf->modifier;
			if (caf->type == APPLY_MOVE) vaf += caf->modifier;
			caf = caf->next;
		}
        ch->max_hit = ch->pcdata->cat_hmm[0] + haf;
        ch->max_mana = ch->pcdata->cat_hmm[1] + maf;
        ch->max_move = ch->pcdata->cat_hmm[2] + vaf;
		ch->hit = ((ch->pcdata->cat_hmm[0] + haf) * ch->hit) / (ch->pcdata->fae_hmm[0] + haf);
		ch->move = ((ch->pcdata->cat_hmm[1] + vaf) * ch->move) / (ch->pcdata->fae_hmm[1] + vaf);
		ch->mana = ((ch->pcdata->cat_hmm[2] + maf) * ch->mana) / (ch->pcdata->fae_hmm[2] + maf);
		if (ch->hit < 1) ch->hit = 1;
		if (ch->move < 1) ch->move = 1;
		if (ch->mana < 1) ch->mana = 1;
    } else if (!strncmp(arg, "weaverb", 7) || !strncmp(arg, "bla", 3)) {
        if (!HAS_FPOW(ch, FPOW_SHIFT, 4)) {
            send_to_char( "Turning into a Weaverblade is beyond your mastery of the Dweomergift.\n\r", ch);
            return;
        }
        if (IS_FFORM(ch, FFORM_BLADE)) {
            send_to_char( "You're already in Weaverblade form!\n\r", ch);
            return;
        }
        if (IS_AFFECTED(ch,AFF_WEBBED)) {
            send_to_char( "The webbing holds your Weave, preventing you from shifting.\n\r", ch);
            return;
        }
        act("Your Weave slowly shifts until you are no longer a Fae, but a Weaverblade.",ch,NULL,NULL,TO_CHAR);
        act("$n's body subtly shifts, until you realise that not a Fae, but a Weaverblade is standing before you.",ch,NULL,NULL,TO_ROOM);
        obj = create_object(get_obj_index(29550),60);
        obj_to_room(obj,ch->in_room);
        ch->pcdata->obj_vnum = 29550;
        obj->chobj = ch;
        ch->pcdata->chobj = obj;
        ch->pcdata->fform = FFORM_BLADE;
        SET_BIT(ch->affected_by, AFF_POLYMORPH);
        SET_BIT(ch->extra, EXTRA_OSWITCH);
        free_string(ch->morph);
        // ch->morph = str_dup("a Weaverblade");
        ch->morph = str_dup(obj->short_descr);
        return;
    } else if (!strncmp(arg, "hea", 3) || !strncmp(arg, "gat", 3)) {
        if (!HAS_FPOW(ch, FPOW_SHIFT, 5)) {
            send_to_char("Your Weave would be ripped apart should you even attempt such a feat!\n\r", ch);
            return;
        }
        if (IS_FFORM(ch, FFORM_GATE)) {
            send_to_char( "You're already a Heartgate!\n\r", ch);
            return;
        }
        send_to_char("You concentrate, and grow, larger and larger, limbs and head soaking into your body as your chest melts in two, allowing passage through your heart.\n\r", ch);
        act("$n's sings a quiet chord, and $e explodes with growth, $s limbs and head soaking into $s body as $s chest melts in two, allowing passage through $s heart.",ch,NULL,NULL,TO_ROOM);
        obj = create_object(get_obj_index(29551), 60);
        obj_to_room(obj,ch->in_room);

		/*
        if ((victim = get_char_world(ch, vict)) == NULL
          || victim == ch 
          || victim->in_room == NULL
          || ch->in_room == NULL) {
            send_to_char("You sense something awry within you.\n\r", ch);
            obj->value[0] = ch->in_room->vnum;
        } else if ( IS_SET(victim->in_room->room_flags, ROOM_SOLITARY)
          || IS_SET(victim->in_room->room_flags, ROOM_NO_RECALL)
          || !IS_IMMUNE(victim, IMM_SUMMON)) {
            send_to_char("You sense something awry within you.\n\r", ch);
            obj->value[0] = ch->in_room->vnum;
            if (!IS_NPC(victim) && ch != victim && IS_MORE(victim, MORE_GUARDIAN)) {
                guardian_message( victim );
                act("$n just failed to open $s heart here.",ch,NULL,victim,TO_VICT);
            }
        } else
            obj->value[0] = victim->in_room->vnum;
		*/

        victim = get_char_world(ch, vict);
		switch (check_moveto_mob(ch, victim)) {
		case 0:
            obj->value[0] = victim->in_room->vnum;
			break;
		case 2:
			guardian_message(victim);
			act("$n just failed to open $s heart here.",ch,NULL,victim,TO_VICT);
			// Drop thru
		case 1:
            send_to_char("You sense something awry within you.\n\r", ch);
            obj->value[0] = ch->in_room->vnum;
			break;
		}
        obj->value[3] = ch->in_room->vnum;

        ch->pcdata->obj_vnum = 29551;
        obj->chobj = ch;
        ch->pcdata->chobj = obj;
        ch->pcdata->fform = FFORM_GATE;
        SET_BIT(ch->affected_by, AFF_POLYMORPH);
        SET_BIT(ch->extra, EXTRA_OSWITCH);
        free_string(ch->morph);
        ch->morph = str_dup(obj->short_descr);

/* Too much of a headfuck- need to hold a pointer to opposite gate in pfile
   And WTF happens if they quit as Gate... I'd have to reload opposite object
   So, Heartgate only exists on one side at once
        if (obj->value[0] != ch->in_room->vnum) {
            obj = create_object(get_obj_index(29551), 60);
            obj_to_room(obj, ch->pcdata->chobj->value[0]);
            obj->value[0] = ch->pcdata->chobj->value[3];
            obj->value[3] = obj->in_room->vnum;
        }
*/
        return;
    } else if (!strncmp(arg, "wea", 3)) {
        if (!HAS_FPOW(ch, FPOW_DWEOMER, 4)) {
            send_to_char("Your Weave refuses to twist into that form.\n\r", ch);
            return;
        }
        if (IS_FFORM(ch, FFORM_WEAVE)) {
            send_to_char( "You're already part of the Weave!\n\r", ch);
            return;
        }
        if (ch->stance[0] != -1) do_stance(ch,"");
        if (ch->mounted == IS_RIDING) do_dismount(ch,"");
        act( "You merge into the Weave.", ch, NULL, NULL, TO_CHAR );
        act( "$n slowly vanishes.", ch, NULL, NULL, TO_ROOM );
        if (IS_EXTRA(ch, TIED_UP)) {
            act("The ropes binding you disintegrate, unable to handle the change.",ch,NULL,NULL,TO_CHAR);
            act("The ropes that bound $n fall to dust.",ch,NULL,NULL,TO_ROOM);
            REMOVE_BIT(ch->extra, TIED_UP);
            REMOVE_BIT(ch->extra, GAGGED);
            REMOVE_BIT(ch->extra, BLINDFOLDED);
        }
        if (is_affected(ch, gsn_web)) {
            send_to_char("The webbing vaporises, leaving a tang of tin in the air.\n\r",ch);
            act("The webbing which entrapped $n vaporises, leaving only the tang of tin floating in the air.",ch,NULL,NULL,TO_ROOM);
            affect_strip(ch, gsn_web);
        }
        ch->pcdata->fform = FFORM_WEAVE;
        SET_BIT(ch->affected_by, AFF_POLYMORPH);
        SET_BIT(ch->affected_by, AFF_ETHEREAL);
        free_string( ch->morph );
        ch->morph = str_dup( "a patch of Weave" );
        return;
    } else {
        send_to_char("Imitate and Morph uncoded.\n\r", ch);
        do_faeshift(ch, "");
/*
        if ( strlen(arg) > 20 ) {
            send_to_char( "Name too long- 20 characters or less.\n\r", ch);
            return;
        }

        if ( str_cmp(arg,"self") && !check_parse_name( arg ) ) {
            send_to_char( "Illegal name.\n\r", ch );
            return;
        }

        if (is_in(arg,"|alexis*sunbirn*levi*leviathan*chojin*lxs*aleister*")) {
            send_to_char( "Illegal name.\n\r", ch );
            return;
        }

        if (!IS_FFORM(ch, FFORM_FAE)) {
            send_to_char( "Your Weave is already shifted.\n\r", ch );
            return;
        }

        if ( !str_cmp(arg,ch->name) || !str_cmp(arg,"self") ) {
            if (!IS_SET(ch->pcdata->fflags, FAE_MASK)) {
                send_to_char( "You already look like yourself!\n\r", ch );
                return;
            }
            sprintf(buf,"$n's features slowly shift back to normal.");
            act(buf,ch,NULL,NULL,TO_ROOM);
            REMOVE_BIT(ch->pcdata->fflags, FAE_MASK);
            free_string( ch->morph );
            ch->morph = str_dup( "" );
            send_to_char("Your features slowly shift back to normal.\n\r", ch);
            return;
        }
        strcpy(arg, capitalize(arg));
        sprintf(buf,"Your features slowly shift into those of %s.", arg);
        send_to_char(buf,ch);
        sprintf(buf,"$n's features slowly shift into those of %s.", arg);
        act(buf,ch,NULL,NULL,TO_ROOM);
        if (!IS_SET(ch->pcdata->fflags, FAE_MASK))
            SET_BIT(ch->pcdata->fflags, FAE_MASK);
        free_string( ch->morph );
        ch->morph = str_dup( arg );
        return;
*/
    }

    return; // Just in case
}

void do_dweomer( CHAR_DATA *ch, char *argument ) {
    char arg [MAX_INPUT_LENGTH];
    char buf [MAX_STRING_LENGTH];
    char buf2 [MAX_STRING_LENGTH];
    int cost = 0;
    int max = 5;
    int sn = -1;
    argument = one_argument( argument, arg );

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char( "Huh?\n\r", ch );
        return;
    }

    if ( arg[0] == '\0' ) {
        send_to_char( "-------------------------------------------------------------------------------\n\r", ch);
        send_to_char( "                           Powers of the Dweomerborn\n\r", ch);
        send_to_char( "-------------------------------------------------------------------------------\n\r", ch);
        sprintf( buf, "   Lifewish : %d,  Force : %d,  Toughness : %d,  DWEOMER : %d.\n\r", FPOW(ch, FPOW_LIFEWISH), FPOW(ch, FPOW_FORCE), FPOW(ch, FPOW_TOUGH), FPOW(ch, FPOW_DWEOMER));
        send_to_char( buf, ch);

        sprintf( buf, "   ");
        if (HAS_FPOW(ch, FPOW_DWEOMER, 2)) {
            sprintf( buf2, "Faeblade : %d", FPOW(ch, FPOW_BLADE));
            strcat(buf, buf2);
            if (HAS_FPOW(ch, FPOW_DWEOMER, 3)) {
                sprintf( buf2, ",  SHIFT : %d", FPOW(ch, FPOW_SHIFT));
                strcat(buf, buf2);
            }
            if (HAS_FPOW(ch, FPOW_DWEOMER, 4)) {
                sprintf( buf2, ",  Weave : %d", FPOW(ch, FPOW_WEAVE));
                strcat(buf, buf2);
            }
            strcat(buf, ".\n\r");
            send_to_char( buf, ch);
        }

        if (HAS_FPOW(ch, FPOW_SHIFT, 1)) {
            sprintf( buf, "   Phoenix : %d,  Panther : %d.\n\r", FPOW(ch, FPOW_PHOENIX), FPOW(ch, FPOW_CAT));
            send_to_char( buf, ch);
        }

        if (HAS_FPOW(ch, FPOW_CAT, 2)) {
            sprintf( buf, "   Breath : %d.\n\r", FPOW(ch, FPOW_BREATH));
            send_to_char( buf, ch);
        }
        send_to_char( "-------------------------------------------------------------------------------\n\r", ch);
        return;
    } 

         if (!strncmp(arg,"lif",3))  sn = FPOW_LIFEWISH;
    else if (!strncmp(arg,"for",3))  sn = FPOW_FORCE;
    else if (!strncmp(arg,"tou",3))  sn = FPOW_TOUGH;
    else if (!strncmp(arg,"dwe",3))  sn = FPOW_DWEOMER;
    else if (!strncmp(arg,"bla",3))  sn = FPOW_BLADE;
    else if (!strncmp(arg,"faeb",4)) sn = FPOW_BLADE;
    else if (!strncmp(arg,"shi",3))  sn = FPOW_SHIFT;
    else if (!strncmp(arg,"wea",3))  sn = FPOW_WEAVE;
    else if (!strncmp(arg,"pho",3))  sn = FPOW_PHOENIX;
    else if (!strncmp(arg,"pan",3))  sn = FPOW_CAT;
    else if (!strncmp(arg,"cat",3))  sn = FPOW_CAT;
    else if (!strncmp(arg,"bre",3))  sn = FPOW_BREATH;
    else if (!strcmp(arg,"xyzzy")) {
        int i;

        for (i = 0; i < 15; i++)
            ch->pcdata->fpow[i] = 5;
        ch->pcdata->fpow[FPOW_DWEOMER] = 4;
        ch->pcdata->fpow[FPOW_ORION] = 9;
        send_to_char("The Dweomer surges through you!\n\r", ch);
        return;
    } else {
        send_to_char( "Type 'dweomer' and select a part of the Dweomergift from those listed.\n\r", ch);
        return;
    }

/*
    if (IS_RANK(ch, RANK_MUNDANE) && sn > FPOW_DWEOMER) {
        send_to_char("You are yet too young for such power.\n\r", ch);
        send_to_char("(Complete the first level of powers)\n\r", ch);
        return;
    }
*/
    if (IS_RANK(ch, RANK_PATH) && (sn > FPOW_DWEOMER || HAS_FPOW(ch, sn, 3))) {
        send_to_char("You must fully embrace the Dweomer before your Weave can withstand such power.\n\r", ch);
        return;
    }

	cost = 12 * (FPOW(ch, sn) + 1);

    if (sn == FPOW_DWEOMER) max = 4;
    else max = 5;

    if (((sn >= FPOW_SHIFT) && (!HAS_FPOW(ch, FPOW_DWEOMER, 3)))
      || ((sn == FPOW_WEAVE) && (!HAS_FPOW(ch, FPOW_DWEOMER, 4)))
      || ((sn >= FPOW_PHOENIX) && (!HAS_FPOW(ch, FPOW_SHIFT, 1)))
      || ((sn >= FPOW_BREATH) && (!HAS_FPOW(ch, FPOW_CAT, 2)))) {
        send_to_char( "That part of the Dweomergift is beyond your reach, as yet.\n\r", ch);
        send_to_char( "The parts of the Dweomergift listed in capitals must be mastered to some degree before the next level of mastery can be approached.\n\r", ch);
        return;
    }
    if (FPOW(ch, sn) >= max) {
        send_to_char( "You have mastered that part of the Dweomergift.\n\r", ch);
        return;
    }
    if (ch->practice < cost) {
        sprintf(buf, "It will cost %d points of primal energy to raise that ability.\n\r", cost);
        send_to_char( buf, ch);
        return;
    }

    send_to_char( "You feel the air sing as you embrace more of the Dweomergift.\n\r", ch);
    ch->practice -= cost;
    ch->pcdata->fpow[sn]++;
    if (sn == FPOW_PHOENIX && FPOW(ch, sn) == 4) {
        if (IS_FFORM(ch, FFORM_PHOENIX))
            ch->max_hit += 2000;
        ch->pcdata->phoenix_hmm[1] += 2000;
    }
    if (sn == FPOW_PHOENIX && FPOW(ch, sn) == 5) {
        if (IS_FFORM(ch, FFORM_PHOENIX))
            ch->max_hit += 1000;
        ch->pcdata->phoenix_hmm[1] += 1000;
    }
    if (sn == FPOW_CAT && FPOW(ch, sn) == 4) {
        if (IS_FFORM(ch, FFORM_CAT))
            ch->max_hit += 2000;
        ch->pcdata->cat_hmm[0] += 2000;
    }
    if (sn == FPOW_CAT && FPOW(ch, sn) == 5) {
        if (IS_FFORM(ch, FFORM_CAT))
            ch->max_hit += 1000;
        ch->pcdata->cat_hmm[0] += 1000;
    }
    return;
}

void do_instill( CHAR_DATA *ch, char *argument ) {
    CHAR_DATA *victim;
    char      arg [MAX_INPUT_LENGTH];
    int i;

    argument = one_argument( argument, arg );

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char("Huh?\n\r",ch);
        return;
    }
    if (!HAS_RANK(ch, RANK_PRINCE)) {
        send_to_char( "The Dweomergift is not for you to grant!\n\r", ch);
        return;
    }

    if ( arg[0] == '\0' ) {
        send_to_char( "Instill the Dweomer in whom?\n\r", ch );
        return;
    }
    if ( ( victim = get_char_room( ch, arg ) ) == NULL ) {
        send_to_char( "They aren't here.\n\r", ch );
        return;
    }

    if (   IS_NPC(victim)
        || victim->level < 3
        || IS_VAMPIRE(victim)
        || IS_WEREWOLF(victim)
        || IS_DEMON(victim)
        || IS_HIGHLANDER(victim)
    ) {
        send_to_char( "They are unsuitable for the Dweomer.\n\r", ch );
        return;
    }
    if (ch == victim || IS_FAE(victim)) {
        send_to_char( "Don't be silly!\n\r", ch );
        return;
    }

    if (!IS_IMMUNE(victim,IMM_VAMPIRE)) {
        send_to_char( "The Dweomer will not enter the unwilling.\n\r", ch);
        return;
    }
#ifdef CHECKREQ
	if (!check_reqs(ch, victim, 0)) {
		send_to_char("They do not meet the requirements for entry.\n\r", ch);
		return;
	}
#endif
    act("A rainbow glow passes between you and $N, and you sense the Dweomer inside them.", ch, NULL, victim, TO_CHAR);
    act("A rainbow glow passes between $n and $N.", ch, NULL, victim, TO_NOTVICT);
    act("A rainbow glow passes between you and $n, and you sense the Dweomer flow into you.", ch, NULL, victim, TO_VICT);
    free_string(victim->lord);
    victim->lord = str_dup(ch->name);
    victim->clan = str_dup(ch->clan);
    victim->class = CLASS_FAE;
    victim->pcdata->xrank = RANK_MUNDANE;
    for (i = 0; i < 19; i++)
        victim->pcdata->fpow[i] = 0;
    victim->pcdata->fflags = 0;
    victim->pcdata->fae_hmm[0] = victim->max_hit;
    victim->pcdata->fae_hmm[1] = victim->max_mana;
    victim->pcdata->fae_hmm[2] = victim->max_move;
    victim->pcdata->phoenix_hmm[0] = 2000;
    victim->pcdata->phoenix_hmm[1] = 2000;
    victim->pcdata->phoenix_hmm[2] = 1000;
    victim->pcdata->cat_hmm[0] = 2000;
    victim->pcdata->cat_hmm[1] = 1000;
    victim->pcdata->cat_hmm[2] = 2000;
    save_char_obj(victim);
    return;
}

void do_twistweave( CHAR_DATA *ch, char *argument ) {
    char arg [MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    int dam;
    int stance;

    one_argument( argument, arg );

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char( "Huh?\n\r", ch );
        return;
    }

    if (!HAS_FPOW(ch, FPOW_FORCE, 1)) {
        send_to_char("You cannot twist someone's Weave yet.\n\r", ch);
        return;
    }

    if (IS_ITEMAFF(ch, ITEMA_PEACE)) do_majesty(ch,"");

    if (arg[0] == '\0' && ch->fighting == NULL) {
        send_to_char("Whose Weave do you wish to twist?\n\r",ch);
        return;
    }

    if ((victim = ch->fighting) == NULL) {
        if ((victim = get_char_room(ch, arg)) == NULL) {
            send_to_char("They aren't here.\n\r", ch);
            return;
        }
    }

    if (is_safe(ch,victim)) {
        if (!IS_NPC(victim) && ch != victim && IS_MORE(victim, MORE_GUARDIAN)) {
            guardian_message( victim );
            act("$n just tried to twist your Weave.",ch,NULL,victim,TO_VICT);
        }
        return;
    }

	if (strcmp(arg, "xyzzy"))
		WAIT_STATE(ch, 6);

    dam = number_range(FPOW(ch, FPOW_FORCE)*30, FPOW(ch, FPOW_FORCE)*70);
    dam += (char_damroll(ch)/4);

    if (!IS_AWAKE(victim)) dam *= 2;
    stance = ch->stance[0];
    if ( IS_STANCE(ch, STANCE_NORMAL) ) dam *= 1.25;
    else dam += dambonus(ch,victim,dam,stance);
    if ( dam <= 0 )
        dam = 1;

    send_to_char("You scream in agony as your very soul seems to be torn apart!\n\r",victim);
    act("$n clutches $s chest and screams in agony!",victim,NULL,NULL,TO_ROOM);

    if (!IS_NPC(victim) && ch != victim && IS_MORE(victim, MORE_GUARDIAN)) {
        guardian_message( victim );
        act("$n just twisted your Weave!",ch,NULL,victim,TO_VICT);
    }

    damage(ch, victim, dam, gsn_ftwist);
    return;
}

void do_hidefae( CHAR_DATA *ch, char *argument ) {
    char arg [MAX_INPUT_LENGTH];

    argument = one_argument( argument, arg );

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char( "Huh?\n\r", ch );
        return;
    }

    if (!HAS_FPOW(ch, FPOW_WEAVE, 1)) {
        send_to_char("Your step still weighs too heavily on the Weave.\n\r", ch);
        return;
    }

    SET_BIT(ch->vampaff, VAM_OBFUSCATE);
    act("You fade away into thin air.", ch, NULL, NULL, TO_CHAR);
    act("A look of concentration crosses $n's face.", ch, NULL, NULL, TO_ROOM);
    act("$n disappears.", ch, NULL, NULL, TO_ROOM);
    
	WAIT_STATE(ch, 11 - FPOW(ch, FPOW_WEAVE));
    return;
}

void do_intuit( CHAR_DATA *ch, char *argument ) {
    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char("Huh?\n\r", ch);
        return;
    }
    if (!HAS_FPOW(ch, FPOW_WEAVE, 1)) {
        send_to_char("The Weave is merely chaos to you; you can see nothing in it.\n\r", ch);
        return;
    }

    if ( IS_SET(ch->act, PLR_HOLYLIGHT) ) {
        REMOVE_BIT(ch->more, MORE_GUARDIAN);
        REMOVE_BIT(ch->act, PLR_HOLYLIGHT);
        send_to_char("You concentrate, and eventually manage to ignore the chaotic chatter of the Weave.\n\r", ch);
    } else {
        SET_BIT(ch->more, MORE_GUARDIAN);
        SET_BIT(ch->act, PLR_HOLYLIGHT);
        send_to_char("You open your mind to the Weave, and sensation floods in.\n\r", ch);
    }
    return;
}

void do_analyse( CHAR_DATA *ch, char *argument ) {
    CHAR_DATA *victim;
    OBJ_DATA  *obj;
    char      arg [MAX_INPUT_LENGTH];
    char      buf [MAX_INPUT_LENGTH];
    char      buf2 [MAX_INPUT_LENGTH];
    int       con_hit, con_dam, con_ac, con_hp, con_mana, con_move;
    int       con_str, con_int, con_dex, con_wis, con_con;
    int       con_max_hp, con_max_mana, con_max_move;

    argument = one_argument( argument, arg );

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char("Huh?\n\r", ch);
        return;
    }
    if (!HAS_FPOW(ch, FPOW_WEAVE, 2)) {
        send_to_char("Analysing the Weave requires a more profound understanding than you possess.\n\r", ch);
        return;
    }

    if ( arg[0] == '\0' ) {
        send_to_char( "Analyse what?\n\r", ch );
        return;
    }

    if ((victim = get_char_room(ch, arg)) == NULL) {
        if ((obj = get_obj_carry(ch, arg)) == NULL) {
            send_to_char( "Analyse what?\n\r", ch );
            return;
        }
        spell_identify( skill_lookup( "identify" ), ch->level, ch, obj );
        return;
    }

    sprintf(buf2,"$n gazes into the distance, straight through %s.", victim->name);
	act(buf2, ch, NULL, victim, TO_NOTVICT);
    act("$n gazes into the distance, straight through you. Most unnerving.", ch, NULL, victim, TO_VICT);

    if (!IS_NPC(victim) && IS_EXTRA(victim, EXTRA_FAKE_CON)) {
        con_hit = victim->pcdata->fake_hit;
        con_dam = victim->pcdata->fake_dam;
        con_ac = victim->pcdata->fake_ac;
        con_str = victim->pcdata->fake_stats[STAT_STR];
        con_int = victim->pcdata->fake_stats[STAT_INT];
        con_wis = victim->pcdata->fake_stats[STAT_WIS];
        con_dex = victim->pcdata->fake_stats[STAT_DEX];
        con_con = victim->pcdata->fake_stats[STAT_CON];
        con_hp = victim->pcdata->fake_hp;
        con_mana = victim->pcdata->fake_mana;
        con_move = victim->pcdata->fake_move;
        con_max_hp = victim->pcdata->fake_max_hp;
        con_max_mana = victim->pcdata->fake_max_mana;
        con_max_move = victim->pcdata->fake_max_move;
    } else {
        con_hit = char_hitroll(victim);
        con_dam = char_damroll(victim);
        con_ac = char_ac(victim);
        con_str = get_curr_str(victim);
        con_int = get_curr_int(victim);
        con_wis = get_curr_wis(victim);
        con_dex = get_curr_dex(victim);
        con_con = get_curr_con(victim);
        con_hp = victim->hit;
        con_mana = victim->mana;
        con_move = victim->move;
        con_max_hp = victim->max_hit;
        con_max_mana = victim->max_mana;
        con_max_move = victim->max_move;
    }

    if (IS_NPC(victim)) sprintf(buf, "%s is an NPC.\n\r",victim->short_descr);
    else {
        if      (victim->level == 12)
            sprintf(buf, "%s is an Implementor.\n\r", victim->name);
        else if (victim->level == 11)
            sprintf(buf, "%s is a High Judge.\n\r", victim->name);
        else if (victim->level == 10)
            sprintf(buf, "%s is a Judge.\n\r", victim->name);
        else if (victim->level == 9 )
            sprintf(buf, "%s is an Enforcer.\n\r", victim->name);
        else if (victim->level == 8 )
            sprintf(buf, "%s is a Quest Maker.\n\r", victim->name);
        else if (victim->level == 7 )
            sprintf(buf, "%s is a Builder.\n\r", victim->name);
        else if (victim->level >= 3 )
            sprintf(buf, "%s is an Avatar.\n\r", victim->name);
        else sprintf(buf, "%s is a Mortal.\n\r", victim->name);
    }
    send_to_char(buf,ch);

    sprintf( buf, "Str: %d.  Int: %d.  Wis: %d.  Dex: %d.  Con: %d.\n\r",
    con_str, con_int, con_wis, con_dex, con_con);
    send_to_char( buf, ch );

    sprintf(buf,"Hp: %d/%d, Mana: %d/%d, Vitality: %d/%d.\n\r",
        con_hp, con_max_hp, con_mana, con_max_mana, con_move, con_max_move);
    send_to_char(buf,ch);

    sprintf(buf,"Hitroll: %d, Damroll: %d, AC: %d.\n\r", 
        con_hit, con_dam, con_ac);
    send_to_char(buf,ch);

    if (!IS_NPC(victim)) {
        sprintf(buf,"Status: %d, ",victim->race);
        send_to_char(buf,ch);
    }

    sprintf(buf,"Alignment: %d.\n\r",victim->alignment);
    send_to_char(buf,ch);

    if (!IS_NPC(victim) && IS_EXTRA(victim, EXTRA_PREGNANT))
        act("$N is pregnant.",ch,NULL,victim,TO_CHAR);
    if (!IS_NPC(victim) && IS_VAMPIRE(victim) && victim->pcdata->diableries[DIAB_EVER] >= 5)
    act("$N's Weave is permanently warped by multiple diablerie.",ch,NULL,victim,TO_CHAR);
    else if (!IS_NPC(victim) && IS_VAMPIRE(victim) && victim->pcdata->diableries[DIAB_TIME] > 0)
    act("$N has recently committed diablerie.",ch,NULL,victim,TO_CHAR);
    if (!IS_NPC(victim) && IS_MORE(victim, MORE_INFORM))
    {
    if (ch->pcdata->lie == LIE_TRUE)
        act("$N has recently lied.",ch,NULL,victim,TO_CHAR);
    else
        act("$N has recently spoken truthfully.",ch,NULL,victim,TO_CHAR);
    }
    if (!IS_NPC(victim) && ch != victim && IS_MORE(victim, MORE_GUARDIAN)) {
        guardian_message( victim );
        act("$n just analysed your essence.",ch,NULL,victim,TO_VICT);
    }
    return;
}

void do_sending(CHAR_DATA *ch, char *argument) {
    CHAR_DATA *victim;
    CHAR_DATA *familiar;

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char("Huh?\n\r", ch);
        return;
    }

    if (!HAS_FPOW(ch, FPOW_WEAVE, 3)) {
        send_to_char("A Sending is beyond your skill, for now.\n\r", ch);
        return;
    }

    if ((familiar = ch->pcdata->familiar) != NULL) {
        extract_char(familiar, TRUE);
        send_to_char("Your Sending vanishes.\n\r", ch);
        REMOVE_BIT(ch->more, MORE_PROJECTION);
        return;
    }

    if (ch->pcdata->followers > 4) {
        send_to_char("Nothing happens.\n\r",ch);
        return;
    }

    ch->pcdata->followers++;
    victim = create_mobile( get_mob_index( MOB_VNUM_ASTRAL ) );
    free_string(victim->lord);
    victim->lord = str_dup(ch->name);
    victim->level = 50;
    victim->hit = ch->hit;
    victim->max_hit = ch->max_hit;
    victim->mana = ch->mana;
    victim->max_mana = ch->max_mana;
    victim->move = ch->move;
    victim->max_move = ch->max_move;
    victim->hitroll = char_hitroll(ch);
    victim->damroll = char_damroll(ch);
    victim->armor = char_ac(ch);

    free_string(victim->name);
    victim->name = str_dup("sending");
    free_string(victim->short_descr);
    victim->short_descr = str_dup("a Sending");
    free_string(victim->long_descr);
    victim->long_descr = str_dup("You feel a Sending is present.\n\r");
    char_to_room(victim,ch->in_room);

    send_to_char("You shape a Sending out of the Weave.\n\r",ch);
    act("$n gazes into the far distance and traces $s hands over $s body.", ch,NULL,NULL,TO_ROOM);
    ch->pcdata->familiar = victim;
    victim->wizard = ch;
    SET_BIT(victim->more, MORE_SPIRIT);
    SET_BIT(victim->vampaff, VAM_SPIRITEYES);
    SET_BIT(ch->more, MORE_PROJECTION);
    return;
}

void do_gate( CHAR_DATA *ch, char *argument ) {
    OBJ_DATA *obj;
    ROOM_INDEX_DATA *room;
    CHAR_DATA *victim;
    char arg [MAX_INPUT_LENGTH];
    int v;

    argument = one_argument( argument, arg );

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char("Huh?\n\r", ch);
        return;
    }

    if (!IS_FFORM(ch, FFORM_GATE)) {
        send_to_char("Only a Heartgate can accomplish this.\n\r", ch);
        return;
    }

    obj = ch->pcdata->chobj;
    if (arg[0] == '\0') {
        send_to_char("You blast out of existence, consumed by a sheet of Aether.\n\r", ch);
        act("$n blasts out of existence, consumed by a sheet of Aether.", ch, NULL, NULL, TO_ROOM);
        obj_from_room(obj);
        if ((room = get_room_index(obj->value[0])) == NULL) {
            send_to_char("Bug. v[0] returned NULL.\n\r", ch);
            return;
        }
        obj_to_room(obj, room);
        send_to_char("The Weave sings as it reforms behind you.\n\r", ch);
        act("Two pillars of Aether rise out of the ground, seeming to sing as $n forms.", ch, NULL, NULL, TO_ROOM);
        v = obj->value[0];
        obj->value[0] = obj->value[3];
        obj->value[3] = v;
        return;
    }

    if ((victim = get_char_world(ch, arg)) == NULL
      || victim == ch 
      || victim->in_room == NULL
      || ch->in_room == NULL) {
        send_to_char("You concentrate, trying to refocus your heartbeat, but it refuses to settle.\n\r", ch);
        act("$n shudders violently for a moment.", ch, NULL, NULL, TO_ROOM);
        // obj->value[0] = ch->in_room->vnum;
    } else if ( IS_SET(victim->in_room->room_flags, ROOM_SOLITARY)
      || IS_SET(victim->in_room->room_flags, ROOM_NO_RECALL)
      || (!IS_NPC(victim) && !IS_IMMUNE(victim, IMM_SUMMON) ) ) {
        send_to_char("You concentrate, trying to refocus your heartbeat, but it refuses to settle.\n\r", ch);
        act("$n shudders violently for a moment.", ch, NULL, NULL, TO_ROOM);
        // obj->value[0] = ch->in_room->vnum;
        if (!IS_NPC(victim) && ch != victim && IS_MORE(victim, MORE_GUARDIAN)) {
            guardian_message( victim );
            act("$n just failed to open $s heart here.",ch,NULL,victim,TO_VICT);
            return;
        }
    } else {
        send_to_char("You concentrate, and refocus your heartbeat.\n\r", ch);
        act("$n shudders violently for a moment. When it stills, the heartbeat is slightly different.", ch, NULL, NULL, TO_ROOM);
        obj->value[0] = victim->in_room->vnum;
    }

    return;
}

void do_foldfae( CHAR_DATA *ch, char *argument ) {
    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char("Huh?\n\r",ch);
        return;
    }
    if (!IS_FFORM(ch, FFORM_PHOENIX)) {
        send_to_char("You don't have wings at the moment.\n\r",ch);
        return;
    }

    if (!IS_SET(ch->pcdata->fflags, FAE_UNFOLDED)) {
        send_to_char("Huge wings of rainbow fire unfold from behind your back.\n\r",ch);
        act("Huge wings of rainbow fire unfold from behind $n's back.", ch, NULL, NULL, TO_ROOM);
        SET_BIT(ch->pcdata->fflags, FAE_UNFOLDED);
        return;
    } else {
        send_to_char("Slowly, the flames die, and you fold your wings.\n\r",ch);
        act("Slowly, the flames die about $n's wings, and $s folds them carefully behind $e.\n\r", ch, NULL, NULL, TO_ROOM);
        REMOVE_BIT(ch->pcdata->fflags, FAE_UNFOLDED);
        return;
    }
}

void do_die( CHAR_DATA *ch, char *argument ) {
    OBJ_DATA *obj;
    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_FAE)) || !IS_FFORM(ch, FFORM_PHOENIX)) {
        send_to_char("How long have you had a deathwish?\n\r", ch);
        return;
    }

    if (!HAS_FPOW(ch, FPOW_PHOENIX, 4)) {
        send_to_char("It would be wise to learn to reincarnate yourself first.\n\r", ch);
        return;
    }

    if ((obj = ch->pcdata->chobj) != NULL && IS_EXTRA(ch, EXTRA_OSWITCH)) {
        ch->pcdata->obj_vnum = 0;
        obj->chobj = NULL;
        ch->pcdata->chobj = NULL;
        REMOVE_BIT(ch->extra, EXTRA_OSWITCH);
        REMOVE_BIT(ch->more, MORE_ASHES);
        free_string(ch->morph);
        ch->morph = str_dup( "a majestic phoenix" );
        act("$p bursts into flame. The fire turns orange, then blue then white, rising up into a great pillar of flame before collapsing into $n.", ch, obj, NULL, TO_ROOM);
        act("You draw your Weave together, concentrating it further and further until it explodes, and you arise from the flames.", ch, obj, NULL, TO_CHAR);
        extract_obj(obj);
        if (ch->in_room->vnum == ROOM_VNUM_IN_OBJECT) {
            char_from_room(ch);
            char_to_room(ch,get_room_index(ROOM_VNUM_HELL));
        }
        return;
    }
    if ((obj = create_object(get_obj_index(OBJ_VNUM_ASHES),0)) == NULL) {
        send_to_char( "Bug - please inform KaVir.\n\r", ch );
        return;
    }
    if (ch->mounted == IS_RIDING) do_dismount(ch,"");
    obj_to_room(obj,ch->in_room);
    SET_BIT(obj->quest, QUEST_VANISH);
    act("$n transforms into $p and falls to the ground.",ch,obj,NULL,TO_ROOM);
    act("You transform into $p and fall to the ground.",ch,obj,NULL,TO_CHAR);
    if (IS_EXTRA(ch, TIED_UP)) {
        act("The ropes binding you fall through your form.",ch,NULL,NULL,TO_CHAR);
        act("The ropes binding $n fall through $s form.",ch,NULL,NULL,TO_ROOM);
        REMOVE_BIT(ch->extra, TIED_UP);
        REMOVE_BIT(ch->extra, GAGGED);
        REMOVE_BIT(ch->extra, BLINDFOLDED);
    }
    if (is_affected(ch, gsn_web)) {
        act("The webbing entrapping $n falls through $s form.",ch,NULL,NULL,TO_ROOM);
        send_to_char("The webbing entrapping you falls through your form.\n\r",ch);
        affect_strip(ch, gsn_web);
    }
    if (IS_AFFECTED(ch, AFF_WEBBED)) {
        act("The webbing entrapping $n falls through $s form.",ch,NULL,NULL,TO_ROOM);
        send_to_char("The webbing entrapping you falls through your form.\n\r",ch);
        REMOVE_BIT(ch->affected_by, AFF_WEBBED);
    }
    if (is_affected(ch, gsn_tendrils)) {
        act("The tendrils of darkness entrapping $n fall through $s form.",ch,NULL,NULL,TO_ROOM);
        send_to_char("The tendrils of darkness entrapping you fall through your form.\n\r",ch);
        affect_strip(ch, gsn_tendrils);
    }
    if (IS_AFFECTED(ch, AFF_SHADOW)) {
        act("The tendrils of darkness entrapping $n fall through $s form.",ch,NULL,NULL,TO_ROOM);
        send_to_char("The tendrils of darkness entrapping you fall through your form.\n\r",ch);
        REMOVE_BIT(ch->affected_by, AFF_SHADOW);
    }
    if (is_affected(ch, gsn_jail)) {
        act("The bands of flame entrapping $n flicker out.",ch,NULL,NULL,TO_ROOM);
        send_to_char("The bands of flame entrapping you flicker out.\n\r",ch);
        affect_strip(ch, gsn_jail);
    }
    if (IS_AFFECTED(ch, AFF_JAIL)) {
        act("The bands of flame entrapping $n flicker out.",ch,NULL,NULL,TO_ROOM);
        send_to_char("The bands of flame entrapping you flicker out.\n\r",ch);
        REMOVE_BIT(ch->affected_by, AFF_JAIL);
    }
    ch->pcdata->obj_vnum = OBJ_VNUM_ASHES;
    obj->chobj = ch;
    ch->pcdata->chobj = obj;
    SET_BIT(ch->extra, EXTRA_OSWITCH);
    SET_BIT(ch->more, MORE_ASHES);
    free_string(ch->morph);
    ch->morph = str_dup(obj->short_descr);
    return;
}

void do_supernov( CHAR_DATA *ch, char *argument ) {
    if (IS_FAE(ch)){
    send_to_char("To go supernova, you must spell it out.\n\r", ch);
    return;
    }
    send_to_char("Huh?\n\r",ch);
    return;
}

void do_supernova( CHAR_DATA *ch, char *argument ) {
    CHAR_DATA *vch;
    CHAR_DATA *vch_next;
    int sn;

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char("Huh?\n\r",ch);
        return;
    }

    if ((sn = skill_lookup("fire breath")) <= 0) {
        send_to_char("Bug - Please inform an IMM.\n\r",ch);
        return;
    }

    if (!IS_FFORM(ch, FFORM_PHOENIX)) {
        send_to_char("Only the Phoenix can accomplish this.\n\r", ch);
        return;
    }

    if (!HAS_FPOW(ch, FPOW_PHOENIX, 5)) {
        send_to_char("Your fire is not strong enough to go supernova.\n\r", ch);
        return;
    }

    if (ch->hit >= 0 || ch->position >= POS_STUNNED) {
        send_to_char("You are not injured enough to release an inferno.\n\r",ch);
        return;
    }

    if (ch->mana < 2000) {
        send_to_char("You have insufficient energy to force a supernova.\n\r",ch);
        return;
    }

    ch->mana -= 2000;
    ch->hit = ch->max_hit * 0.1;
    ch->position = POS_STANDING;
    act("$n's body blasts outward into a blue-white supernova!",ch,NULL,NULL,TO_ROOM);
    for ( vch = ch->in_room->people; vch != NULL; vch = vch_next ) {
        vch_next = vch->next_in_room;
        if (ch == vch || is_safe(ch,vch)) continue;
        // damage(ch, vch, ch->max_hit/2, sn);
        act("$n burns your flesh away!", ch, NULL, NULL, TO_ROOM);
        vch->hit -= ch->max_hit/4;
    }
    WAIT_STATE(ch, 8);
    return;
}

void do_orion(CHAR_DATA *ch, char *argument) {
	TIMER_DATA t;
    char buf[MAX_INPUT_LENGTH];

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char("Huh?\n\r",ch);
        return;
    }

    if (!IS_FFORM(ch, FFORM_CAT)) {
        send_to_char("You must be a Panther to hunt with Orion.\n\r", ch);
        return;
    }
    if (ch->pcdata->quest < 2000) {
        send_to_char("It costs 2000 qp to summon Orion.\n\r",ch);
        return;
    }
    if (HAS_FPOW(ch, FPOW_ORION, 9)) {
        send_to_char("You possess perfection of wisdom and body.\n\r",ch);
        return;
    }

    ch->pcdata->quest -= 2000;
    send_to_char("You summon Orion, and stream into the Starweave.\n\r", ch);
	send_to_char("*If you leave the Weave or pantherform, you cannot hunt, and the QP sacrifice is forfeit*\n\r", ch);
	sprintf(buf, "%s has begun to hunt with Orion.", ch->name);
	log_string(buf);
    act("$n turns black, $s body studded with stars, then flashes and disappears.",ch,NULL,NULL,TO_ROOM);
	if (!IS_AFFECTED(ch, AFF_SHADOWPLANE))
		SET_BIT(ch->affected_by, AFF_SHADOWPLANE);

	t.fn = t_orion;
	t.hash = TIMER_ORION;
	t.count = 3;
	t.argument = str_dup("s1");
	timer_to_char(ch, &t);
}
void t_orion(CHAR_DATA *ch, char *argument, int v) {
	TIMER_DATA t;

	if (!strcmp(argument, "s1")) {
		send_to_char("You reach the Weave, and stand for a moment reattuning yourself to it's pure harmony.\n\r", ch);
		do_meditate(ch, "");
		t.count = 3; // 60 secs in total to go thru timers
		t.argument = str_dup("s2");
	} else if (!strcmp(argument, "s2")) {
		send_to_char("Orion silently beckons you, and you set off on the hunt.\n\r",ch);
		do_stand(ch, "");
		t.count = 3; // 60 secs in total to go thru timers
		t.argument = str_dup("s3");
	} else if (!strcmp(argument, "s3")) {
		send_to_char("You easily find your prey, and chase it up into the stars.\n\r", ch);
		t.argument = NULL;
		t.count = 5;
	} else {
		if (number_percent() < 30) {
			char buf[MAX_INPUT_LENGTH];
			send_to_char("You bring down the Stag, and ripping open his belly, eat the heart, liver and kidneys.\n\r", ch);
			send_to_char("Your heart fills with new wisdom, and your claws itch to hunt again.\n\r", ch);
			ch->pcdata->fpow[FPOW_ORION]++;
			REMOVE_BIT(ch->affected_by, AFF_SHADOWPLANE);

			sprintf(buf, "%s has begun to hunt with Orion.", ch->name);
			log_string(buf);
			return;
		} else if (number_percent() < 40) send_to_char("Orion's spear nicks the Stag, and it runs off again trailing a stream of stars.\n\r", ch);
		else if (number_percent() < 60) send_to_char("You lunge, and claw at the Stag's rear, but he escapes.\n\r", ch);
		else if (number_percent() < 80) send_to_char("Orion jumps from a cliff, and cuts a large gash in the Stag's neck before he is thrown.\n\r", ch);
		else send_to_char("The Stag runs across a wide river, and you are forced to acknowledge it's wisdom as the water drags on your fur.\n\r", ch);
		t.count = 5;
		t.argument = str_dup("x");
	}
	t.fn = t_orion;
	t.hash = v;
	timer_to_char(ch, &t);
}

void do_darkbreath( CHAR_DATA *ch, char *argument ) {
    char arg [MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    int spelltype;
    int level;
    int sn;

    one_argument( argument, arg );

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char( "Huh?\n\r", ch );
        return;
    }

    if (!IS_FFORM(ch, FFORM_CAT)) {
        send_to_char("You must be a panther to use breath weapons.\n\r", ch);
        return;
    }
    if (!HAS_FPOW(ch, FPOW_BREATH, 2)) {
        send_to_char("You cannot breathe darkness yet.\n\r", ch);
        return;
    }
	if (ch->mana < 150) {
		send_to_char("Your Weave is too weak to accomplish this.\n\r", ch);
		return;
	}
	ch->mana -= 150;

    if (IS_ITEMAFF(ch, ITEMA_PEACE)) do_majesty(ch,"");

    if (arg[0] == '\0' && ch->fighting == NULL) {
        send_to_char("Who do you wish to breathe darkness on?\n\r",ch);
        return;
    }

    if ((victim = ch->fighting) == NULL) {
        if ((victim = get_char_room(ch, arg)) == NULL) {
            send_to_char("They aren't here.\n\r", ch);
            return;
        }
    }

    if ( ch == victim ) {
        if (is_affected(ch, gsn_tendrils)) {
            act("The tendrils of darkness entrapping $n fall away.",ch,NULL,NULL,TO_ROOM);
            send_to_char("The tendrils of darkness entrapping you fall away.\n\r",ch);
            affect_strip(ch, gsn_tendrils);
        } else if (IS_AFFECTED(ch, AFF_SHADOW)) {
            act("The tendrils of darkness entrapping $n fall away.",ch,NULL,NULL,TO_ROOM);
            send_to_char("The tendrils of darkness entrapping you fall away.\n\r",ch);
            REMOVE_BIT(ch->affected_by, AFF_SHADOW);
        } else send_to_char( "Nothing happens.\n\r", ch );
        return;
    }

    if ( IS_AFFECTED(victim, AFF_ETHEREAL) ) {
        send_to_char("The darkness billows straight through them.\n\r", ch );
        if (!IS_NPC(victim) && ch != victim && IS_MORE(victim, MORE_GUARDIAN)) {
            guardian_message( victim );
            act("$n just failed to entrap you in darkness.",ch,NULL,victim,TO_VICT);
        }
        return;
    }

    if (is_safe(ch,victim)) {
        if (!IS_NPC(victim) && ch != victim && IS_MORE(victim, MORE_GUARDIAN)) {
            guardian_message( victim );
            act("$n just failed to entrap you in darkness.",ch,NULL,victim,TO_VICT);
        }
        return;
    }

    if ((sn = skill_lookup("tendrils")) < 0) return;
    spelltype = skill_table[sn].target;
    level = FPOW(ch, FPOW_FORCE) *5;
    (*skill_table[sn].spell_fun) ( sn, level, ch, victim );

	if (strcmp(arg, "xyzzy"))
		WAIT_STATE(ch, 8);

    return;
}

void do_acidbreath( CHAR_DATA *ch, char *argument ) {
	int hits;

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char( "Huh?\n\r", ch );
        return;
    }
    if (!IS_FFORM(ch, FFORM_CAT)) {
        send_to_char("You must be a panther to use breath weapons.\n\r", ch);
        return;
    }
    if (!HAS_FPOW(ch, FPOW_BREATH, 1)) {
        send_to_char("You cannot blast acid yet.\n\r", ch);
        return;
    }

	if (ch->fighting != NULL && !IS_NPC(ch->fighting))
		hits = kicktype(ch, argument, gsn_facid + TYPE_AGG, 100, 0,
		  35*FPOW(ch, FPOW_ORION), 200, 0.04, 12,
		  CLASS_FAE, 2, "$n just tried to breathe acid over you.");
	else hits = kicktype(ch, argument, gsn_facid, 100, 0,
		  35*FPOW(ch, FPOW_ORION), 200, 0.04, 12,
		  CLASS_FAE, 1, "$n just tried to breathe acid over you.");

	if (hits == 0)
		send_to_char("Your blast of acid hisses as it hits the floor.\n\r", ch);
    return;
}

void do_firebreath( CHAR_DATA *ch, char *argument ) {
	int hits;

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char( "Huh?\n\r", ch );
        return;
    }
    if (!IS_FFORM(ch, FFORM_CAT)) {
        send_to_char("You must be a panther to use breath weapons.\n\r", ch);
        return;
    }
    if (!HAS_FPOW(ch, FPOW_BREATH, 3)) {
        send_to_char("You cannot breathe fire yet.\n\r", ch);
        return;
    }
	
	hits = kicktype(ch, argument, gsn_ffire, 200, 0, 
	  40*FPOW(ch, FPOW_ORION), 400, 2, 10,
	  CLASS_VAMPIRE, 0, "$n just tried to breathe fire over you.");
    return;
}

void do_ltnbreath( CHAR_DATA *ch, char *argument ) {
	int hits;

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char( "Huh?\n\r", ch );
        return;
    }
    if (!IS_FFORM(ch, FFORM_CAT)) {
        send_to_char("You must be a panther to use breath weapons.\n\r", ch);
        return;
    }
    if (!HAS_FPOW(ch, FPOW_BREATH, 4)) {
        send_to_char("You cannot breathe lightning yet.\n\r", ch);
        return;
    }
	
	hits = kicktype(ch, argument, gsn_fltn, 350, 0,
	  40*FPOW(ch, FPOW_ORION), 400, 0.15, 10, CLASS_DEMON +CLASS_VAMPIRE,
	  0, "$n just tried to breathe lightning at you.");
	if (hits > 0) kicktype(ch, argument, gsn_fltn, 0, 0,
		  40*FPOW(ch, FPOW_ORION), 400, 0.15, 8, CLASS_DEMON +CLASS_VAMPIRE,
		  0, "");
    return;
}

void do_aetherbreath( CHAR_DATA *ch, char *argument ) {
	int hits;

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char( "Huh?\n\r", ch );
        return;
    }
    if (!IS_FFORM(ch, FFORM_CAT)) {
        send_to_char("You must be a panther to use breath weapons.\n\r", ch);
        return;
    }
    if (!HAS_FPOW(ch, FPOW_BREATH, 5)) {
        send_to_char("You cannot breathe Aether yet.\n\r", ch);
        return;
    }
	hits = kicktype(ch, argument, gsn_faether, 120, 20,
	  40*FPOW(ch, FPOW_ORION), 400, 0.3, 8,
	  CLASS_HIGHLANDER, 0, "$n just tried to breathe Aether at you.");
	if (hits < 1 || number_percent() < 50) return;

	hits = kicktype(ch, argument, gsn_faether, 120, 20,
	  40*FPOW(ch, FPOW_ORION), 400, 0.3, 8,
	  CLASS_HIGHLANDER, 0, "$n just tried to breathe Aether at you.");
	if (hits < 1 || number_percent() < 50) return;
	
	hits = kicktype(ch, argument, gsn_faether, 120, 20,
	  40*FPOW(ch, FPOW_ORION), 400, 0.3, 8,
	  CLASS_HIGHLANDER, 0, "$n just tried to breathe Aether at you.");

    return;
}

/*
void do_acidbreath( CHAR_DATA *ch, char *argument ) {
    char arg [MAX_INPUT_LENGTH];
    CHAR_DATA *vch;
    CHAR_DATA *vch_next;
    int dam;
    int stance;
	bool hit = FALSE;

    one_argument( argument, arg );

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char( "Huh?\n\r", ch );
        return;
    }

    if (!IS_FFORM(ch, FFORM_CAT)) {
        send_to_char("You must be a panther to use breath weapons.\n\r", ch);
        return;
    }
    if (!HAS_FPOW(ch, FPOW_BREATH, 1)) {
        send_to_char("You cannot blast acid yet.\n\r", ch);
        return;
    }
	if (ch->mana < 100) {
		send_to_char("Your Weave is too weak to accomplish this.\n\r", ch);
		return;
	}
	ch->mana -= 100;

    if (IS_ITEMAFF(ch, ITEMA_PEACE)) do_majesty(ch,"");

	if (strcmp(arg, "xyzzy"))
		WAIT_STATE( ch, 12 );

    stance = ch->stance[0];

    for ( vch = ch->in_room->people; vch != NULL; vch = vch_next ) {
        vch_next = vch->next_in_room;
		if (vch == ch) continue;
		if (!IS_NPC(vch)) continue;
		if (IS_EMPLOYEE(vch)) continue;

		dam = number_range(200,400);
		dam += (char_damroll(ch)/24);
		if (IS_STANCE(ch, STANCE_NORMAL)) dam *= 1.25;
		else dam = dambonus(ch, vch, dam, stance);
		if (!IS_AWAKE(vch))
			dam *= 2;
		if (dam <= 0)
			dam = 1;
		damage( ch, vch, dam, gsn_facid + TYPE_ADD_AGG );
		hit = TRUE;
    }
	if (!hit) send_to_char("Your blast of acid hisses as it hits the floor.\n\r", ch);
    return;
}

void do_firebreath( CHAR_DATA *ch, char *argument ) {
    char arg [MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    int dam;
    int stance;

    one_argument( argument, arg );

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char( "Huh?\n\r", ch );
        return;
    }

    if (!IS_FFORM(ch, FFORM_CAT)) {
        send_to_char("You must be a panther to use breath weapons.\n\r", ch);
        return;
    }
    if (!HAS_FPOW(ch, FPOW_BREATH, 3)) {
        send_to_char("You cannot breathe fire yet.\n\r", ch);
        return;
    }
	if (ch->mana < 200) {
		send_to_char("Your Weave is too weak to accomplish this.\n\r", ch);
		return;
	}
	ch->mana -= 200;

    if (IS_ITEMAFF(ch, ITEMA_PEACE)) do_majesty(ch,"");

    if (arg[0] == '\0' && ch->fighting == NULL) {
        send_to_char("Who do you wish to breathe fire on?\n\r",ch);
        return;
    }

    if ((victim = ch->fighting) == NULL) {
        if ((victim = get_char_room(ch, arg)) == NULL) {
            send_to_char("They aren't here.\n\r", ch);
            return;
        }
    }

    if (is_safe(ch,victim)) {
        if (!IS_NPC(victim) && ch != victim && IS_MORE(victim, MORE_GUARDIAN)) {
            guardian_message( victim );
            act("$n just tried to breathe fire over you.",ch,NULL,victim,TO_VICT);
        }
        return;
    }

	if (strcmp(arg, "xyzzy"))
		WAIT_STATE(ch, 12);

    dam = number_range(FPOW(ch, FPOW_BREATH)*50, FPOW(ch, FPOW_BREATH)*100);
    dam += (char_damroll(ch)/4);

    if (!IS_AWAKE(victim)) dam *= 2;
    stance = ch->stance[0];
    if ( IS_STANCE(ch, STANCE_NORMAL) ) dam *= 1.25;
    else dam = dambonus(ch,victim,dam,stance);
    if ( dam <= 0 )
        dam = 1;

	//Test thing
	ch->damcap[DAM_CAP] *= 3;
	ch->damcap[DAM_CHANGE] = 1;
    damage(ch, victim, dam, gsn_ffire);
    return;
}

void do_ltnbreath( CHAR_DATA *ch, char *argument ) {
    char arg [MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    int dam;
    int stance;

    one_argument( argument, arg );

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char( "Huh?\n\r", ch );
        return;
    }

    if (!IS_FFORM(ch, FFORM_CAT)) {
        send_to_char("You must be a panther to use breath weapons.\n\r", ch);
        return;
    }
    if (!HAS_FPOW(ch, FPOW_BREATH, 4)) {
        send_to_char("You cannot breathe lightning yet.\n\r", ch);
        return;
    }
	if (ch->mana < 250) {
		send_to_char("Your Weave is too weak to accomplish this.\n\r", ch);
		return;
	}
	ch->mana -= 250;

    if (IS_ITEMAFF(ch, ITEMA_PEACE)) do_majesty(ch,"");

    if (arg[0] == '\0' && ch->fighting == NULL) {
        send_to_char("Who do you wish to breathe lightning at?\n\r",ch);
        return;
    }

    if ((victim = ch->fighting) == NULL) {
        if ((victim = get_char_room(ch, arg)) == NULL) {
            send_to_char("They aren't here.\n\r", ch);
            return;
        }
    }

    if (is_safe(ch,victim)) {
        if (!IS_NPC(victim) && ch != victim && IS_MORE(victim, MORE_GUARDIAN)) {
            guardian_message( victim );
            act("$n just tried to breathe lightning at you.",ch,NULL,victim,TO_VICT);
        }
        return;
    }

	if (strcmp(arg, "xyzzy"))
		WAIT_STATE(ch, 6);

    dam = number_range(FPOW(ch, FPOW_BREATH)*50, FPOW(ch, FPOW_BREATH)*100);
    dam += (char_damroll(ch)/6);

    if (!IS_AWAKE(victim)) dam *= 2;
    stance = ch->stance[0];
    if ( IS_STANCE(ch, STANCE_NORMAL) ) dam *= 1.25;
    else dam = dambonus(ch,victim,dam,stance);
    if ( dam <= 0 )
        dam = 1;

    damage(ch, victim, dam, gsn_fltn);
    damage(ch, victim, dam, gsn_fltn);
    return;
}

void do_aetherbreath( CHAR_DATA *ch, char *argument ) {
    char arg [MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    int dam;
    int stance;

    one_argument( argument, arg );

    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char( "Huh?\n\r", ch );
        return;
    }

    if (!IS_FFORM(ch, FFORM_CAT)) {
        send_to_char("You must be a panther to use breath weapons.\n\r", ch);
        return;
    }
    if (!HAS_FPOW(ch, FPOW_BREATH, 5)) {
        send_to_char("You cannot breathe Aether yet.\n\r", ch);
        return;
    }
	if (ch->mana < 400) {
		send_to_char("Your Weave is too weak to accomplish this.\n\r", ch);
		return;
	}
	ch->mana -= 400;

    if (IS_ITEMAFF(ch, ITEMA_PEACE)) do_majesty(ch,"");

    if (arg[0] == '\0' && ch->fighting == NULL) {
        send_to_char("Who do you wish to breathe Aether at?\n\r",ch);
        return;
    }

    if ((victim = ch->fighting) == NULL) {
        if ((victim = get_char_room(ch, arg)) == NULL) {
            send_to_char("They aren't here.\n\r", ch);
            return;
        }
    }

    if (is_safe(ch,victim)) {
        if (!IS_NPC(victim) && ch != victim && IS_MORE(victim, MORE_GUARDIAN)) {
            guardian_message( victim );
            act("$n just tried to breathe Aether at you.",ch,NULL,victim,TO_VICT);
        }
        return;
    }

	if (strcmp(arg, "xyzzy"))
		WAIT_STATE(ch, 8);

    dam = number_range(FPOW(ch, FPOW_BREATH)*50, FPOW(ch, FPOW_BREATH)*100);
    dam += (char_damroll(ch)/3);

    if (!IS_AWAKE(victim)) dam *= 2;
    stance = ch->stance[0];
    if ( IS_STANCE(ch, STANCE_NORMAL) ) dam *= 1.25;
    else dam += dambonus(ch,victim,dam,stance);
    if ( dam <= 0 )
        dam = 1;

    damage(ch, victim, dam, gsn_faether);
	if (number_percent() < 50) return;
    damage(ch, victim, dam, gsn_faether);
	if (number_percent() < 50) return;
	damage(ch, victim, dam, gsn_faether);
    return;
}
*/

void do_wrath( CHAR_DATA *ch, char *argument ) {
    if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
        send_to_char("Huh?\n\r", ch);
        return;
    }

    if (!HAS_FPOW(ch, FPOW_CAT, 5)) {
        send_to_char("You are not yet wholly the Panther.\n\r", ch);
        return;
    }

    TOGGLE_BIT(ch->pcdata->fflags, FAE_AUTOCAT);
    if (IS_SET(ch->pcdata->fflags, FAE_AUTOCAT)) send_to_char("You awaken the hunter within, ready to destroy any who dares attack you.\n\r", ch);
    else send_to_char("You calm yourself, controlling your feral impulses.\n\r", ch);
    return;
}

void do_faeblade(CHAR_DATA *ch, char *argument) {
	OBJ_INDEX_DATA *pObjIndex;
	OBJ_DATA *obj;
	char buf[MAX_STRING_LENGTH];
	char arg[MAX_STRING_LENGTH];
	int type;

	one_argument(argument, arg);

	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}

	if ((pObjIndex = get_obj_index(29552)) == NULL) {
		send_to_char("Missing object, please inform the Imps.\n\r",ch);
		return; 
	}
	if (arg[0] != '\0') {
	         if (!str_cmp(arg,"slice" )) type = 1;
	    else if (!str_cmp(arg,"stab"  )) type = 2;
	    else if (!str_cmp(arg,"slash" )) type = 3;
	    else if (!str_cmp(arg,"pierce")) type = 11;
	    else {
			send_to_char("Valid types: Slice, Stab, Slash or Pierce.\n\r",ch);
			return;
		}
	} else type = 11;
	obj = create_object(pObjIndex, 50);
	obj->value[3] = type;

	switch (type) {
		default: strcpy(arg, "sharp kiwi"); break;
		case 1:	strcpy(arg, "finecrafted sword"); break;
		case 2:	strcpy(arg, "elegant dagger"); break;
		case 3:	strcpy(arg, "ferocious axe"); break;
		case 11:strcpy(arg, "noble rapier"); break;
	}
	sprintf( buf, obj->name, arg);
	free_string( obj->name );
	obj->name = str_dup(buf);
	 
	switch (type) {
		default: strcpy(arg, "a sharp kiwi"); break;
		case 1:	strcpy(arg, "a sword"); break;
		case 2:	strcpy(arg, "a dagger"); break;
		case 3:	strcpy(arg, "an axe"); break;
		case 11:strcpy(arg, "a rapier"); break;
	}
	sprintf( buf, obj->short_descr, arg);
	free_string(obj->short_descr);
	obj->short_descr = str_dup(buf);
	
	switch (type) {
		default: strcpy(arg, "A viciously sharp piece of kiwi lies here."); break;
		case 1:	strcpy(arg, "A finecrafted sword gleams brightly."); break;
		case 2:	strcpy(arg, "An elegant dagger lies forgotten."); break;
		case 3:	strcpy(arg, "A ferocious axe has been embedded in the floor.");break;
		case 11:strcpy(arg, "Some noble's rapier has been left here."); break;
	}
	sprintf( buf, obj->description, arg);
	free_string(obj->description);
	obj->description = str_dup(buf);
	
	free_string(obj->questmaker); obj->questmaker = str_dup(ch->name);
	free_string(obj->questowner); obj->questowner = str_dup(ch->name); 

	SET_BIT(obj->spectype, SITEM_FAE);
	if (HAS_FPOW(ch, 2, 1)) {
		if (obj->value[0] >= 1000)
		obj->value[0] -= ((obj->value[0] / 1000) * 1000);
		obj->value[0] += (8*1000);
	}
	if (HAS_FPOW(ch, 3, 1)) {
	    if (obj->value[0] >= 1000)
		obj->value[0] = ((obj->value[0] / 1000) * 1000);
	    else obj->value[0] = 0;
	    obj->value[0] += 4;
	}

	obj_to_char(obj, ch);
	 
	act("The air shimmers and $p slowly fades into existance in your hands.",ch,obj,NULL,TO_CHAR);
	act("The air shimmers and $p slowly fades into existance in $n's hands.",ch,obj,NULL,TO_ROOM);
	return;
}

void do_surge(CHAR_DATA *ch, char *argument) {
	int i, hurt = 0;
	
	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}
	if (!HAS_FPOW(ch, FPOW_LIFEWISH, 5)) {
		send_to_char("Your will to live is not strong enough.\n\r", ch);
		return;
	}

	if (ch->mana < 2000) {
		send_to_char("You lack sufficient mana.\n\r", ch);
		return;
	}

	for (i = 0; i < 7; i++) {
		if (ch->loc_hp[i] != 0) {
			hurt = 1;
			ch->loc_hp[i] = 0;
		}
	}
	if (ch->position == POS_STUNNED) {
		ch->position = POS_STANDING;
		hurt = 1;
	}

	if (hurt == 0) {
		send_to_char("You are whole in body; Aether cannot perform the gentle healings.\n\r", ch);
		return;
	}

	ch->mana -= 1000;
	send_to_char("The air surges with Aetherglow, bathing you in healing radiance.\n\r", ch);
	act("The air surges with Aetherglow, bathing $n in blue radiance.\n\r", ch, NULL, NULL, TO_ROOM);
}
/*
void do_bselect(CHAR_DATA *ch, char *argument) {
	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_FAE))
	{
		send_to_char("Huh?\n\r", ch);
		return;
	}
	if (!HAS_FPOW(ch, FPOW_BREATH, 1)) {
		send_to_char("You have no breath weapons!\n\r", ch);
		return;
	}
	
		 if (!str_cmp(argument, "none")) ch->pcdata->fbreath = -1;
	else if (!str_cmp(argument, "best")) ch->pcdata->fbreath = 0;
	else if (!str_cmp(argument, "acid")) ch->pcdata->fbreath = 1;
	else if (!str_cmp(argument, "dark")) ch->pcdata->fbreath = 2;
	else if (!str_cmp(argument, "fire")) ch->pcdata->fbreath = 3;
	else if (!str_cmp(argument, "lightning")) ch->pcdata->fbreath = 4;
	else if (!str_cmp(argument, "ltn")) ch->pcdata->fbreath = 4;
	else if (!str_cmp(argument, "aether")) ch->pcdata->fbreath = 5;
	else {
		send_to_char("None, acid, dark, fire, ltn or aether.\n\r", ch);
		return;
	}
	ch->pcdata->fbreath = UMIN(ch->pcdata->fbreath, FPOW(ch, FPOW_BREATH));

	switch (ch->pcdata->fbreath) {
		case -1: send_to_char("Breath weapon disabled.\n\r", ch); break;
		case 0: send_to_char("Highest breath weapon selected.\n\r", ch); break;
		case 1: send_to_char("Acidbreath selected.\n\r", ch); break;
		case 2: send_to_char("Darkbreath selected.\n\r", ch); break;
		case 3: send_to_char("Firebreath selected.\n\r", ch); break;
		case 4: send_to_char("Lightningbreath selected.\n\r", ch); break;
		case 5: send_to_char("Aetherbreath selected.\n\r", ch); break;
	}*/
}
