/*****************************************
 * Prometheus Unbound:  Mummy Class File *
 *            By Wolfman, (C) 2001       *
 *****************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "player.h"
#include "mummy.h"

void do_deities( CHAR_DATA *ch, char *argument )
{
	char arg1[MAX_INPUT_LENGTH];
	char arg2[MAX_INPUT_LENGTH];
	char buf[MAX_STRING_LENGTH];

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_MUMMY))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}

	if (arg1[0] == '\0' && arg2[0] == '\0')
	{
		sprintf(buf,"#G~~~~~~~~~~#RMummy Deities#G~~~~~~~~~~#n\n\r");
		stc(buf,ch);
	sprintf(buf,"Osiris (%d), Anubis (%d), Sekhmet (%d), Sobek (%d),\n\r",
		ch->pcdata->powers[MUM_OSIRIS], ch->pcdata->powers[MUM_ANUBIS],
		ch->pcdata->powers[MUM_SEKHMET], ch->pcdata->powers[MUM_SOBEK]);
		stc(buf,ch);
		sprintf(buf,"Amun (%d), Seth (%d), Serket (%d), Bastet (%d),\n\r",
		ch->pcdata->powers[MUM_AMUN], ch->pcdata->powers[MUM_SETH],
		ch->pcdata->powers[MUM_SERKET], ch->pcdata->powers[MUM_BASTET]);
		stc(buf,ch);
		sprintf(buf,"Shu (%d), Isis (%d), Maat (%d), Seker (%d),\n\r",
		ch->pcdata->powers[MUM_SHU], ch->pcdata->powers[MUM_ISIS],
		ch->pcdata->powers[MUM_MAAT], ch->pcdata->powers[MUM_SEKER]);
		stc(buf,ch);
		sprintf(buf,"Ra (%d)\n\r",
		ch->pcdata->powers[MUM_RA]);
		stc(buf,ch);
		return;
	}
	if (arg2[0] == '\0')
	{
		if (!str_cmp(arg1,"osiris"))
		{
send_to_char("Osiris - The God of Agriculture and Ruler of the Dead.\n\r",ch);
		if ( ch->pcdata->powers[MUM_OSIRIS] == 0 )
		send_to_char("Osiris: None.\n\r",ch);
		if ( ch->pcdata->powers[MUM_OSIRIS] > 0 )
		send_to_char("Osiris: #GVines#n of wrath\n\r",ch);
		if ( ch->pcdata->powers[MUM_OSIRIS] > 1 )
		send_to_char("Osiris: Maneating #GFlytrap#n of Osiris\n\r",ch);
		if ( ch->pcdata->powers[MUM_OSIRIS] > 2 )
		send_to_char("Osiris: Walls of #GGrass#n\n\r",ch);
		if ( ch->pcdata->powers[MUM_OSIRIS] > 3 )
		send_to_char("Osiris: Arms of #GCorn#n\n\r",ch);
		if ( ch->pcdata->powers[MUM_OSIRIS] > 4 )
		send_to_char("Osiris: Mighty #GOak#n\n\r",ch);
		send_to_char("\n\r",ch);
		return;
		}
		else if (!str_cmp(arg1,"anubis"))
		{
                send_to_char("Anubis - The God of mummification.\n\r",ch);
		if ( ch->pcdata->powers[MUM_ANUBIS] == 0 )
		send_to_char("Anubis: None.\n\r",ch);
		if ( ch->pcdata->powers[MUM_ANUBIS] > 0 )
		send_to_char("Anubis: #oDisembowel#n\n\r",ch);
		if ( ch->pcdata->powers[MUM_ANUBIS] > 1 )
		send_to_char("Anubis: Brain #ohook#n\n\r",ch);
		if ( ch->pcdata->powers[MUM_ANUBIS] > 2 )
		send_to_char("Anubis: #oLung#n removal\n\r",ch);
		if ( ch->pcdata->powers[MUM_ANUBIS] > 3 )
		send_to_char("Anubis: #oCanopic#n jar\n\r",ch);
		if ( ch->pcdata->powers[MUM_ANUBIS] > 4 )
		send_to_char("Anubis: #oWrappings#n of Strangulation\n\r",ch);
		send_to_char("\n\r",ch);
		return;
		}
		else if (!str_cmp(arg1,"sekhmet"))
		{
send_to_char("Sekhmet - The Lioness Goddess of War and Sickness.\n\r",ch);
		if ( ch->pcdata->powers[MUM_SEKHMET] == 0 )
		send_to_char("Sekhmet: None.\n\r",ch);
		if ( ch->pcdata->powers[MUM_SEKHMET] >= 1 )
		send_to_char("Sekhmet: Warrior's Strength\n\r",ch);
		if ( ch->pcdata->powers[MUM_SEKHMET] >= 2 )
		send_to_char("Sekhmet: Warrior's Speed\n\r",ch);
		if ( ch->pcdata->powers[MUM_SEKHMET] >= 3 )
		send_to_char("Sekhmet: Warrior's Toughness\n\r",ch);
		if ( ch->pcdata->powers[MUM_SEKHMET] >= 4 )
		send_to_char("Sekhmet: Black Plague\n\r",ch);
		if ( ch->pcdata->powers[MUM_SEKHMET] >= 5 )
		send_to_char("Sekhmet: Creeping Death\n\r",ch);
		send_to_char("\n\r",ch);
		return;
		}
		else if (!str_cmp(arg1,"sobek"))
		{
send_to_char("Sobek - The representative of the 4 Elemental Gods.\n\r",ch);
		if ( ch->pcdata->powers[MUM_SOBEK] == 0 )
		send_to_char("Sobek: None.\n\r",ch);
		if ( ch->pcdata->powers[MUM_SOBEK] >= 1 )
		send_to_char("Sobek: Tornado Winds\n\r",ch);
		if ( ch->pcdata->powers[MUM_SOBEK] >= 2 )
		send_to_char("Sobek: Hurricane Force\n\r",ch);
		if ( ch->pcdata->powers[MUM_SOBEK] >= 3 )
		send_to_char("Sobek: Volcanic Lava\n\r",ch);
		if ( ch->pcdata->powers[MUM_SOBEK] >= 4 )
		send_to_char("Sobek: Earthquake\n\r",ch);
		if ( ch->pcdata->powers[MUM_SOBEK] >= 5 )
		send_to_char("Sobek: Typhoon\n\r",ch);
		send_to_char("\n\r",ch);
		return;
		}
		else if (!str_cmp(arg1,"amun"))
		{
send_to_char("Amun - The God known as 'The Hidden One'.\n\r",ch);
		if ( ch->pcdata->powers[MUM_AMUN] == 0 )
		send_to_char("Amun: None.\n\r",ch);
		if ( ch->pcdata->powers[MUM_AMUN] >= 1 )
		send_to_char("Amun: Cloak of Shadows\n\r",ch);
		if ( ch->pcdata->powers[MUM_AMUN] >= 2 )
		send_to_char("Amun: Cloak of Darkness\n\r",ch);
		if ( ch->pcdata->powers[MUM_AMUN] >= 3 )
		send_to_char("Amun: Cloak of Stealth\n\r",ch);
		if ( ch->pcdata->powers[MUM_AMUN] >= 4 )
		send_to_char("Amun: Cloak of Invisibility\n\r",ch);
		if ( ch->pcdata->powers[MUM_AMUN] >= 5 )
		send_to_char("Amun: Cloak of Amun\n\r",ch);
		send_to_char("\n\r",ch);
		return;
		}
		else if (!str_cmp(arg1,"seth"))
		{
send_to_char("Seth - The God of storms, disorder, the desert, and foreign lands.\n\r",ch);
		if ( ch->pcdata->powers[MUM_SETH] == 0 )
		send_to_char("Seth: None.\n\r",ch);
		if ( ch->pcdata->powers[MUM_SETH] >= 1 )
		send_to_char("Seth: Sandstorm\n\r",ch);
		if ( ch->pcdata->powers[MUM_SETH] >= 2 )
		send_to_char("Seth: Mimickry\n\r",ch);
		if ( ch->pcdata->powers[MUM_SETH] >= 3 )
		send_to_char("Seth: 3",ch);
		if ( ch->pcdata->powers[MUM_SETH] >= 4 )
		send_to_char("Seth: 4",ch);
		if ( ch->pcdata->powers[MUM_SETH] >= 5 )
		send_to_char("Seth: 5",ch);
		send_to_char("\n\r",ch);
		return;
		}
		else if (!str_cmp(arg1,"serket"))
		{
send_to_char("Serket - A Scorpion Goddess who struck death to the wicked.\n\r",ch);
		if ( ch->pcdata->powers[MUM_SERKET] == 0 )
		send_to_char("Serket: None.\n\r",ch);
		if ( ch->pcdata->powers[MUM_SERKET] >= 1 )
		send_to_char("Serket: Scorpion Call\n\r",ch);
		if ( ch->pcdata->powers[MUM_SERKET] >= 2 )
		send_to_char("Serket: Scorpion Sting\n\r",ch);
		if ( ch->pcdata->powers[MUM_SERKET] >= 3 )
		send_to_char("Serket: Black Scorpion\n\r",ch);
		if ( ch->pcdata->powers[MUM_SERKET] >= 4 )
		send_to_char("Serket: Brown Scorpion\n\r",ch);
		if ( ch->pcdata->powers[MUM_SERKET] >= 5 )
		send_to_char("Serket: White Scorpion\n\r",ch);
		send_to_char("\n\r",ch);
		return;
		}
		else if (!str_cmp(arg1,"bastet"))
		{
send_to_char("Bastet - A Cat Goddess, protector of cats.\n\r",ch);
		if ( ch->pcdata->powers[MUM_BASTET] == 0 )
		send_to_char("Bastet: None.\n\r",ch);
		if ( ch->pcdata->powers[MUM_BASTET] >= 1 )
		send_to_char("Bastet: Cat's eyes\n\r",ch);
		if ( ch->pcdata->powers[MUM_BASTET] >= 2 )
		send_to_char("Bastet: Cat's Claws\n\r",ch);
		if ( ch->pcdata->powers[MUM_BASTET] >= 3 )
		send_to_char("Bastet: Meow of Agony\n\r",ch);
		if ( ch->pcdata->powers[MUM_BASTET] >= 4 )
		send_to_char("Bastet: Ball of Yarn\n\r",ch);
		if ( ch->pcdata->powers[MUM_BASTET] >= 5 )
		send_to_char("Bastet: Fur of Frenzy",ch);
		send_to_char("\n\r",ch);
		return;
		}
		else if (!str_cmp(arg1,"shu"))
		{
send_to_char("Shu - The God of the air, atmosphere, and of dry winds.\n\r",ch);
		if ( ch->pcdata->powers[MUM_SHU] == 0 )
		send_to_char("Shu: None.\n\r",ch);
		if ( ch->pcdata->powers[MUM_SHU] >= 1 )
		send_to_char("Shu: 1",ch);
		if ( ch->pcdata->powers[MUM_SHU] >= 2 )
		send_to_char("Shu: 2",ch);
		if ( ch->pcdata->powers[MUM_SHU] >= 3 )
		send_to_char("Shu: 3",ch);
		if ( ch->pcdata->powers[MUM_SHU] >= 4 )
		send_to_char("Shu: 4",ch);
		if ( ch->pcdata->powers[MUM_SHU] >= 5 )
		send_to_char("Shu: 5",ch);
		send_to_char("\n\r",ch);
		return;
		}
		else if (!str_cmp(arg1,"isis"))
		{
send_to_char("Isis - The Goddess of healing, magical spells, and charms.\n\r",ch);
		if ( ch->pcdata->powers[MUM_ISIS] == 0 )
		send_to_char("Isis: None.\n\r",ch);
		if ( ch->pcdata->powers[MUM_ISIS] >= 1 )
		send_to_char("Isis: 1",ch);
		if ( ch->pcdata->powers[MUM_ISIS] >= 2 )
		send_to_char("Isis: 2",ch);
		if ( ch->pcdata->powers[MUM_ISIS] >= 3 )
		send_to_char("Isis: 3",ch);
		if ( ch->pcdata->powers[MUM_ISIS] >= 4 )
		send_to_char("Isis: 4",ch);
		if ( ch->pcdata->powers[MUM_ISIS] >= 5 )
		send_to_char("Isis: 5",ch);
		send_to_char("\n\r",ch);
		return;
		}
		else if (!str_cmp(arg1,"maat"))
		{
send_to_char("Maat - The Deity associated with truth and justice.\n\r",ch);
		if ( ch->pcdata->powers[MUM_MAAT] == 0 )
		send_to_char("Maat: None.\n\r",ch);
		if ( ch->pcdata->powers[MUM_MAAT] >= 1 )
		send_to_char("Maat: 1",ch);
		if ( ch->pcdata->powers[MUM_MAAT] >= 2 )
		send_to_char("Maat: 2",ch);
		if ( ch->pcdata->powers[MUM_MAAT] >= 3 )
		send_to_char("Maat: 3",ch);
		if ( ch->pcdata->powers[MUM_MAAT] >= 4 )
		send_to_char("Maat: 4",ch);
		if ( ch->pcdata->powers[MUM_MAAT] >= 5 )
		send_to_char("Maat: 5",ch);
		send_to_char("\n\r",ch);
		return;
		}
		else if (!str_cmp(arg1,"seker"))
		{
send_to_char("Seker - The God of light, protector of the spirits of the dead.\n\r",ch);
		if ( ch->pcdata->powers[MUM_SEKER] == 0 )
		send_to_char("Seker: None.\n\r",ch);
		if ( ch->pcdata->powers[MUM_SEKER] >= 1 )
		send_to_char("Seker: 1",ch);
		if ( ch->pcdata->powers[MUM_SEKER] >= 2 )
		send_to_char("Seker: 2",ch);
		if ( ch->pcdata->powers[MUM_SEKER] >= 3 )
		send_to_char("Seker: 3",ch);
		if ( ch->pcdata->powers[MUM_SEKER] >= 4 )
		send_to_char("Seker: 4",ch);
		if ( ch->pcdata->powers[MUM_SEKER] >= 5 )
		send_to_char("Seker: 5",ch);
		send_to_char("\n\r",ch);
		return;
		}
		else if (!str_cmp(arg1,"ra"))
		{
send_to_char("Ra - The God of the sun.\n\r",ch);
		if ( ch->pcdata->powers[MUM_RA] == 0 )
		send_to_char("Ra: None.\n\r",ch);
		if ( ch->pcdata->powers[MUM_RA] >= 1 )
		send_to_char("Ra: 1",ch);
		if ( ch->pcdata->powers[MUM_RA] >= 2 )
		send_to_char("Ra: 2",ch);
		if ( ch->pcdata->powers[MUM_RA] >= 3 )
		send_to_char("Ra: 3",ch);
		if ( ch->pcdata->powers[MUM_RA] >= 4 )
		send_to_char("Ra: 4",ch);
		if ( ch->pcdata->powers[MUM_RA] >= 5 )
		send_to_char("Ra: 5",ch);
		send_to_char("\n\r",ch);
		return;
		}
		sprintf(buf,"#G~~~~~~~~~~#RMummy Deities#G~~~~~~~~~~#n\n\r");
		stc(buf,ch);
	sprintf(buf,"Osiris (%d), Anubis (%d), Sekhmet (%d), Sobek (%d),\n\r",
		ch->pcdata->powers[MUM_OSIRIS], ch->pcdata->powers[MUM_ANUBIS],
		ch->pcdata->powers[MUM_SEKHMET], ch->pcdata->powers[MUM_SOBEK]);
		stc(buf,ch);
		sprintf(buf,"Amun (%d), Seth (%d), Serket (%d), Bastet (%d),\n\r",
		ch->pcdata->powers[MUM_AMUN], ch->pcdata->powers[MUM_SETH],
		ch->pcdata->powers[MUM_SERKET], ch->pcdata->powers[MUM_BASTET]);
		stc(buf,ch);
		sprintf(buf,"Shu (%d), Isis (%d), Maat (%d), Seker (%d),\n\r",
		ch->pcdata->powers[MUM_SHU], ch->pcdata->powers[MUM_ISIS],
		ch->pcdata->powers[MUM_MAAT], ch->pcdata->powers[MUM_SEKER]);
		stc(buf,ch);
		sprintf(buf,"Ra (%d)\n\r",
		ch->pcdata->powers[MUM_RA]);
		stc(buf,ch);
		return;
		}
	if (!str_cmp(arg2,"improve"))
	{
		int improve;
		int cost;
		int max;

		if 		(!str_cmp(arg1,"osiris"  )) {
			improve = MUM_OSIRIS;
			max=5;
		}
		else if 	(!str_cmp(arg1,"anubis"   )) {
			improve = MUM_ANUBIS;
			max=5;
		}
		else if 	(!str_cmp(arg1,"sekhmet"   )) {
			improve = MUM_SEKHMET;
			max=5;
		}
		else if 	(!str_cmp(arg1,"sobek"   )) {
			improve = MUM_SOBEK;

			max=5;
		}
		else if 	(!str_cmp(arg1,"amun"   )) {
			improve = MUM_AMUN;
			max=5;
		}
		else if 	(!str_cmp(arg1,"seth"   )) {
			improve = MUM_SETH;
			max=5;
		}
		else if 	(!str_cmp(arg1,"serket"   )) {
			improve = MUM_SERKET;
			max=5;
		}
		else if 	(!str_cmp(arg1,"bastet"   )) {
			improve = MUM_BASTET;
			max=5;
		}
		else if 	(!str_cmp(arg1,"shu"   )) {
			improve = MUM_SHU;
			max=5;
		}
		else if 	(!str_cmp(arg1,"isis"   )) {
			improve = MUM_ISIS;
			max=5;
		}
		else if 	(!str_cmp(arg1,"maat"   )) {
			improve = MUM_MAAT;
			max=5;
		}
		else if 	(!str_cmp(arg1,"seker"   )) {
			improve = MUM_SEKER;
			max=5;
		}
		else if 	(!str_cmp(arg1,"ra"   )) {
			improve = MUM_RA;
			max=5;
		}
		else
		{
			stc("Deities: Osiris, Anubis, Sekhmet, Sobek,\n\r",ch);
			stc("         Amun, Seth, Serket, Bastet, Shu,\n\r",ch);
			stc("         Isis, Maat, Seker, Ra.\n\r",ch);
			return;
		}
		cost = (ch->pcdata->powers[improve]+1) * 10;
		arg1[0] = UPPER(arg1[0]);
		if ( ch->pcdata->powers[improve] >= max )
		{
sprintf(buf,"You already have all your powers from the deity %s.\n\r", arg1);
			send_to_char(buf,ch);
			return;
		}
		if ( cost > ch->practice )
		{
sprintf(buf,"It costs %d primal to gain more skills from the deity %s.\n\r", cost, arg1);
			send_to_char(buf,ch);
			return;
		}
		ch->pcdata->powers[improve] += 1;
		ch->practice -= cost;
		sprintf(buf,"The deity %s grants you a new skill.\n\r", arg1);
		send_to_char(buf,ch);
	}
	else send_to_char("To improve a skill, type: deities <deity name> improve.\n\r",ch);
	return;
}

void do_vines( CHAR_DATA *ch, char *argument )                                    
{                                                                               
    CHAR_DATA *victim;                                                          
    char arg [MAX_INPUT_LENGTH];                                                
    int sn;                                                                     
    int level;                                                                  
    int spelltype;                                                              
                                                                                
    argument = one_argument( argument, arg );                                   
    if (IS_NPC(ch)) return;                                                     
                                                                                
    if (!IS_CLASS(ch, CLASS_MUMMY))        
    {                                                                           
        send_to_char("Huh?\n\r",ch);                                            
        return;                                                                 
    }                                                                           
    if ( ch->pcdata->powers[MUM_OSIRIS] < 1 )
    {
	stc("You haven't asked your deity Osiris for this power yet.\n\r",ch);
	return;
    }
    if ( arg[0] == '\0' )                                                       
    {                                                                           
        send_to_char( "Unleash your vines on who?\n\r", ch );                                                                
        return;                                                                 
    }
    if ( ( victim = get_char_room( ch, arg ) ) == NULL )                        
    {                                                                           
        send_to_char( "They aren't here.\n\r", ch );                            
        return;                                                                 
    }                                                                           
                                                                                
    if ( ch == victim )                                                         
   {                                                                           
        send_to_char( "The vines refuse to attack you.\n\r", ch );                     
        return;                                                                 
    }                                                                           
                                                                                
    if ( IS_AFFECTED(victim, AFF_ETHEREAL) )                                    
    {                                                                           
        send_to_char( "The vines of wrath sprout from the ground and go right through them!\n\r", ch ); 
        return;                                                                 
    }                                                                           
                                                                                
    if ( ( sn = skill_lookup( "vines" ) ) < 0 ) return;                           
    spelltype = skill_table[sn].target;                                         
    level = ch->spl[spelltype] * 0.75;                                          
    (*skill_table[sn].spell_fun) ( sn, level, ch, victim );                     
    WAIT_STATE( ch, 12 );                                                       
    return;                                                                     
}                                                                               

void do_flytrap( CHAR_DATA *ch, char *argument )                  
{                                                                               
    CHAR_DATA *victim;                                                          
    char arg [MAX_INPUT_LENGTH];                                                
    char buf [MAX_INPUT_LENGTH];                                                                                

    argument = one_argument( argument, arg );                                   

    if (IS_NPC(ch)) return;                                                     
                                                                                
    if (!IS_CLASS(ch, CLASS_MUMMY))                                             
    {                                                                           
        send_to_char("Huh?\n\r",ch);                                            
        return;                                                                 
    }                                                                           
    if ( ch->pcdata->powers[MUM_OSIRIS] < 2 )                                   
    {                                                                           
        stc("You haven't asked your deity Osiris for this power yet.\n\r",ch);  
        return;                                                                 
    }
    ch->pcdata->followers++;                                                    
                                                                                
        victim=create_mobile( get_mob_index(93421));                            
        free_string(victim->lord);                                              
        victim->lord = str_dup(ch->name);                                       
        SET_BIT(victim->act, ACT_NOEXP);
        char_to_room( victim, ch->in_room );                                    
        act( "$N grows out of the ground.", ch, NULL, victim, TO_CHAR );           
        act( "$N grows out of the ground.", ch, NULL, victim, TO_ROOM );           
        sprintf(buf, "%s",ch->name);                                                
        do_follow( victim, buf );                                                   
        return;                                                                 
    }                                                                           

void do_grass(CHAR_DATA *ch, char *argument)
{                                                                               
OBJ_DATA *obj = NULL;                                                           
OBJ_DATA *objc;                                                                 
char arg[MAX_STRING_LENGTH];                                                    
char wall[MAX_STRING_LENGTH];                                                   
char buf[MAX_STRING_LENGTH];                                                    
argument=one_argument(argument,arg);                                            
if (IS_NPC(ch)) return;                                                         
if (!IS_CLASS(ch,CLASS_MUMMY))                                                
{                                                                               
send_to_char("Huh?\n\r",ch);                                                    
return;                                                                         
}                                                                               
    if ( ch->pcdata->powers[MUM_OSIRIS] < 3 )                                   
    {                                                                           
        stc("You haven't asked your deity Osiris for this power yet.\n\r",ch);  
        return;                                                                 
}                                                                               
if (arg[0] == '\0' || (str_cmp(arg,"n")                                         
                   && str_cmp(arg,"s")                                          
                   && str_cmp(arg,"e")                                          
                   && str_cmp(arg,"w")                                          
                   && str_cmp(arg,"u")                                          
                   && str_cmp(arg,"d")))                                        
{                                                                               
send_to_char("You may wall n, w, s, e, d or u.\n\r",ch);                        
return;                                                                         
}                                                                               
sprintf(buf,"%s prays to the deity Osiris, and a wall of grass quickly grows out of the ground!",ch->name);
act(buf,ch,NULL,NULL,TO_ROOM);                                                  
send_to_char("You pray to Osiris, and a wall of grass quickly grows out of the ground!\n\r",ch);
if (!str_cmp(arg,"n")) sprintf(wall,"walln");                                   
if (!str_cmp(arg,"w")) sprintf(wall,"wallw");                                   
if (!str_cmp(arg,"s")) sprintf(wall,"walls");                                   
{                                                                               
send_to_char("You may wall n, w, s, e, d or u.\n\r",ch);                        
return;                                                                         
}                                                                               
sprintf(buf,"%s prays to the deity Osiris, and a wall of grass quickly grows out of the ground!",ch->name);
act(buf,ch,NULL,NULL,TO_ROOM);                                                  
send_to_char("You pray to Osiris, and a wall of grass quickly grows out of the ground!\n\r",ch);
if (!str_cmp(arg,"n")) sprintf(wall,"walln");                                   
if (!str_cmp(arg,"w")) sprintf(wall,"wallw");                                   
if (!str_cmp(arg,"s")) sprintf(wall,"walls");                                   
if (!str_cmp(arg,"e")) sprintf(wall,"walle");                                   
if (!str_cmp(arg,"d")) sprintf(wall,"walld");                                   
if (!str_cmp(arg,"u")) sprintf(wall,"wallu");                                   
objc = get_obj_list(ch,wall,ch->in_room->contents);                             
if ( objc != NULL)                                                              
{                                                                               
send_to_char("A wall of grass is already blocking that direction.\n\r",ch);        
return;                                                                         
}                                                                               
WAIT_STATE(ch,25);                                                              
sprintf(buf,"Very very tall grass quickly grows from the ground with no lawnmower in sight!");
act(buf,ch,NULL,NULL,TO_ROOM);                                                  
send_to_char(buf,ch);                                                           
if (!str_cmp(arg,"n")) obj=create_object(get_obj_index(30056),0);               
if (!str_cmp(arg,"s")) obj=create_object(get_obj_index(30057),0);               
if (!str_cmp(arg,"e")) obj=create_object(get_obj_index(30058),0);               
if (!str_cmp(arg,"w")) obj=create_object(get_obj_index(30059),0);               
if (!str_cmp(arg,"d")) obj=create_object(get_obj_index(30060),0);               
if (!str_cmp(arg,"u")) obj=create_object(get_obj_index(30061),0);               
obj_to_room(obj,ch->in_room);                                                   
obj->timer=3;                                                                   
obj->item_type = ITEM_WALL;                                                     
return;                                                                         
}                                                                               

void do_corn(CHAR_DATA *ch, char *argument)                                    
{                                                                               
    OBJ_DATA *obj;                                                              
    char arg[MAX_INPUT_LENGTH];                                                 
    argument = one_argument(argument, arg);                                     
                                                                                
    if (IS_NPC(ch)) return;                                                     
                                                                                
        if (!IS_CLASS(ch,CLASS_MUMMY))                                          
    {                                                                           
    send_to_char("Huh?\n\r",ch);                                                
    return;                                                                     
    }                                                                           
    if ( ch->pcdata->powers[MUM_OSIRIS] < 4 )                                   
    {                                                                           
        stc("You haven't asked your deity Osiris for this power yet.\n\r",ch);  
        return;                                                                 
    }                                                                           
    if (IS_SET(ch->newbits, THIRD_HAND) && IS_SET(ch->newbits, FOURTH_HAND))    
    {                                                                           
        stc("You have already gained 2 extra arms!\n\r",ch);                              
        return;                                                                 
    }                                                                           
                                                                                
    if (!IS_SET(ch->newbits, FOURTH_HAND))                                      
    {                                                                           
        act("An extra arm made of corn sprouts from your body.",ch,NULL,obj,TO_CHAR);            
        act("An arm made of corn sprouts from $n's body.",ch,NULL,obj,TO_ROOM);              
        SET_BIT(ch->newbits, FOURTH_HAND);                                      
        SET_TIMER(ch, TIMER_FOURTH_ARM_GOING, dice(ch->generation, 6) );        
        WAIT_STATE(ch, 18);                                                     
        extract_obj(obj);                                                       
        return;                                                                 
    }                                                                           
                                                                                
    if (!IS_SET(ch->newbits, THIRD_HAND))                                       
    {                                                                           
        act("An extra arm made of corn sprouts from your body.",ch,NULL,obj,TO_CHAR);            
        act("An arm made of corn sprouts from $n's body.",ch,NULL,obj,TO_ROOM);              
        SET_BIT(ch->newbits, THIRD_HAND);                                       
        SET_TIMER(ch, TIMER_THIRD_ARM_GOING, dice(ch->generation, 6) );         
        WAIT_STATE(ch, 18);                                                     
        extract_obj(obj);                                                       
        return;                                                                 
    }                                                                           
                                                                                
    return;                                                                     
}                                                                               

void do_oak (CHAR_DATA *ch, char *argument)                                 
{                                                                               
  OBJ_DATA *obj;                                                                
                                                                                
  if (IS_NPC(ch)) return;                                                       
  if (!IS_CLASS(ch, CLASS_MUMMY))                                        
  {                                                                             
    send_to_char("Huh.\n\r",ch);                                                
    return;                                                                     
  }                                                                             
    if ( ch->pcdata->powers[MUM_OSIRIS] < 5 )                                   
    {                                                                           
        stc("You haven't asked your deity Osiris for this power yet.\n\r",ch);  
        return;                                                                 
  }                                                                             
  if (IS_AFFECTED(ch,AFF_POLYMORPH))                                            
  {                                                                             
    send_to_char( "You must be in human form.\n\r", ch);                        
    return;                                                                     
  }                                                                             
  if (ch->fight_timer>0)                                                        
  {                                                                             
    send_to_char("Not with a fight timer.\n\r",ch);                             
    return;                                                                     
  }                                                                             
  if ((obj = create_object(get_obj_index(11611),60)) == NULL)                   
  {                                                                             
    send_to_char( "Object bug, tell a Coder.\n\r", ch);                         
    return;                                                                     
  }                                                                             
  obj_to_room(obj,ch->in_room);                                                 
  act("$n transforms into $p, and grows roots into the ground.",ch,obj,NULL,TO_ROOM);    
  act("You transform into $p, and grow roots into the ground.",ch,obj,NULL,TO_CHAR);     
  ch->pcdata->obj_vnum = 11611;                                                 
  obj->chobj = ch;                                                              
  ch->pcdata->chobj = obj;                                                      
  SET_BIT(ch->affected_by, AFF_POLYMORPH);                                      
  SET_BIT(ch->extra, EXTRA_OSWITCH);                                            
  free_string(ch->morph);                                                       
  ch->morph = str_dup(obj->short_descr);                                        
  return;                                                                       
}                                                                               

void do_disembowel (CHAR_DATA *ch, char *argument)                                
{                                                                               
        CHAR_DATA *victim;                                                      
        OBJ_DATA *obj;                                                          
        char arg [MAX_INPUT_LENGTH];                                            
        char buf [MAX_STRING_LENGTH];                                           
        argument = one_argument (argument, arg);                                
        if (IS_NPC(ch)) return;                                                 
        if (!IS_CLASS(ch, CLASS_MUMMY))                                         
        {                                                                       
                send_to_char("Huh?\n\r",ch);                                    
                return;                                                         
        }                                                                       
       if (ch->pcdata->powers[MUM_ANUBIS] < 1)                                 
        {                                                                       
        send_to_char("You haven't asked your deity Anubis for this power yet.\n\r",ch);
                return;                                                         
        }                                                                       
        if ( arg[0] == '\0' )                                                   
        {                                                                       
                send_to_char("Whose time hath come?\n\r",ch);             
                return;                                                         
        }                                                                       
        victim = get_char_room(ch, arg);                                        
        if ( ( victim = get_char_room( ch, arg) ) == NULL )                     
        {                                                                       
                send_to_char("They arent here.\n\r",ch);                        
                return;                                                         
        }                                                                       
        if (IS_SET(victim->in_room->room_flags, ROOM_SAFE))                     
        {                                                                       
                send_to_char("You cannot attack them here.\n\r",ch);            
                return;                                                         
        }                                                                       
       if (is_safe(ch,victim) == TRUE)                                         
                return;                                                         
        if (IS_SET(victim->garou2,MISSING_INTESTINES))                          
        {                                                                       
                send_to_char("You have already removed their intestines!\n\r",ch);    
                return;                                                         
        }                                                                       
        if (number_percent ( ) < 45 )                                           
        {                                                                       
                if (!IS_SET(victim->garou2,MISSING_INTESTINES))                  
               {                                                               
                       SET_BIT(victim->garou2,MISSING_INTESTINES);              
                        if ((obj = get_eq_char( victim, WEAR_BODY )) != NULL)   
                                take_item(victim,obj);                          
                        make_part(victim,"intestines");                              
                        sprintf(buf, "%s disembowels %s!",ch->name,victim->name);
                        send_to_char(buf,ch);                                   
                        act(buf,ch,NULL,NULL,TO_ROOM);                          
                        do_get(ch,"intestines");                            
                        if (victim->hit >= 300)                                 
                        {                                                       
                                sh_int power;                                   
                                sh_int dam;                                     
                                power = 100;                                    
                                dam = dice(power, power + 2);                   
                                if (dam < 0) dam = 0;                           
                                if (dam > ch->max_hit) dam = (ch->max_hit/2);  
                                if (dam > 1500) dam = 1500;                     
                                victim->hit -= dam;                             
                                ch->hit += dam / 2;                             
                                send_to_char(buf,ch);                           
                                return;                                         
                                }                                               
                               }                                                
                              }                                                 
}

void do_hook (CHAR_DATA *ch, char *argument)                                
{                                                                               
        CHAR_DATA *victim;                                                      
        OBJ_DATA *obj;                                                          
        char arg [MAX_INPUT_LENGTH];                                            
        char buf [MAX_STRING_LENGTH];                                           
        argument = one_argument (argument, arg);                                
        if (IS_NPC(ch)) return;                                                 
        if (!IS_CLASS(ch, CLASS_MUMMY))                                         
        {                                                                       
                send_to_char("Huh?\n\r",ch);                                    
                return;                                                         
        }                                                                       
       if (ch->pcdata->powers[MUM_ANUBIS] < 2)                                 
        {                                                                       
                send_to_char("You haven't asked your deity Anubis for this power yet.\n\r",ch);  
                return;                                                         
        }                                                                       
        if ( arg[0] == '\0' )                                                   
        {                                                                       
                send_to_char("Whose time hath come?\n\r",ch);             
                return;                                                         
        }                                                                       
       victim = get_char_room(ch, arg);                                        
        if ( ( victim = get_char_room( ch, arg) ) == NULL )                     
        {                                                                       
                send_to_char("They arent here.\n\r",ch);                        
                return;                                                         
        }                                                                       
        if (IS_SET(victim->in_room->room_flags, ROOM_SAFE))                     
        {                                                                       
                send_to_char("You cannot attack them here.\n\r",ch);            
                return;                                                         
        }                                                                       
        if (is_safe(ch,victim) == TRUE)                                         
                return;                                                         
        if (IS_SET(victim->loc_hp[9],LOST_BRAIN))                               
        {                                                                       
                send_to_char("You have already prepared their brains for the afterlife!\n\r",ch);    
                return;                                                         
        }                                                                       
        if (number_percent ( ) < 45 )                                           
        {                                                                       
               if (!IS_SET(victim->loc_hp[9],LOST_BRAIN))                      
                {                                                               
                       SET_BIT(victim->loc_hp[9],LOST_BRAIN);                   
                        if ((obj = get_eq_char( victim, WEAR_HEAD )) !=NULL)   
                                take_item(victim,obj);                          
                        make_part(victim,"brain");                              
                        sprintf(buf, "%s drives a hooked pole up %s's nose, and rips the brain out!",ch->name,victim->name);
                        send_to_char(buf,ch);                                   
                        act(buf,ch,NULL,NULL,TO_ROOM);                          
                        do_get(ch,"brain");                                     
                        if (victim->hit >= 300)                                 
                        {                                                       
                                sh_int power;                                   
                                sh_int dam;                                     
                                power = 100;                                    
                                dam = dice(power, power + 2);                   
                                if (dam < 0) dam = 0;                           
                                if (dam > ch->max_hit) dam = (ch->max_hit/2);  
                                if (dam > 1500) dam = 1500;                     
                               victim->hit -= dam;                             
                                send_to_char(buf,ch);                           
                                return;                                         
                                }                                               
                               }                                                
                              }                                                 
}                                                                               

void do_lung (CHAR_DATA *ch, char *argument) 
{                                                                               
        CHAR_DATA *victim;                                                      
        OBJ_DATA *obj;                                                          
        char arg [MAX_INPUT_LENGTH];                                            
        char buf [MAX_STRING_LENGTH];                                           
        argument = one_argument (argument, arg);                                
        if (IS_NPC(ch)) return;                                                 
        if (!IS_CLASS(ch, CLASS_MUMMY))                                         
        {                                                                       
                send_to_char("Huh?\n\r",ch);                                    
                return;                                                         
        }                                                                       
       if (ch->pcdata->powers[MUM_ANUBIS] < 3)                                  
        {                                                                       
        send_to_char("You haven't asked your deity Anubis for this power yet.\n\r",ch);
                return;                                                         
        }                                                                       
        if ( arg[0] == '\0' )                                                   
        {                                                                       
               send_to_char("Whose time hath come?\n\r",ch);                   
                return;                                                         
        }                                                                       
        victim = get_char_room(ch, arg);                                        
        if ( ( victim = get_char_room( ch, arg) ) == NULL )                     
        {                                                                       
                send_to_char("They arent here.\n\r",ch);                        
                return;                                                         
        }                                                                       
        if (IS_SET(victim->in_room->room_flags, ROOM_SAFE))                     
       {                                                                       
                send_to_char("You cannot attack them here.\n\r",ch);            
                return;                                                         
        }                                                                       
       if (is_safe(ch,victim) == TRUE)                                          
                return;                                                         
        if (IS_SET(victim->garou2,MISSING_LUNGS))                          
        {                                                                       
                send_to_char("You have already removed their lungs!\n\r",ch);
                return;                                                         
       }                                                                       
        if (number_percent ( ) < 45 )                                           
        {                                                                       
                if (!IS_SET(victim->garou2,MISSING_LUNGS))
               {                                                                
                       SET_BIT(victim->garou2,MISSING_LUNGS);              
                        if ((obj = get_eq_char( victim, WEAR_BODY )) !=NULL)   
                                take_item(victim,obj);                          
                        make_part(victim,"lungs");                              
                        sprintf(buf, "%s rips the lungs out of %s!",ch->name,victim->name);
                       send_to_char(buf,ch);                                   
                        act(buf,ch,NULL,NULL,TO_ROOM);                          
                        do_get(ch,"lungs");                                
                        if (victim->hit >= 300)                                 
                        {                                                       
                                sh_int power;                                   
                                sh_int dam;                                     
                                power = 100;                                    
                                dam = dice(power, power + 2);                   
                                if (dam < 0) dam = 0;                           
                               if (dam > ch->max_hit) dam =(ch->max_hit/2);   
                                if (dam > 1500) dam = 1500;                     
                                victim->hit -= dam;                             
                                ch->hit += dam / 2;                             
                                send_to_char(buf,ch);                           
                                return;                                         
                                }                                               
                               }                                                
                              }                                                 
}                                                                               

