/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,
 *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"

/*
 * Local functions.
 */

void	adv_spell_damage	args( ( CHAR_DATA *ch, OBJ_DATA *book, 
				OBJ_DATA *page, char *argument) );
void	adv_spell_affect	args( ( CHAR_DATA *ch, OBJ_DATA *book, 
				OBJ_DATA *page, char *argument) );
void	adv_spell_action	args( ( CHAR_DATA *ch, OBJ_DATA *book, 
				OBJ_DATA *page, char *argument) );
void	birth_write		args( ( CHAR_DATA *ch, char *argument ) );
bool	birth_ok		args( ( CHAR_DATA *ch, char *argument ) );

/* Need to get rid of those flames somehow - KaVir */

void do_level( CHAR_DATA *ch, char *argument )  {
    char arg       [MAX_INPUT_LENGTH];
    char skill  [40];  
   /* char stance [20];*/
    one_argument( argument, arg );

    if (IS_NPC(ch)) return;  
    

    stc("#o    ---> #lWeapon Levels#o <---#n\n\r",ch);
    stc("\n\r",ch);
    sprintf(skill, "#cUnarmed#o: #g%d  #7**    #cSlice#o: #g%d#n\n\r",
    ch->wpn[0], ch->wpn[1]);
    stc(skill,ch);
    sprintf(skill, "#cStab#o: #g%d     #7**    #cSlash#o: #g%d#n\n\r",
    ch->wpn[2], ch->wpn[3]);
    stc(skill,ch);
    sprintf(skill, "#cWhip#o: #g%d     #7**    #cClaw#o: #g%d#n\n\r",
    ch->wpn[4], ch->wpn[5]);
    stc(skill,ch);
    sprintf(skill, "#cBlast#o: #g%d    #7**    #cPound#o: #g%d#n\n\r",
    ch->wpn[6], ch->wpn[7]);
    stc(skill,ch);
    sprintf(skill, "#cCrush#o: #g%d    #7**    #cGrep#o: #g%d#n\n\r",
    ch->wpn[8], ch->wpn[9]);
    stc(skill,ch);
    sprintf(skill, "#cBite#o: #g%d     #7**    #cPierce#o: #g%d#n\n\r",
    ch->wpn[10], ch->wpn[11]);
    stc(skill,ch);
    sprintf(skill, "#cSuck#o: #g%d     #7**    #cChop#o: #g%d#n\n\r",
    ch->wpn[12], ch->wpn[13]);
    stc(skill,ch);
    stc("\n\r",ch);
    stc("#o    ---> #rStance Levels #o<---#n\n\r",ch);
    stc("\n\r",ch);
    sprintf(skill, "#cViper#o: #g%d     #7**    #cCrane#o: #g%d#n\n\r",
    ch->stance[1], ch->stance[2]);
    stc(skill,ch);
    sprintf(skill, "#cCrab#o: #g%d      #7**    #cMongoose#o: #g%d#n\n\r",
    ch->stance[3], ch->stance[4]);
    stc(skill,ch);
    sprintf(skill, "#cBull#o: #g%d      #7**    #cMantis#o: #g%d#n\n\r",
    ch->stance[5], ch->stance[6]);
    stc(skill,ch);
    sprintf(skill, "#cDragon#o: #g%d    #7**    #cTiger#o: #g%d#n\n\r",
    ch->stance[7], ch->stance[8]);
    stc(skill,ch);
    sprintf(skill, "#cMonkey#o: #g%d    #7**    #cSwallow#o: #g%d#n\n\r",
    ch->stance[9], ch->stance[10]);
    stc(skill,ch);
    sprintf(skill, "#cWolf#o: #g%d      #7**    #cDog#o: #g%d#n\n\r",
    ch->stance[11], ch->stance[12]);
    stc(skill,ch);
    sprintf(skill, "#cSquirrel#o: #g%d  #7**    #cGrasshopper#o: #g%d#n\n\r",
    ch->stance[13], ch->stance[14]);
    stc(skill,ch);
    sprintf(skill, "#cButterfly#o: #g%d #7**    #cWasp#o: #g%d#n\n\r",
    ch->stance[15], ch->stance[16]);
    stc(skill,ch);
    stc("\n\r",ch);
    stc("#o    ---> #rM#7a#lg#ci#oc #gL#pe#rv#le#yl#Ps #o<---#n\n\r",ch);
    stc("\n\r",ch);
    if (IS_ITEMAFF(ch, ITEMA_AFFENTROPY))
    sprintf(skill,"#5Purple#o: #c%-4d  #7**   #rRed#o: #c%d#n\n\r",
    ch->spl[0] + 20, ch->spl[1] + 20);
    else sprintf(skill,"#5Purple#o: #c%-4d   #7**   #rRed#o: #c%d#n\n\r",
    ch->spl[0], ch->spl[1]);
    stc( skill, ch );
    if (IS_ITEMAFF(ch, ITEMA_AFFENTROPY))
    sprintf(skill,"#lBlue#o: #c%-4d     #7**   #gGreen#o: #c%d#n\n\r",
    ch->spl[2] + 20, ch->spl[3] + 20);
    else sprintf(skill,"#lBlue#o: #c%-4d     #7**   #gGreen#o: #c%d#n\n\r",
    ch->spl[2], ch->spl[3]);
    stc( skill, ch );
    if (IS_ITEMAFF(ch, ITEMA_AFFENTROPY))
    sprintf(skill,"#oYellow#o: #c%-4d   #7**   #yOrange#o: #c%d#n\n\r",
    ch->spl[4] + 20, ch->spl[5] + 20);
    else sprintf(skill,"#oYellow#o: #c%-4d   #7**   #yOrange#o: #c%d#n\n\r",
    ch->spl[4], ch->spl[5]);
    stc( skill, ch );
    if (IS_ITEMAFF(ch, ITEMA_AFFENTROPY))
    sprintf(skill,"#LIndigo#o: #c%-4d   #7**   #pViolet#o: #c%d#n\n\r",
    ch->spl[6] + 20, ch->spl[7] + 20);
    else sprintf(skill,"#LIndigo#o: #c%-4d   #7**   #pViolet#o: #c%d#n\n\r",
    ch->spl[6], ch->spl[7]);
    stc( skill, ch );
    if (IS_ITEMAFF(ch, ITEMA_AFFENTROPY))
    sprintf(skill,"#cCyan#o: #c%-4d     #7**   #7White#o: #c%d#n\n\r",
    ch->spl[8] + 20, ch->spl[9] + 20);
    else sprintf(skill,"#cCyan#o: #c%-4d     #7**   #7White#o: #c%d#n\n\r",
    ch->spl[8], ch->spl[9]);
    stc( skill, ch );
    stc( "\n\r", ch );
    stc("#o    ---> #c Misc. Items #o<---#n\n\r",ch);
    stc( "\n\r",ch);
    sprintf(skill, "#GRecall Room#y :#7 %d\n\r", ch->home);
    stc( skill, ch );
    stc("\n\r",ch);
    stc("#o    ---> #p Class Stuff #o<---#n\n\r",ch);
    stc("\n\r",ch);
    if ( IS_CLASS(ch, CLASS_DEMON) )
     send_to_char("You are a demon!\n\r", ch);
    if ( IS_CLASS(ch, CLASS_MAGE) )
     send_to_char("You are a battlemage!\n\r", ch);    
     if ( IS_CLASS(ch ,CLASS_SHAPESHIFTER))
       send_to_char("You are a shapeshifter!\n\r",ch);
     if (IS_CLASS(ch, CLASS_UNDEAD_KNIGHT))
       send_to_char("You are an undead knight!\n\r",ch);
     if ( IS_CLASS(ch, CLASS_WEREWOLF) )
     send_to_char("You are a werewolf!\n\r", ch);
     if ( IS_CLASS(ch, CLASS_NINJA) )
     send_to_char("You are a ninja!\n\r", ch);
    if ( IS_CLASS(ch, CLASS_VAMPIRE) )
     send_to_char("You are a vampire!\n\r", ch);
    if ( IS_CLASS(ch, CLASS_HIGHLANDER) )
     send_to_char("You are a Samurai!\n\r", ch);
    if ( IS_CLASS(ch, CLASS_DROW) )
     send_to_char("You are a drow!\n\r", ch);    
    if (IS_CLASS(ch, CLASS_ANGEL))
     send_to_char("You are an angel!\n\r", ch);
    if (IS_CLASS(ch, CLASS_TANARRI))
     send_to_char("You are a Tanar'ri.\n\r",ch);
    if( IS_CLASS(ch, CLASS_MONK) )
	stc( "You are a monk!\n\r",ch);
    if( IS_CLASS(ch, CLASS_CYBORG))
	stc( "You are a Cyborg!\n\r",ch);
    if( IS_CLASS(ch, CLASS_XOMBI))
	stc( "You are a Xombi!\n\r",ch);
    if( IS_CLASS(ch, CLASS_JEDI))
        stc( "You are a Jedi!\n\r",ch);
    if( IS_CLASS(ch, CLASS_MECHA))
	stc("You are a MechaWarrior!\n\r",ch);
    sprintf(skill, "Generation : %d\n\r", ch->generation); 
    send_to_char( skill, ch );
 if (IS_CLASS(ch, CLASS_TANARRI))
 {
  if (ch->pcdata->rank == TANARRI_FODDER)
    send_to_char("You are nothing but fodder for the great war.\n\r",ch);
  if (ch->pcdata->rank == TANARRI_FIGHTER)
    send_to_char("You are a fighter in the great war.\n\r",ch);
  if (ch->pcdata->rank == TANARRI_ELITE)
    send_to_char("You are an elite warrior in the great war.\n\r",ch);
  if (ch->pcdata->rank == TANARRI_CAPTAIN)
    send_to_char("You are a captain in the great war.\n\r",ch);
  if (ch->pcdata->rank == TANARRI_WARLORD)
    send_to_char("You are a warlord in the great war.\n\r",ch);
  if (ch->pcdata->rank == TANARRI_BALOR)
    send_to_char("You are a Tanar'ri Balor.\n\r",ch);
 } 

 if (IS_CLASS(ch, CLASS_VAMPIRE) )
 {

	if (ch->pcdata->rank == AGE_TRUEBLOOD)
	  send_to_char("You are a TrueBlood!\n\r",ch);
	else if (ch->pcdata->rank == AGE_LA_MAGRA)
	  send_to_char("You are a La Magra!\n\r",ch);
	else if (ch->pcdata->rank == AGE_METHUSELAH)
	  send_to_char("You are a Methuselah!\n\r",ch);
	else if (ch->pcdata->rank == AGE_ELDER)
	  send_to_char("You are an Elder!\n\r",ch);
	else if (ch->pcdata->rank == AGE_ANCILLA)
	  send_to_char("You are an Ancilla!\n\r",ch);
	else if (ch->pcdata->rank == AGE_NEONATE)
	  send_to_char("You are a Neonate!\n\r", ch);
	else
	  send_to_char("You are a Childe!\n\r", ch);
	if ( IS_SET(ch->special, SPC_PRINCE) )
	  send_to_char("You are a prince!\n\r", ch);
 }
 
 if (IS_CLASS(ch, CLASS_NINJA)&&!IS_CLASS(ch, CLASS_VAMPIRE) && !IS_CLASS(ch, CLASS_WEREWOLF) )
 {
	if ( IS_SET(ch->special, SPC_PRINCE) )
	  send_to_char("You can discipline people!\n\r", ch);
 }
 
}

