/**************************************************************************     
 ** Voodoo skill redone - by Wolfman for Prometheus Unbound Mud (c) 2001 **
 **************************************************************************/    
                                                                                
#if defined(macintosh)                                                          
#include <types.h>                                                              
#else                                                                           
#include <sys/types.h>                                                          
#include <sys/time.h>                                                           
#endif                                                                          
#include <stdio.h>                                                              
#include <string.h>                                                             
#include <stdlib.h>                                                             
#include <ctype.h>                                                              
#include <time.h>                                                               
#include "merc.h"                                                               

/* Voodoo skill originally by KaVir */                                                     
                                                                                
void do_voodoo( CHAR_DATA *ch, char *argument )                                 
{                                                                               
  CHAR_DATA *victim;                                                            
  OBJ_DATA  *obj;                                                               
  char arg1 [MAX_INPUT_LENGTH];                                                 
  char arg2 [MAX_INPUT_LENGTH];                                                 
  char arg3 [MAX_INPUT_LENGTH];
  char buf [MAX_INPUT_LENGTH];                                                  
  char buffy [MAX_STRING_LENGTH];
  char part1 [MAX_INPUT_LENGTH];                                                
  char part2 [MAX_INPUT_LENGTH];                                                

  argument = one_argument( argument, arg1 );                                    
  argument = one_argument( argument, arg2 );                                    
  argument = one_argument( argument, arg3 );

  if ( arg1[0] == '\0')                                                         
  {                                                                             
    send_to_char( "Who do you wish to use voodoo magic on?\n\r", ch );          
    return;                                                                     
  }                                                                             
  if ( ( obj = get_eq_char( ch, WEAR_HOLD ) ) == NULL )                         
  {                                                                             
    send_to_char( "You are not holding a voodoo doll.\n\r", ch );               
    return;                                                                     
  }                                                                             
  if ( ( victim = get_char_world( ch, arg1 ) ) == NULL )                        
  {                                                                             
    send_to_char( "They are not here.\n\r", ch );                               
    return;                                                                     
  }                                                                             
  if ( IS_NPC(victim) )                                                         
  {                                                                             
    send_to_char( "Not on NPC's.\n\r", ch );                                    
    return;                                                                     
  }                                                                             
  sprintf(part2,obj->name);                                                     
  sprintf(part1,"%s voodoo doll",victim->name);                                 
  if ( str_cmp(part1,part2) )                                                   
  {                                                                             
    sprintf(buf,"But you are holding %s, not %s!\n\r",obj->short_descr,victim->name);
    send_to_char( buf, ch );                                                    
    return;                                                                     
  }                                                                             
  if ( arg2[0] == '\0')                                                         
  {
  send_to_char( "Using Voodoo, You can create havoc with another\n\r",ch);
  send_to_char( "player through the use of violence against the doll,\n\r",ch);
  send_to_char( "like to: 'stab', 'burn' or 'throw' the doll.\n\r", ch ); 
  send_to_char( "You may also use your voodoo doll as a charm to 'order'\n\r",ch);
  send_to_char( "your victim to do things, and 'force' them to follow you.\n\r",ch);
  }
  else if ( !str_cmp(arg2, "stab") )                                            
  {                                                                             
    WAIT_STATE(ch,12);                                                          
    act("You stab a pin through $p.", ch, obj, NULL, TO_CHAR);                  
    act("$n stabs a pin through $p.", ch, obj, NULL, TO_ROOM);                  
    act("You feel an agonising pain in your chest!", victim, NULL, NULL, TO_CHAR);
    act("$n clutches $s chest in agony!", victim, NULL, NULL, TO_ROOM);         
  }
  else if ( !str_cmp(arg2, "order") )
  {
    WAIT_STATE(ch,4);
    sprintf( buffy, "%s %s", arg3, argument );                                  
    if (IS_NPC(victim))                                                         
        sprintf( buf, "I order %s to %s",victim->short_descr,buffy);      
    else if (!IS_NPC(victim) && IS_AFFECTED(victim, AFF_POLYMORPH))             
        sprintf( buf, "I order %s to %s", victim->morph,buffy);           
   else                                                                        
        sprintf( buf, "I order %s to %s", victim->name,buffy);            
    do_say(ch,buf);                                                             
    act("You blink in confusion.",victim,NULL,NULL,TO_CHAR);                    
    act("$n blinks in confusion.",victim,NULL,NULL,TO_ROOM);                    
    strcpy(buf,"Yes, Master...");                                   
    do_say(victim,buf);                                                         
    interpret( victim, buffy );                                               
    }                                                                               
  else if ( !str_cmp(arg2, "force") )                                           
  {                                                                             
    WAIT_STATE(ch,4);                                                           
    if (IS_NPC(victim))                                                         
    act("You blink in confusion.",victim,NULL,NULL,TO_CHAR);                    
    act("$n blinks in confusion.",victim,NULL,NULL,TO_ROOM);                    
    strcpy(buf,"My master has commanded me to follow... I shall follow my master.");
    do_say(victim,buf);
    sprintf(buf, "%s",ch->name); 
    do_follow( victim, buf );
    }
  else if ( !str_cmp(arg2, "burn") )                                            
  {                                                                             
    WAIT_STATE(ch,12);                                                          
    act("You set fire to $p.", ch, obj, NULL, TO_CHAR);                         
    act("$n sets fire to $p.", ch, obj, NULL, TO_ROOM);                         
    act("$p burns to ashes.", ch, obj, NULL, TO_CHAR);                          
    act("$p burns to ashes.", ch, obj, NULL, TO_ROOM);                          
    obj_from_char(obj);                                                         
    extract_obj(obj);                                                           
    if (IS_AFFECTED(victim,AFF_FLAMING) )                                       
      return;                                                                   
    SET_BIT(victim->affected_by, AFF_FLAMING);                                  
    act("You suddenly burst into flames!", victim, NULL, NULL, TO_CHAR);        
    act("$n suddenly bursts into flames!", victim, NULL, NULL, TO_ROOM);        
  }                                                                             
  else if ( !str_cmp(arg2, "throw") )                                           
  {                                                                             
    WAIT_STATE(ch,12);                                                          
    act("You throw $p to the ground.", ch, obj, NULL, TO_CHAR);                 
    act("$n throws $p to the ground.", ch, obj, NULL, TO_ROOM);                 
    obj_from_char(obj);                                                         
    obj_to_room(obj, ch->in_room);                                              
    if (victim->position < POS_STANDING) return;                                
    if (victim->position == POS_FIGHTING)                                       
      stop_fighting(victim, TRUE);                                              
    act("A strange force picks you up and hurls you to the ground!", victim, NULL, NULL, TO_CHAR);
    act("$n is hurled to the ground by a strange force.", victim, NULL, NULL, TO_ROOM);
    victim->position = POS_RESTING;                                             
    victim->hit = victim->hit - number_range(ch->level,(5*ch->level));          
    update_pos(victim);                                                         
    if (victim->position == POS_DEAD && !IS_NPC(victim))                        
    {                                                                           
      do_killperson(ch,victim->name);                                           
      return;                                                                   
    }                                                                           
  }                                                                             
return;
}

