/************************************WINDOWS*******************************     
                         Voltec's Window code (c) 1998                     
***************************************************************************/    
                                                                                
#if defined(macintosh)                                                          
#include <types.h>                                                              
#else                                                                           
#include <sys/types.h>                                                          
#include <sys/time.h>                                                           
#endif                                                                          
#include <stdio.h>                                                              
#include <string.h>                                                             
#include <stdlib.h>                                                             
#include <ctype.h>                                                              
#include <time.h>                                                               
#include "merc.h"                                                               

void look_window( CHAR_DATA *ch, OBJ_DATA *obj ) 
   {
    char 			 buf[MAX_STRING_LENGTH];
    ROOM_INDEX_DATA *window_room;   

	if ( obj->value[0] == 0 )
       {
	   sprintf(buf, "%s\n\r", obj->description );
	   send_to_char(buf, ch);
	   return;
	   }

	window_room = get_room_index( obj->value[0] );

	if ( window_room == NULL )
	   {
	   send_to_char( "!!BUG!! Window looks into a NULL room! Please report!\n\r", ch );
	   bug( "Window %d looks into a null room!!!", obj->pIndexData->vnum );
	   return;
	   }
		 
	if ( !IS_NPC(ch) )
	  {
	  send_to_char( "Looking through the window you can see ",ch);
	  send_to_char( window_room->name, ch );
	  send_to_char( "\n\r", ch);
	  show_list_to_char( window_room->contents, ch, FALSE, FALSE );
	  show_char_to_char( window_room->people,   ch );
	  return;
	  }
   }
