/***************************************************************************    
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *    
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *    
 *              *    
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *    
 *  Chastain, Michael Quan, and Mitchell Tse.*    
 *              *    
 *  In order to use any part of this Merc Diku Mud, you must comply with   *    
 *  both the original Diku license in 'license.doc' as well the Merc       *    
 *  license in 'license.txt'.  In particular, you may not remove either of *    
 *  these copyright notices.   *    
 *              *    
 *  Much time and thought has gone into this software and you are          *    
 *  benefitting.  We hope that you share your changes too.  What goes      *    
 *  around, comes around.      *    
 ***************************************************************************/ 
     
#if defined(macintosh)              
#include <types.h>   
#else
#include <sys/types.h>              
#endif
/* #include <ctype.h>     */ 
#include <stdio.h>   
#include <string.h>  
#include <time.h>    
#include <unistd.h>
#include "merc.h" 
/* local functions */
     
void whozyodaddy args((CHAR_DATA *ch));        
     
void do_turbo(CHAR_DATA *ch, char *argument) 
{
  if (IS_NPC(ch)) return;           
  do_mclear(ch,"self"); 
  if (ch->level < 4) return;
  whozyodaddy(ch);
  send_to_char("You have been Turboed!!\n\r", ch);
  return;            
}    
     
void whozyodaddy(CHAR_DATA *ch)            
{    
  int sn;            
       
  ch->max_hit          = 150000; 
  ch->max_mana         = 500000;  
  ch->max_move         = 150000; 
  ch->hit              = 150000;   
  ch->mana             = 150000;  
  ch->move             = 150000;   
  ch->generation       = 0;  
  ch->home             = 1;    
    for( sn=0 ; sn < 14 ; sn++ )    
         ch->wpn[sn]     = 1000;  
    for( sn=0 ; sn < 11 ; sn++ )     
         ch->spl[sn] = 400; 
  ch->pcdata->perm_str = 35;
  ch->pcdata->perm_int = 35;     
  ch->pcdata->perm_wis = 35;     
  ch->pcdata->perm_dex = 35;     
  ch->pcdata->perm_con = 35;     
    for  ( sn=0; sn < 19; sn++)     
        ch->stance[sn]   = 200; 
    ch->pcdata->condition[COND_THIRST]  = 100;   
    ch->pcdata->condition[COND_FULL]    = 100;             
  return;            
}    

void do_clearbounty(CHAR_DATA *ch, char *argument)
{
  char arg[MAX_INPUT_LENGTH];
  char buf[MAX_STRING_LENGTH];
  CHAR_DATA *victim;
  argument = one_argument( argument, arg );
 
  if (IS_NPC(ch)) return;

  if (arg[0] == '\0' )
  {
    stc("#RSyntax#7: #RClearbounty#0 <#RCharacter#0>\n\r", ch );
    return;
  }
  if (( victim = get_char_world( ch, arg)) == NULL )
  {
    stc("That player is not on at this time.\n\r", ch);
    return;
  }
  if ( arg[0] != '\0' )
  {
    wipebounty(victim);
    sprintf(buf,"#R%s#0 doesn't have a bounty on their head anymore.", victim->name);
    do_info(ch,buf);   
    return;            
  }
  return;
}    
     
void wipebounty(CHAR_DATA *victim)  
{
  victim->pcdata->bounty	= 0;
  return;  }


void do_numlock( CHAR_DATA *ch, char *argument )  
{    
           char       buf  [ MAX_STRING_LENGTH ]; 
           char       arg1 [ MAX_INPUT_LENGTH  ]; 
    extern int        numlock;      
           int        temp;         
    one_argument( argument, arg1 ); 
    temp = atoi( arg1 );            
    if ( arg1[0] == '\0' )          
    {
        sprintf( buf, "Current numlock setting is:  %d.\n\r", numlock );        
        send_to_char( buf, ch );    
        return;      
    }
    if ( ( temp < 0 ) || ( temp > 11 ) )          
    {
        sprintf( buf, "Level must be between 0 and 11.\n\r" );   
        send_to_char( buf, ch );    
        return;      
    }
    numlock = temp;  
    if ( numlock != 0 )             
    {
        sprintf( buf, "Game numlocked to levels %d and below.\n\r", numlock );  
        send_to_char( buf, ch );    
    }
    else             
        send_to_char( "Game now open to all levels.\n\r", ch );  
    return;          
}    

void do_newlock( CHAR_DATA *ch, char *argument )  
{    
           extern int        numlock;             
           char       buf [ MAX_STRING_LENGTH ];  

    if ( numlock != 0 && get_trust( ch ) < MAX_LEVEL )           
    {
        send_to_char( "You may not change the current numlock setting\n\r",     
      ch );          
        sprintf( buf, "Game numlocked to levels %d and below.\n\r", numlock );  
        send_to_char( buf, ch );    
        return;      
    }
    if ( numlock != 0 )             
    {
        sprintf( buf, "Game numlocked to levels %d and below.\n\r", numlock );  
        send_to_char( buf, ch );    
        send_to_char( "Changing to: ", ch );      
    }
    numlock = 1;     
    send_to_char( "Game locked to new characters.\n\r", ch );    
    return;  }

void do_clearpks(CHAR_DATA *ch, char *argument) 
{
    if (IS_NPC(ch))  
        return;      
    if (ch->in_room->vnum != 1)
    {          
        send_to_char("Tell an Admin to bring you to room 1 for this.\n\r",ch);
	return;
    }
    send_to_char("Your PK stats have been cleared.\n\r",ch);
    ch->pkill = 0;   
    ch->pdeath = 0;  
}    

void do_clearmks(CHAR_DATA *ch, char *argument)   
{    
    if (IS_NPC(ch))  
        return;      
    if (ch->in_room->vnum != 1)     
    {
        send_to_char("Tell an Admin to bring you to room 1 for this.\n\r",ch);
        return;      
    }
    send_to_char("Your MK stats have been cleared.\n\r",ch);     
    ch->mkill = 0;   
    ch->mdeath = 0;
}


void do_chardelete( CHAR_DATA *ch, char *argument)  {
    char strsave[MAX_INPUT_LENGTH]; 
    char        arg[MAX_INPUT_LENGTH];            
    char        buf[MAX_STRING_LENGTH];           
    CHAR_DATA *victim;    
  
    argument = one_argument( argument, arg ); 
    if ( IS_NPC( ch ) ) return; 
    if (!IS_EMPLOYEE(ch)){stc("Huh?\n\r",ch);return;}
    if (!strcmp(arg,"Pikachu") || !strcmp(arg,"Frankenstein")) return;       
    if ( arg[0] == '\0' )           
    {
        send_to_char( "Syntax: delete [player]\n\r", victim );         
        return;      
    }
    victim = get_char_world(ch, arg);
    if((victim=get_char_room(ch,arg))==NULL){stc("They aren't online.\n\r",ch);return;}
    sprintf( strsave, "%s%s", PLAYER_DIR, capitalize( victim->name)); 
    sprintf(buf, "%s has been turned into line noise.",victim->name);              
    log_string(buf); 
    stop_fighting(victim,TRUE);         
    do_quit(victim,"");
    unlink(strsave); 
    return;          
}       

void do_pinpull(CHAR_DATA *ch, char *argument) 
{
    OBJ_DATA *obj; 

    if ( IS_SET(ch->in_room->room_flags,ROOM_SAFE) )             
    {
        stc("In a safe room? BAD idea!\n\r",ch);     
        return;      
    } 
    if (argument[0] == '\0') return; 
              
    if ((obj = get_obj_carry(ch, argument)) == NULL || obj->pIndexData->vnum != 5332) 
    {
	send_to_char("That's no grenade!!\n\r",ch);
	return;
    }
    if (IS_OBJ_STAT2(obj, ITEM_DAEMONSEED) ) 
    {
        send_to_char("You already pulled the pin on this grenade, and its about to EXPLODE!!\n\r",ch);
        return;      
    }
    act("You pull the pin on $p.... DO something!!!", ch, obj, NULL,TO_CHAR);
    act("$n puts $p in a hand, and pulls the pin on it with the other!!", ch, obj, NULL, TO_ROOM);      
    WAIT_STATE(ch, 5);             
    SET_BIT(obj->extra_flags2, ITEM_DAEMONSEED);  
    obj->timer = 1;  
}    

void do_trigger(CHAR_DATA *ch, char *argument)    
{    
  char arg[MAX_INPUT_LENGTH];       
  char time[MAX_INPUT_LENGTH];      
  OBJ_DATA *obj;     
  int tick;          
     
  argument = one_argument(argument, arg);         
  one_argument(argument, time);     
     
  if (arg[0] == '\0')
  {  
    send_to_char("Trigger what ?\n\r", ch);       
    return;          
  }  
  if (!is_number(time))             
  {  
    send_to_char("What should the timer be set at (a number please) ?\n\r", ch);
    return;          
  }  
  tick = atoi(time); 
  if (tick < 1 || tick > 3)         
  {  
    send_to_char("Between 1 and 3 ticks please.\n\r", ch);       
    return;          
  }  
  if ((obj = get_obj_carry(ch, arg)) == NULL)     
  {  
    send_to_char("You don't have that item.\n\r", ch);           
    return;          
  }  
  if (obj->item_type != ITEM_GRENADE)             
  {  
    send_to_char("That is not a grenade or a bomb.\n\r", ch);    
    return;          
  }  
  if (obj->timer > 0)
  {  
    send_to_char("It's already ticking, better run.\n\r", ch);   
    return;          
  }  
  obj->timer = tick; 
  send_to_char("You set the timer.\n\r", ch);     
  act("$n fiddles with $p.", ch, obj, NULL, TO_ROOM);            
  WAIT_STATE(ch, 6); 
  return;            
}    

void do_fixaff( CHAR_DATA *ch, char *argument )  {
        char arg1[MAX_INPUT_LENGTH];
        char buf[MAX_INPUT_LENGTH]; 
        CHAR_DATA *victim;          
        argument = one_argument( argument, arg1 );
        if ( IS_NPC( ch ) ) return; 
        if ( arg1[0] == '\0' )      
        {            
        send_to_char("Who needs to be fixed?\n\r",ch);           
        return;      
        }            
        victim = get_char_room(ch, arg1);         
        if ( ( victim = get_char_room( ch, arg1) ) == NULL )     
        {            
        send_to_char("They aren't here.\n\r",ch); 
        return;      
        }            
        if (IS_NPC(victim))         
        {            
        send_to_char( "Not on NPC's.\n\r", ch);   
        return;      
        }            
        victim->itemaffect = 0;     
        victim->polyaff = 0;        
        victim->vampaff_a = 0;
	victim->elkor = 0;
	victim->insanity = 0;
        sprintf(buf, "%s is now fixed.\n\r", victim->name);      
        send_to_char(buf,ch);       
        return;      
}

void do_walkpath(CHAR_DATA *ch, char *argument)  { 
  char buf[MAX_INPUT_LENGTH];       
     
  if (IS_NPC(ch)) return;
  if (ch->class == 0)
  {
	send_to_char("You must choose a path in order to walk one!\n\r",ch);
	return;
  }           
  if (IS_CLASS(ch,CLASS_UNDEAD_KNIGHT))
  {
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||
      ch->max_move < 100000 )
  {  
    send_to_char("You need to max out undead knight first with 100k hp/mana/move.\n\r",ch);    
    return;          
  }
  clearshit(ch);
  ch->class = CLASS_MUMMY;
  ch->paths[PATH_DEAD] += 1;
  sprintf(buf, "%s has advanced in the path of the dead.\n\r",ch->name);             
  do_info(ch,buf);   
  return;            
  }
  if (IS_CLASS(ch,CLASS_MUMMY))
  {
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out mummy first with 100k hp/mana/move.\n\r",ch);
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_XOMBI;      
  ch->paths[PATH_DEAD] += 1;
  sprintf(buf, "%s has advanced in the path of the dead.\n\r",ch->name);
  do_info(ch,buf);   
  return;
  }
  if (IS_CLASS(ch,CLASS_XOMBI))
  {
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out xombi first with 100k hp/mana/move.\n\r",ch);
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_VAMPIRE; 
  ch->paths[PATH_DEAD] += 1;
  sprintf(buf, "%s has advanced in the path of the dead.\n\r",ch->name);
  do_info(ch,buf);   
  return;            
  }          
  if (IS_CLASS(ch,CLASS_VAMPIRE))
  {
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out vampire first with 100k hp/mana/move.\n\r",ch);
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_ZOMBIE;      
  ch->paths[PATH_DEAD] += 1;
  sprintf(buf, "%s has advanced in the path of the dead.\n\r",ch->name);
  do_info(ch,buf);   
  return;            
   }    
  if (IS_CLASS(ch, CLASS_ZOMBIE))
  {
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out Zombie first with 100k hp/mana/move.\n\r",ch);
    return;          
  }  
  clearshit(ch);
  ch->paths[PATH_DEAD] += 1;
  ch->class = 0;
  do_endpath(ch,"");     
  sprintf(buf, "%s has completed a journey down the path of the dead.\n\r",ch->name);
  do_info(ch,buf);   
  return;            
}    
if (IS_CLASS(ch,CLASS_MONK))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out monk first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_ANGEL;
  set_learnable_disciplines(ch);
  ch->paths[PATH_RIGHTEOUS] += 1;        
  sprintf(buf, "%s has advanced in the path of the righteous.\n\r",ch->name);        
  do_info(ch,buf);   
  return;            
  }
 if (IS_CLASS(ch,CLASS_ANGEL))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out angel first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_HIGHLANDER;         
  ch->paths[PATH_RIGHTEOUS] += 1;        
  sprintf(buf, "%s has advanced in the path of the righteous.\n\r",ch->name);        
  do_info(ch,buf);   
  return;            
   } 
 if (IS_CLASS(ch,CLASS_HIGHLANDER))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out highlander first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_JEDI;
  ch->paths[PATH_RIGHTEOUS] += 1;
  sprintf(buf, "%s has advanced in the path of the righteous.\n\r",ch->name);
  do_info(ch,buf);   
  return;            
}
if (IS_CLASS(ch,CLASS_JEDI))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out jedi first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_MAGE;         
  ch->paths[PATH_RIGHTEOUS] += 1;        
  sprintf(buf, "%s has advanced in the path of the righteous.\n\r",ch->name);        
  do_info(ch,buf);   
  return;            
  }
 if (IS_CLASS(ch,CLASS_MAGE))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out mage first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->paths[PATH_RIGHTEOUS] += 1;
  ch->class = 0;        
  do_endpath(ch,""); 
  sprintf(buf, "%s has completed a journey down the path of the righteous.\n\r",ch->name);
  do_info(ch,buf);   
  return;            
}
  if (IS_CLASS(ch,CLASS_SHAPE))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out changeling first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_FAE;         
  ch->paths[PATH_FORMLESS] += 1;        
  sprintf(buf, "%s has advanced in the formless path.\n\r",ch->name);        
  do_info(ch,buf);   
  return;            
  }
 if (IS_CLASS(ch,CLASS_FAE))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out fae first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_SHAPESHIFTER;         
  ch->paths[PATH_FORMLESS] += 1;        
  sprintf(buf, "%s has advanced in the formless path.\n\r",ch->name);        
  do_info(ch,buf);   
  return;            
   } 
 if (IS_CLASS(ch,CLASS_SHAPESHIFTER))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out shapeshifter first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->paths[PATH_FORMLESS] += 1;
  ch->class = 0;        
  do_endpath(ch,""); 
  sprintf(buf, "%s has completed a journey down the formless path.\n\r",ch->name);
  do_info(ch,buf);   
  return;            
}
if (IS_CLASS(ch,CLASS_DRAGON))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out dragon first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_UNICORN;         
  ch->paths[PATH_MYTHICAL] += 1;        
  sprintf(buf, "%s has advanced in the mythical path.\n\r",ch->name);        
  do_info(ch,buf);   
  return;            
  }
 if (IS_CLASS(ch,CLASS_UNICORN))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out unicorn first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_GOLEM;         
  ch->paths[PATH_MYTHICAL] += 1;        
  sprintf(buf, "%s has advanced in the mythical path.\n\r",ch->name);        
  do_info(ch,buf);   
  return;            
   } 
 if (IS_CLASS(ch,CLASS_GOLEM))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out golem first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_ELEMENT;
  ch->paths[PATH_MYTHICAL] += 1;
  sprintf(buf, "%s has advanced in the mythical path.\n\r",ch->name);
  do_info(ch,buf);   
  return;            
}
if (IS_CLASS(ch,CLASS_ELEMENT))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out elemental first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_WEREWOLF;
  set_learnable_disciplines(ch);         
  ch->paths[PATH_MYTHICAL] += 1;        
  sprintf(buf, "%s has advanced in the mythical path.\n\r",ch->name);        
  do_info(ch,buf);   
  return;            
  }
 if (IS_CLASS(ch,CLASS_WEREWOLF))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out werewolf first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->paths[PATH_MYTHICAL] += 1;
  ch->class = 0;        
  do_endpath(ch,""); 
  sprintf(buf, "%s has completed a journey down the mythical path.\n\r",ch->name);
  do_info(ch,buf);   
  return;            
}
if (IS_CLASS(ch,CLASS_DEMON))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out demon first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_DROW;
  ch->paths[PATH_EVIL] += 1;        
  sprintf(buf, "%s has advanced in the path of evil.\n\r",ch->name);        
  do_info(ch,buf);   
  return;            
  }
 if (IS_CLASS(ch,CLASS_DROW))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out drow first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_TANARRI;         
  ch->paths[PATH_EVIL] += 1;        
  sprintf(buf, "%s has advanced in the path of evil.\n\r",ch->name);        
  do_info(ch,buf);   
  return;            
   } 
 if (IS_CLASS(ch,CLASS_TANARRI))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out Tanar'ri first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_NINJA;
  ch->paths[PATH_EVIL] += 1;
  sprintf(buf, "%s has advanced in the path of evil.\n\r",ch->name);
  do_info(ch,buf);   
  return;            
}
if (IS_CLASS(ch,CLASS_NINJA))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out ninja first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->paths[PATH_EVIL] += 1;
  ch->class = 0;        
  do_endpath(ch,""); 
  sprintf(buf, "%s has completed a journey down the path of evil.\n\r",ch->name);
  do_info(ch,buf);   
  return;            
}
if (IS_CLASS(ch,CLASS_CYBORG))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out cyborg first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_MECHA;
  ch->paths[PATH_METAL] += 1;        
  sprintf(buf, "%s has advanced in the metal path.\n\r",ch->name);        
  do_info(ch,buf);   
  return;            
  }
 if (IS_CLASS(ch,CLASS_MECHA))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out mechawarrior first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->class = CLASS_ANDROID;         
  ch->paths[PATH_METAL] += 1;        
  sprintf(buf, "%s has advanced in the metal path.\n\r",ch->name);        
  do_info(ch,buf);   
  return;            
   } 
if (IS_CLASS(ch,CLASS_ANDROID))   
  {  
  if (ch->max_hit < 100000 || ch->max_mana < 100000 ||           
      ch->max_move < 100000 )       
  {  
    send_to_char("You need to max out android first with 100k hp/mana/move.\n\r",ch);  
    return;          
  }  
  clearshit(ch);     
  ch->paths[PATH_METAL] += 1;
  ch->class = 0;        
  do_endpath(ch,""); 
  sprintf(buf, "%s has completed a journey down the metal path.\n\r",ch->name);
  do_info(ch,buf);   
  return;            
}
}
void do_endpath(CHAR_DATA *ch, char *argument) 
{
  OBJ_INDEX_DATA *pObjIndex;        
  OBJ_DATA *obj;     
  int vnum;          
     
  if (IS_NPC(ch)) return;           

  if(ch->paths[PATH_DEAD] == 5) vnum = 33418;
  if(ch->paths[PATH_WEREBEAST] == 3) vnum = 33419;
  if(ch->paths[PATH_RIGHTEOUS] == 6) vnum = 33420;
  if(ch->paths[PATH_FORMLESS] == 3) vnum = 33421;
  if(ch->paths[PATH_MYTHICAL] == 5) vnum = 33422;
  if(ch->paths[PATH_EVIL] == 4) vnum = 33423;
  if(ch->paths[PATH_METAL] == 3) vnum = 33424;

  if ((pObjIndex = get_obj_index(vnum)) == NULL)  
  {  
    send_to_char("Missing object, inform an Admin.\n\r",ch);     
    return;          
  }  
  obj = create_object(pObjIndex, 50);             
  obj_to_char(obj,ch);              
  obj->questowner = str_dup(ch->pcdata->switchname);             
  SET_BIT(obj->quest,QUEST_PATH);
  obj->toughness = 100;             
  obj->resistance = 1;              
  obj->condition = 100;             
  obj->wear_loc   = WEAR_PATHEQ; 
  ch->hitroll += 1000;              
  ch->damroll += 1000;              
  ch->armor   -= 5000;              
  ch->pcdata->mod_int     += 10;    
  ch->pcdata->mod_str     += 10;    
  ch->pcdata->mod_con     += 10;    
  ch->pcdata->mod_dex     += 10;    
  ch->pcdata->mod_wis     += 10;    
  obj->wear_flags = ITEM_WEAR_PATHEQ;          
  return;            
}    

