/************************************
 * Death's Domain Zombie Class File *
 *      By Wolfman, (C) 2001        *
 ************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "player.h"
#include "zombie.h"

void zombpowers( CHAR_DATA *ch, char *argument )
{
	char buf[MAX_STRING_LENGTH];
	char arg1[MAX_INPUT_LENGTH];
	char arg2[MAX_INPUT_LENGTH];

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

  if (IS_NPC(ch)) return; 
  if (!IS_CLASS(ch, CLASS_ZOMBIE))
  {send_to_char("Huh?\n\r",ch); return;}
  if (arg1[0] == '\0' && arg2[0] == '\0'){
  sprintf(buf,"Zombie Powers: Flesh (%d), Mind (%d), Body (%d)\n\r",
  ch->pcdata->powers[ZOMB_FLESH], ch->pcdata->powers[ZOMB_MIND],
  ch->pcdata->powers[ZOMB_BODY]);
  send_to_char(buf,ch);
  return;}
  if (arg2[0] == '\0'){
  if (!str_cmp(arg1,"flesh")){
  if ( ch->pcdata->powers[ZOMB_FLESH] == 0 )
    send_to_char("      Flesh: None.\n\r",ch);
  if ( ch->pcdata->powers[ZOMB_FLESH] >= 1 )
    send_to_char("      Flesh: Skin",ch);
  if ( ch->pcdata->powers[ZOMB_FLESH] >= 2 )
    send_to_char("      Flesh: Feast",ch);
  if ( ch->pcdata->powers[ZOMB_FLESH] >= 3 )
    send_to_char("      Flesh: Rip",ch);
  if ( ch->pcdata->powers[ZOMB_FLESH] >= 4 )
    send_to_char("      Flesh: Tend",ch);
  if ( ch->pcdata->powers[ZOMB_FLESH] >= 5 )
    send_to_char("      Flesh: Fillet",ch);
  if ( ch->pcdata->powers[ZOMB_FLESH] >= 6 )
    send_to_char("      Flesh: StrongFlesh",ch);
  if ( ch->pcdata->powers[ZOMB_FLESH] >= 7 )
    send_to_char("      Flesh: Detongue",ch);
  return;} 

  else if (!str_cmp(arg1,"mind")){
  if ( ch->pcdata->powers[ZOMB_MIND] == 0 ) 
    send_to_char("  Mind: None.\n\r",ch);
  if ( ch->pcdata->powers[ZOMB_MIND] >= 1 )
    send_to_char("      Mind:  Lobotomy",ch);
  if ( ch->pcdata->powers[ZOMB_MIND] >= 2 )
    send_to_char("      Mind:  Genius",ch);
  if ( ch->pcdata->powers[ZOMB_MIND] >= 3 )
    send_to_char("      Mind:  Sniff",ch);
  return;}

  else if (!str_cmp(arg1,"body")){
  if ( ch->pcdata->powers[ZOMB_BODY] == 0 )
    send_to_char("      Body: None.\n\r",ch);
  if ( ch->pcdata->powers[ZOMB_BODY] >= 1 )
    send_to_char("      Body: Denerve",ch);
  if ( ch->pcdata->powers[ZOMB_BODY] >= 2 )
    send_to_char("      Body: Pulp",ch);
  if ( ch->pcdata->powers[ZOMB_BODY] >= 3 )
    send_to_char("      Body: Bonerip",ch);
  if ( ch->pcdata->powers[ZOMB_BODY] >= 4 )
    send_to_char("      Body: Enamel",ch);
  if ( ch->pcdata->powers[ZOMB_BODY] >= 5 )
    send_to_char("      Body: Nails",ch);
  if ( ch->pcdata->powers[ZOMB_BODY] >= 6 )
    send_to_char("      Body: Chew",ch);
  if ( ch->pcdata->powers[ZOMB_BODY] >= 7 )
    send_to_char("      Body: Brainhunt",ch);
  return;}

  sprintf(buf,"Flesh (%d), Mind (%d), Body (%d)\n\r",
  ch->pcdata->powers[ZOMB_FLESH], ch->pcdata->powers[ZOMB_MIND],
  ch->pcdata->powers[ZOMB_BODY]);
  send_to_char(buf,ch);
  return;}

  if(!str_cmp(arg2,"improve")){
  int improve;
  int cost;
  int max;
  if (!str_cmp(arg1,"flesh")) { improve = ZOMB_FLESH;max=7;}
  else if (!str_cmp(arg1,"mind")) { improve = ZOMB_MIND;max=3;}
  else if (!str_cmp(arg1,"body")) { improve = ZOMB_BODY;max=7;}
  else{
  send_to_char("Syntax: zombpowers (flesh/mind/body) improve\n\r",ch);
  return;}
  cost = (ch->pcdata->powers[improve]+1) * 10;
  arg1[0] = UPPER(arg1[0]);
  if (ch->pcdata->powers[improve] >= max){
  sprintf(buf,"You already have all of your %s skills.\n\r", arg1);
  send_to_char(buf,ch);
  return;}
  if (cost > ch->practice ){
  sprintf(buf,"You do not have the %d primal to improve your %s skills.\n\r",cost,arg1);
  send_to_char(buf,ch);
  return;}
  ch->pcdata->powers[improve] += 1;
  ch->practice -= cost;
  sprintf(buf,"You improve your %s skills.\n\r",arg1);
  send_to_char(buf,ch);
  return;
}

void do_skin( CHAR_DATA *ch, char *argument ) 
{
	char arg[MAX_INPUT_LENGTH];
	OBJ_DATA *obj;
	int hpgain;
        int gain;
	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;
	if (!IS_CLASS(ch, CLASS_ZOMBIE))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}
	if (ch->pcdata->powers[ZOMB_FLESH] < 1)
	{
		send_to_char("You need level 1 Flesh to use Skin.\n\r",ch);
		return;
	}

	if ( arg[0] == '\0' )
	{
		send_to_char("Which corpse do you want to skin?\n\r",ch);
		return;
	}

	obj = get_obj_list( ch, arg, ch->in_room->contents );
	if ( obj == NULL )
	{
		send_to_char( "You can't find it.\n\r", ch );
		return;
	}

	if (obj->item_type != ITEM_CORPSE_NPC)
	{
		act( "The skin of $p is too tough to slice off.", ch, obj, 0, TO_CHAR);
		return;
	}
	else if (obj->chobj != NULL && !IS_NPC(obj->chobj)
		    && obj->chobj->pcdata->obj_vnum != 0)
	{
		act( "The skin of $p is too tough to slice off.", ch, obj, 0, TO_CHAR);
		return;
	}

	hpgain = number_range(750,1000);
	gain = number_range(750,1000); 
	ch->hit += hpgain; 
	if (ch->hit > ch->max_hit)
		ch->hit = ch->max_hit;
	act( "You slice off the skin of $p and add it to your own.", ch, obj, NULL, TO_CHAR );
	act( "$p is totally skinned by $n.", ch, obj, NULL, TO_ROOM );
	extract_obj( obj );
	WAIT_STATE(ch, 4);
	ch->pcdata->powers[ZOMB_SKIN] += gain; 
	return; 
}
void do_feast (CHAR_DATA *ch, char *argument)
{
	CHAR_DATA *victim;
	OBJ_DATA *obj;
	char arg [MAX_INPUT_LENGTH];
	char buf [MAX_STRING_LENGTH];

	argument = one_argument (argument, arg);

	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_ZOMBIE))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}

	if (ch->pcdata->powers[ZOMB_FLESH] < 2)
	{
		send_to_char("Feast Requirement: Level 2 Flesh\n\r",ch);
		return;
	}

	if ( arg[0] == '\0' )
	{
		send_to_char("So, you want to feast upon the living... which one?\n\r",ch);
		return;
	}

	victim = get_char_room(ch, arg);
	if ( ( victim = get_char_room( ch, arg) ) == NULL )
	{
		send_to_char("I don't see them... do you?\n\r",ch);
		return;
	}

	if (IS_SET(victim->in_room->room_flags, ROOM_SAFE))
	{
		send_to_char("Chill... it's a safe room.\n\r",ch);
		return;
	}

	if (is_safe(ch,victim) == TRUE)
		return;

	if (IS_ARM_R(victim,LOST_ARM) && IS_ARM_L(victim,LOST_ARM) &&
		    IS_LEG_R(victim,LOST_LEG) && IS_LEG_L(victim,LOST_LEG))
	{
		send_to_char("Seems you've already turned them into lunch.\n\r",ch);
		return;
	}

	if (number_percent ( ) < 100 )
	{
		if (!IS_ARM_R(victim,LOST_ARM))
		{
			SET_BIT(victim->loc_hp[3],LOST_ARM);
			if ((obj = get_eq_char( victim, WEAR_HOLD )) != NULL )
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_HANDS )) != NULL)
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_WRIST_R )) != NULL)
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_FINGER_R )) != NULL)
				take_item(victim,obj);
			make_part(victim,"arm");
			act("You rip $N's arm off, and feast on it!",ch,victim,TO_CHAR);
			act("$n rips $N's arm off, and feasts on it!",ch,victim,TO_NOVICT);
			act("$n rips your arm off, and feasts on it!",ch,victim,TO_VICT);
			do_get(ch,"arm");
			do_eat(ch,"arm");
			if (victim->hit >= 300)
			{
				sh_int power;
				sh_int dam;
				power = 100;
				dam = dice(power, power + 2);
				if (dam < 0) dam = 0;
				if (dam > ch->max_hit) dam = (ch->max_hit / 2);
				if (dam > 1500) dam = 1500;
				victim->hit -= dam;
				ch->hit += dam / 2;
				if (ch->hit >= ch->max_hit + 5000)
					ch->hit = ch->max_hit + 5000;
				sprintf(buf,"#1You feel much better after absorbing %dhp from $N.#n\n\r",dam,victim->name);
				send_to_char(buf,ch);
				return;
			}
		}

		if (!IS_ARM_L(victim,LOST_ARM))
		{
			SET_BIT(victim->loc_hp[2],LOST_ARM);
			if ((obj = get_eq_char( victim, WEAR_HOLD )) != NULL )
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_HANDS )) != NULL)
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_WRIST_L )) != NULL)
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_FINGER_L )) != NULL)
				take_item(victim,obj);
			make_part(victim,"arm");
			sprintf(buf, "%s tears %s's arm off!",ch->name, victim->name);
			act(buf,ch,NULL,NULL,TO_ROOM);
			send_to_char(buf,ch);
			do_get(ch,"arm");
			do_eat(ch,"arm");
			if (victim->hit >= 300)
			{
				sh_int power;
				sh_int dam;
				power = 100;
				dam = dice(power, power + 2);
				if (dam < 0) dam = 0;
				if (dam > ch->max_hit) dam = (ch->max_hit / 2);
				if (dam > 1500) dam = 1500;
				victim->hit -= dam;
				ch->hit += dam / 2;
				if (ch->hit >= ch->max_hit + 250)
					ch->hit = ch->max_hit + 250;
				sprintf(buf,"#1You absorb %d hitpoints from your meal.#n\n\r",dam);
				send_to_char(buf,ch);
				return;
			}
		}
		if (!IS_LEG_R(victim,LOST_LEG))
		{
			SET_BIT(victim->loc_hp[5],LOST_LEG);
			if ((obj = get_eq_char( victim, WEAR_FEET )) != NULL )
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_LEGS )) != NULL)
				take_item(victim,obj);
			make_part(victim,"leg");
			sprintf(buf, "%s tears %s's leg off!",ch->name, victim->name);
			act(buf,ch,NULL,NULL,TO_ROOM);
			send_to_char(buf,ch);
			do_get(ch,"leg");
			do_eat(ch,"leg");
			if (victim->hit >= 300)
			{
				sh_int power;
				sh_int dam;
				power = 100;
				dam = dice(power, power + 2);
				if (dam < 0) dam = 0;
				if (dam > ch->max_hit) dam = (ch->max_hit / 2);
				if (dam > 1500) dam = 1500;
				victim->hit -= dam;
				ch->hit += dam / 2;
				if (ch->hit >= ch->max_hit + 250)
					ch->hit = ch->max_hit + 250;
				sprintf(buf,"#1You absorb %d hitpoints from your meal.#n\n\r",dam);
				send_to_char(buf,ch);
				return;
			}
		}
		if (!IS_LEG_L(victim,LOST_LEG))
		{
			SET_BIT(victim->loc_hp[4],LOST_LEG);
			if ((obj = get_eq_char( victim, WEAR_FEET )) != NULL )
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_LEGS )) != NULL)
				take_item(victim,obj);
			make_part(victim,"leg");
			sprintf(buf, "%s tears %s's leg off!",ch->name, victim->name);
			act(buf,ch,NULL,NULL,TO_ROOM);
			send_to_char(buf,ch);
			do_get(ch,"leg");
			do_eat(ch,"leg");
			if (victim->hit >= 300)
			{
				sh_int power;
				sh_int dam;
				power = 100;
				dam = dice(power, power + 2);
				if (dam < 0) dam = 0;
				if (dam > ch->max_hit)
					dam = (ch->max_hit / 2);
				if (dam > 1500) dam = 1500;
				victim->hit -= dam;
				ch->hit += dam / 2;
				if (ch->hit >= ch->max_hit + 250)
					ch->hit = ch->max_hit + 250;
				sprintf(buf,"#1You absorb %d hitpoints from your meal.#n\n\r",dam);
				send_to_char(buf,ch);
				return;
			}
		}
		else send_to_char("You failed to feast on them.\n\r",ch);
		return;
	}
}

void do_rip (CHAR_DATA *ch, char *argument)                                  
{                                                                               
  char arg[MAX_STRING_LENGTH];                                                  
  CHAR_DATA *victim;                                                            
  AFFECT_DATA af;                                                               
  int i, dam, count, sn;                                                        
  int red_magic = ch->spl[RED_MAGIC];                                           
  int blue_magic = ch->spl[BLUE_MAGIC];                                         
  int green_magic = ch->spl[GREEN_MAGIC];                                       
  int purple_magic = ch->spl[PURPLE_MAGIC];                                     
  int yellow_magic = ch->spl[YELLOW_MAGIC];                                     
  argument=one_argument(argument,arg);                                          
                                                                                
  if (IS_NPC(ch)) return;                                                       
  if (!IS_CLASS(ch, CLASS_ZOMBIE))                                               
  {                                                                             
    send_to_char("Huh?\n\r",ch);                                                
    return;                                                                     
  }                                                                             
  if ( IS_CLASS(ch, CLASS_ZOMBIE) && ch->pcdata->powers[ZOMB_FLESH] < 3 )    
  {                                                                             
  send_to_char("You need level 3 Flesh to use this power.\n\r",ch);         
  return;                                                                       
  }                                                                             
    if (arg[0] == '\0')                                                         
    {                                                                           
    send_to_char("Who's skin do you want to rip off in little pieces?\n\r",ch); 
    return;                                                                     
    }                                                                           
    if ((victim = get_char_room(ch, arg)) == NULL)                              
    {                                                                           
      send_to_char("They are not here.\n\r", ch );                              
      return;                                                                   
    }                                                                           
    if (ch->mana < 5000)                                                           
    {                                                                           
      send_to_char("You need 5000 mana.\n\r",ch);                                 
      return;                                                                   
    }                                                                           
    if (victim->position == POS_DEAD || ch->in_room != victim->in_room)         
      return;                                                                   
    count = 0;                                                                  
    for (i = 0;i<5;i++)                                                         
    {                                                                           
      if (i==0) {sn = skill_lookup("purple sorcery");dam=purple_magic;}         
      if (i==1) {sn = skill_lookup("yellow sorcery");dam=yellow_magic;}         
      if (i==2) {sn = skill_lookup("green sorcery");dam=green_magic;}           
      if (i==3) {sn = skill_lookup("red sorcery");dam=red_magic;}               
      if (i==4) {sn = skill_lookup("blue sorcery");dam=blue_magic;}
      if (is_affected(victim, sn))
        continue; 
                                                                                
      count++; 

      af.type      = sn; 
      af.duration  = 10;                                                     
      af.location  = APPLY_HITROLL;                                                 
      af.modifier  = -dam*2;
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              

      af.type		= sn;
      af.duration	= 10;
      af.location 	= APPLY_DAMROLL;
      af.modifier	= -dam*2;
      af.bitvector	= 0;
      affect_to_char(victim, &af);

      af.type		= sn;
      af.duration	= 10;
      af.location	= APPLY_AC;
      af.modifier	= +dam*4;
      af.bitvector	= 0;
      affect_to_char(victim, &af);
    }
    ch->mana -= count * 1200;
    WAIT_STATE(ch,2);
    act("You grab hold of $N, and rip $S skin off in little pieces.",ch,NULL,victim,TO_CHAR);
    act("$n grabs hold of you, and rips off your skin in little pieces.",ch,NULL,victim,TO_VICT);
    act("$n grabs hold of $N, and rips off $N's skin in little pieces.",ch,NULL,victim,TO_NOTVICT);
    return; 
  }

void do_tend (CHAR_DATA *ch,char *argument)
{
	CHAR_DATA *victim;
	OBJ_DATA *obj;
	char arg [MAX_INPUT_LENGTH];
	char buf [MAX_STRING_LENGTH];
	AFFECT_DATA af;
	argument = one_argument (argument, arg);


	if (IS_NPC(ch)) return;
	if (!IS_CLASS(ch, CLASS_ZOMBIE))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}
	if (ch->pcdata->powers[ZOMB_FLESH] < 4)
	{
		send_to_char("Tend Requirement: Level 4 Flesh\n\r",ch);
		return;
	}

	if( arg[0] == '\0' )
	{
		send_to_char("Who's eyes ya gonna claw out?\n\r",ch);
		return;
	}
	victim = get_char_room(ch, arg);
	if ( victim == NULL )
	{
		send_to_char("I don't see them... do you?\n\r",ch);
		return;
	}

	if (IS_SET(victim->in_room->room_flags, ROOM_SAFE))
	{
		send_to_char("Chill... it's a safe room.\n\r",ch);
		return;
	}

	if (is_safe(ch,victim) == TRUE)
		return;

	if ( IS_SET(victim->loc_hp[0],LOST_EYE_L) && IS_SET(victim->loc_hp[0],LOST_EYE_R) )
	{
		send_to_char("You've already clawed out both of their eyes!\n\r",ch);
		return;
	}
	if (number_percent ( ) < 100 )
	{
		if ( !IS_SET(victim->loc_hp[0],LOST_EYE_L) )
		{
			SET_BIT(victim->loc_hp[0],LOST_EYE_L);
			if ((obj = get_eq_char( victim, WEAR_FACE )) != NULL )
				take_item(victim,obj);
			act("You gouge $N's eye out, and replace one of your own with it!",ch,victim,TO_CHAR);
			act("$n gouges $N's eye out, and inserts it instead of their own!",ch,victim,TO_NOVICT);
			act("$n gouges your eye out, and inserts it instead of their own!",ch,victim,TO_VICT);
			sprintf(buf,"#1You absorb $N's vision powers!#n\n\r",victim->name);
				send_to_char(buf,ch);
				return; 
		}
		} 
		if ( !IS_SET(victim->loc_hp[0],LOST_EYE_R) ) 
		{
			SET_BIT(victim->loc_hp[0],LOST_EYE_R);
			if ((obj = get_eq_char( victim, WEAR_FACE )) != NULL )
				take_item(victim,obj);
			act("You gouge $N's eye out, and replace one of your own with it!",ch,victim,TO_CHAR); 
			act("$n gouges $N's eye out, and inserts it instead of their own!",ch,victim,TO_NOVICT);
			act("$n gouges your eye out, and inserts it instead of their own!",ch,victim,TO_VICT); 
			sprintf(buf,"#1You absorb $N's vision powers!#n\n\r",victim->name);
				send_to_char(buf,ch); 
				return;  
		}
	}
	if ( IS_SET(victim->loc_hp[0],LOST_EYE_R) &&
	     IS_SET(victim->loc_hp[0],LOST_EYE_L))
	{
	if (IS_SET(victim->act, PLR_HOLYLIGHT);
		REMOVE_BIT(victim->act, PLR_HOLYLIGHT); 
		SET_BIT(ch->act, PLR_HOLYLIGHT); 
	if (IS_SET(victim->pcdata->stats[UNI_AFF], VAM_NIGHTSIGHT);
		REMOVE_BIT(victim->pcdata->stats[UNI_AFF], VAM_NIGHTSIGHT); 
		SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_NIGHTSIGHT);
 
		af.type = skill_lookup("blindness"); 
		af.location  = APPLY_HITROLL;
		af.location  = APPLY_DAMROLL;
		af.modifier = -50000; 
		af.duration  = 1000;
		af.bitvector = AFF_BLIND;
		affect_to_char( victim, &af );
		WAIT_STATE(ch, 2);
		return;           
}
}
}

void do_fillet( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *victim;
	char arg [MAX_INPUT_LENGTH];
	int dam;
	char buf [MAX_STRING_LENGTH];

	argument = one_argument( argument, arg );

	if ( IS_NPC(ch) ) return;

	if (!IS_CLASS(ch, CLASS_ZOMBIE))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}

	if (ch->pcdata->powers[ZOMB_FLESH] < 5 )
	{
		send_to_char("You must obtain level 5 Flesh to use Fillet.\n\r",ch);
		return;
	}

	if ( ( victim = get_char_room( ch, arg ) ) == NULL )
	{
		send_to_char( "They aren't here.\n\r", ch );
		return;
	}
	if ((ch->fighting) != NULL) victim = ch->fighting;

	if ( arg[0] == '\0' )
	{
		send_to_char( "Whose skin do you want to fillet off?\n\r", ch );
		return;
	}

	if (victim->hit < 500)
	{
		send_to_char("They are far to hurt to do that!\n\r",ch);
		return;
	}

	if (is_safe(ch, victim))
	{
		send_to_char("Not while in a safe room!\n\r", ch);
		return;
	}

	if (IS_NPC(victim))
	{
		dam = ch->pcdata->powers[ZOMB_FLESH] * (75 * number_range(2,6)) + number_range(1,100);
		hurt_person(ch, victim, dam);
		ch->hit += dam / 2;
		if (ch->hit > ch->max_hit + 1000) ch->hit = ch->max_hit + 1000;
		sprintf( buf, "%s fillets your skin for [#r%d#n].\n\r", ch->name, dam );
		send_to_char( buf, victim );
		sprintf( buf, "You fillet %s's skin for [#r%d#n] [#L%d#n].\n\r", victim->name, dam, dam/2 );
		send_to_char( buf, ch );
		act("$n fillets off a bunch of skin from $N.", ch, NULL, victim, TO_NOTVICT);
		WAIT_STATE(ch,12);
		return;
	}

	if (!IS_NPC(victim))
	{
		dam = ch->pcdata->powers[ZOMB_FLESH] * (75 * number_range(2,6)) + number_range(1,100);
		hurt_person(ch, victim, dam);
		ch->hit += dam / 2;
		if (ch->hit > ch->max_hit + 1000) ch->hit = ch->max_hit + 1000;
		sprintf( buf, "%s fillets your skin for [#r%d#n].\n\r", ch->name, dam );
		send_to_char( buf, victim );
		sprintf( buf, "You fillet %s's skin for [#r%d#n].\n\r", victim->name, dam );
		send_to_char( buf, ch );
		act("$n fillets off a bunch of skin from $N.", ch, NULL, victim, TO_NOTVICT);
		WAIT_STATE(ch,12);
		return;
	}
}

void do_strongflesh( CHAR_DATA *ch, char *argument )
{
	char arg [MAX_INPUT_LENGTH]; 
	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;
    
	if ( !IS_CLASS(ch, CLASS_ZOMBIE))
	{
		stc("Huh?\n\r",ch);
		return;
	}
	if (IS_CLASS(ch, CLASS_ZOMBIE) && ch->pcdata->powers[ZOMB_FLESH] < 6)
	{
		send_to_char("You need level 6 Flesh to use strongflesh.\n\r",ch);
		return;
	}
	if (IS_SET(ch->pcdata->stats[UNI_AFF],DEM_TOUGH))
	{
		send_to_char("Your skin begins to weaken and rot.\n\r",ch);
		act("$n's skin begins to rot.", ch, NULL, NULL, TO_ROOM);
		REMOVE_BIT(ch->pcdata->stats[UNI_AFF], DEM_TOUGH);
		return; 
	}
        if (!IS_SET(ch->pcdata->stats[UNI_AFF],DEM_TOUGH))
        {
	send_to_char("Your skin becomes extremely strong.\n\r",ch); 
	act("$n's skin heals up all signs of rot and looks new.", ch, NULL, NULL, TO_ROOM);
	SET_BIT(ch->pcdata->stats[UNI_AFF], DEM_TOUGH);
	return;
}
}

void do_detongue( CHAR_DATA *ch, char *argument )      
{                                                                               
    char arg[MAX_INPUT_LENGTH];  
    char buf[MAX_STRING_LENGTH];                               
    CHAR_DATA *victim; 
    OBJ_DATA *obj;
    one_argument( argument, arg );
                                              
    if (IS_NPC(ch)) return; 
    if (!IS_CLASS(ch, CLASS_ZOMBIE))
    {
           send_to_char( "Huh?\n\r", ch );
           return;
    }
    else if ( ch->pcdata->powers[ZOMB_FLESH] < 7 )
    {
            send_to_char( "You need Flesh level 7 to use this skill.\n\r",ch);
            return;
    } 
    if ( arg[0] == '\0' ) 
    {                                                                           
        send_to_char( "Rip who's tongue out?", ch );                     
        return;                                                                 
    }                                                                           
    if ( ( victim = get_char_room( ch, arg ) ) == NULL )                       
    {                                                                           
        send_to_char( "They aren't here.\n\r", ch );                            
        return;                                                                 
    }                                                                           
    if ( IS_NPC(victim) )                                                       
    {                                                                           
        send_to_char( "Not on NPC's.\n\r", ch );                                
        return;                                                                 
    }                                                                           
    if ( IS_HEAD(victim, LOST_TONGUE) || IS_HEAD(victim, LOST_HEAD))
    {                                                                           
        send_to_char( "Their tongue has already been ripped out!\n\r", ch);
    }                                                                           
    else if (!IS_HEAD(victim, LOST_TONGUE) || !IS_HEAD(victim, LOST_HEAD))
    {                                                                           
        act( "You reach deeply into $N's mouth, rip out their tongue, and eat it!\n\r",ch,NULL,victim,TO_CHAR);
        act( "$n reaches deeply into your mouth, rips out your tongue, and eats it!\n\r",ch,NULL,victim,TO_VICT);
        act( "$n reaches deeply into $N's mouth, rips out their tongue, and eats it!\n\r",ch,NULL,victim,TO_ROOM);
        SET_BIT(victim->loc_hp[LOC_HEAD],LOST_TONGUE);            
        if ((obj = get_eq_char( victim, WEAR_FACE )) != NULL )   
        take_item(victim,obj);                          
        make_part(victim,"tongue");                         
        do_get(ch,"tongue");                                  
	do_eat(ch,"tongue");
        if (victim->hit >= 300)
	{
          sh_int power;                                   
          sh_int dam;                                     
          power = 100;                                    
          dam = dice(power, power + 2);                   
          if (dam < 0) dam = 0;                           
          if (dam > ch->max_hit) dam = (ch->max_hit/2); 
          if (dam > 1500) dam = 1500;                     
          victim->hit -= dam;                             
          ch->hit += dam / 2;                             
          if (ch->hit >= ch->max_hit + 250)               
          ch->hit = ch->max_hit + 250;            
          sprintf(buf,"#1You absorb %d hitpoints from your meal.#n\n\r",dam);
          send_to_char(buf,ch);                           
          return;                                         
        }
    }
}

void do_lobotomy (CHAR_DATA *ch, char *argument)                            
{                                                                               
        CHAR_DATA *victim;                                                      
        OBJ_DATA *obj;                                                          
        char arg [MAX_INPUT_LENGTH];                                            
        char buf [MAX_STRING_LENGTH];                                           
        argument = one_argument (argument, arg);                                
        if (IS_NPC(ch)) return;                                                 
        if (!IS_CLASS(ch, CLASS_ZOMBIE))                                         
        {                                                                       
                send_to_char("Huh?\n\r",ch);                                    
                return;                                                         
        }                                                                       
       if (ch->pcdata->powers[ZOMB_MIND] < 2)                               
        {                                                                       
                send_to_char("You need level 2 Mind to use Lobotomy.\n\r",ch);
                return;                                                         
        }                                                                       
        if ( arg[0] == '\0' )                                                   
        {                                                                       
                send_to_char("Who do you wish to feed on?\n\r",ch);             
                return;                                                         
        }                                                                       
        victim = get_char_room(ch, arg);                                        
        if ( ( victim = get_char_room( ch, arg) ) == NULL )                     
        {                                                                       
                send_to_char("They arent here.\n\r",ch);                        
                return;                                                         
        }                                                                       
        victim = get_char_room(ch, arg);                                        
        if ( ( victim = get_char_room( ch, arg) ) == NULL )                     
        {                                                                       
                send_to_char("They arent here.\n\r",ch);                        
                return;                                                         
        }                                                                       
        if (IS_SET(victim->in_room->room_flags, ROOM_SAFE))                     
        {                                                                       
                send_to_char("You cannot attack them here.\n\r",ch);            
                return;                                                         
        }                                                                       
        if (is_safe(ch,victim) == TRUE)                                         
                return;                             
        if (IS_SET(victim->loc_hp[9],LOST_BRAIN))     
        {                                                                       
                send_to_char("You pulled out their brains already!\n\r",ch); 
                return;                                                         
        }                                                                       
        if (number_percent ( ) < 45 )                                           
        {                                                                       
                if (!IS_SET(victim->loc_hp[9],LOST_BRAIN))                      
                {                                                               
                       SET_BIT(victim->loc_hp[9],LOST_BRAIN);               
                        if ((obj = get_eq_char( victim, WEAR_HEAD )) != NULL)
                                take_item(victim,obj);                          
                        make_part(victim,"brain");                             
                        sprintf(buf, "%s rips %s's brains out!",ch->name, victim->name);
                        send_to_char(buf,ch); 
                        act(buf,ch,NULL,NULL,TO_ROOM);                          
                        do_get(ch,"brain");                                     
                        do_eat(ch,"brain");                                   
                        if (victim->hit >= 300)                                 
                        {                                                       
                                sh_int power;                                   
                                sh_int dam;                                     
                                power = 100;                                    
                                dam = dice(power, power + 2);                   
                                if (dam < 0) dam = 0;                           
                                if (dam > ch->max_hit) dam = (ch->max_hit/ 2); 
                                if (dam > 1500) dam = 1500;                     
                                victim->hit -= dam;                             
                                ch->hit += dam / 2;                             
                                if (ch->hit >= ch->max_hit + 250)               
                                        ch->hit = ch->max_hit + 250;            
                                sprintf(buf,"#1You absorb %d hitpoints from your meal.#n\n\r",dam);
                                send_to_char(buf,ch); 
                                return;                                         
                                }
			       }
		      	      }

}

void do_genius (CHAR_DATA *ch, char *argument)
{
  char arg[MAX_STRING_LENGTH];                                  
  CHAR_DATA *victim;                                                            
  AFFECT_DATA af;                                                               
  int i, dam, count, sn;                                                        
  int red_magic = ch->spl[RED_MAGIC];                                           
  int blue_magic = ch->spl[BLUE_MAGIC];                                         
  int green_magic = ch->spl[GREEN_MAGIC];                                       
  int purple_magic = ch->spl[PURPLE_MAGIC];                                     
  int yellow_magic = ch->spl[YELLOW_MAGIC];                                     
  argument=one_argument(argument,arg);                                         

  if (IS_NPC(ch)) return;                                                       
  if (!IS_CLASS(ch, CLASS_ZOMBIE))             
  {                                                                             
    send_to_char("Huh?\n\r",ch);                                                
    return;                                                                     
  }
  if ( IS_CLASS(ch, CLASS_ZOMBIE) && ch->pcdata->powers[ZOMB_MIND] < 3 )
  {
  send_to_char("You need level 3 Mind to use this power.\n\r",ch);
  return;
  }    
    if (arg[0] == '\0')
    {
    send_to_char("Who do you wish to use Genius on?\n\r",ch);
    return;
    }     
    if ((victim = get_char_room(ch, arg)) == NULL) 
    {                                                                           
      send_to_char("They are not here.\n\r", ch );                              
      return;                                                                   
    }                                                                           
    if (ch->mana <25)                                                         
    {                                                                           
      send_to_char("You need 25 mana.\n\r",ch);                               
      return;                                                                   
    }                                                                           
    if (victim->position == POS_DEAD || ch->in_room != victim->in_room)         
      return;                                                                   
    count = 0;                                                                  
    for (i = 0;i<5;i++)                                                         
    {                                                                           
      if (i==0) {sn = skill_lookup("purple sorcery");dam=purple_magic;}         
      if (i==1) {sn = skill_lookup("yellow sorcery");dam=yellow_magic;}         
      if (i==2) {sn = skill_lookup("green sorcery");dam=green_magic;}           
      if (i==3) {sn = skill_lookup("red sorcery");dam=red_magic;}               
      if (i==4) {sn = skill_lookup("blue sorcery");dam=blue_magic;}             
      if (is_affected(victim, sn))                                              
        continue;                                                               

      count++;                                                                  

      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_HIT;                                                 
      af.modifier  = -dam*2;                                                    
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_AC;                                                  
      af.modifier  = dam/2;                                                     
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_MOVE;                                                
      af.modifier  = -dam*2;                                                    
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_MANA;                                                
      af.modifier  = -dam*2;                                                    
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_HITROLL;                                             
      af.modifier  = -dam/3;                                                    
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_DAMROLL;                                             
      af.modifier  = -dam/3;                                                    
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
    }                                                                           
    ch->mana -= count * 5;                                                    
    WAIT_STATE(ch,2); 
    act("You snicker, then slap $N upside the head!!",ch,NULL,victim,TO_CHAR);
    act("$n snickers, then slaps you upside the head!!",ch,NULL,victim,TO_VICT);
    act("$n snickers, then slaps $N upside the head!!",ch,NULL,victim,TO_NOTVICT);
    return; 
  }                                                                             

void do_sniff( CHAR_DATA *ch, char *argument )
{
	char arg1[MAX_INPUT_LENGTH];
	char buf[MAX_INPUT_LENGTH];
	CHAR_DATA *victim;

	argument = one_argument( argument, arg1 );

	if ( IS_NPC( ch ) ) return;
	if ( !IS_CLASS( ch, CLASS_ZOMBIE ) )
	{
		send_to_char( "Huh?\n\r", ch );
		return;
	}
	else if ( ch->pcdata->powers[ZOMB_MIND] < 7 )
	{
		send_to_char( "You need Mind level 7 to use this skill.\n\r", ch );
		return;
	}

	if ( arg1[0] == '\0' )
	{
		send_to_char("Who do you wish to sniff?\n\r",ch);
		return;
	}

	victim = get_char_room(ch, arg1);
	if ( ( victim = get_char_room( ch, arg1) ) == NULL )
	{
		send_to_char("They aren't here.\n\r",ch);
		return;
	}

	sprintf( buf, "%s has %d of %d hitpoints.\n\r", victim->name, victim->hit, victim->max_hit );
	send_to_char( "You sniff them and find that:\n\r", ch );
	send_to_char( buf, ch );
	sprintf( buf, "%s sniffs you hungrily- I wouldn't hang around too long!\n\r", ch->name );
	send_to_char( buf, victim );
}

void do_denerve( CHAR_DATA *ch, char *argument )
{ 
if (IS_NPC(ch)) return;
if (!IS_CLASS(ch, CLASS_ZOMBIE))
{
send_to_char("Huh?\n\r",ch);
return;
}
if (ch->pcdata->powers[ZOMB_BODY] < 1)
{
send_to_char("You need level 1 Body to use denerve.\n\r",ch);
return;
}
if ( IS_GAR1(ch, WOLF_COCOON) )
{
stc("Your ability to feel pain has returned.\n\r",ch);
act("$n can feel pain now.",ch,NULL,NULL,TO_ROOM);
REMOVE_BIT(ch->garou1, WOLF_COCOON);
return;
}
stc("You hit yourself in the neck and stop your ability to feel pain.\n\r",ch);
act("$n hits $s self in the neck and stops feeling pain.",ch,NULL,NULL,TO_ROOM);
SET_BIT(ch->garou1, WOLF_COCOON);
return;
}

void do_pulp( CHAR_DATA *ch, char *argument ) 
{
	char      arg [MAX_INPUT_LENGTH];
	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;

	if ( !IS_CLASS(ch, CLASS_ZOMBIE))
	{
		stc("Huh?\n\r",ch);
		return;
	}
	if (IS_CLASS(ch, CLASS_ZOMBIE) && ch->pcdata->powers[ZOMB_BODY] < 2)
	{
		send_to_char("You need level 2 Body to use pulp.\n\r",ch);
		return;
	}

	if (IS_SET(ch->pcdata->stats[UNI_AFF],DEM_MIGHT) )
	{
		send_to_char("Your strength of the undead leaves you.\n\r",ch);
		act("$n's undead strength leaves $m.", ch, NULL, NULL, TO_ROOM);
		REMOVE_BIT(ch->pcdata->stats[UNI_AFF], DEM_MIGHT);
		return;
	}
        if (!IS_SET(ch->pcdata->stats[UNI_AFF],DEM_MIGHT))
        { 
	send_to_char("You gain the strength of the undead.\n\r",ch); 
	act("$n gains the strength of the undead.", ch, NULL, NULL, TO_ROOM);
	SET_BIT(ch->pcdata->stats[UNI_AFF], DEM_MIGHT);
	return;
}
}
void do_bonerip( CHAR_DATA *ch, char *argument )
{
	OBJ_INDEX_DATA *pObjIndex;
	OBJ_DATA *obj;
	char arg[MAX_INPUT_LENGTH];
	int vnum = 0;

	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_ZOMBIE) || (ch->pcdata->stats[UNI_GEN] > 2) )
	{
		do_rand_typo(ch,"");
		return;
	}
	if (IS_CLASS(ch, CLASS_ZOMBIE) && ch->pcdata->powers[ZOMB_BODY] < 3)
	{
		send_to_char("You need level 3 Body to use bonerip.\n\r",ch);
		return;
	}
	if ( ch->practice < 100)
	{
		send_to_char("You need 100 primal to do a bonerip.\n\r", ch);
		return;
	}
	else ( vnum = 200013 );

	if ( vnum == 0 || (pObjIndex = get_obj_index( vnum )) == NULL)
	{
		send_to_char("Missing object, please inform Wolfman.\n\r",ch);
		return;
	}

	ch->practice   -= 100;
	obj = create_object(pObjIndex, 50);
	obj_to_char(obj, ch);
	SET_BIT(obj->spectype, SITEM_XOMBIWEAPON);
	obj->questowner = str_dup(ch->name);	//Set owner to Victim

	obj->questmaker = str_dup(ch->name);	//Set creator to CH

	act("You rip $p out of your ribcage.",ch,obj,NULL,TO_CHAR);
	act("$n rips $p out of $s ribcage.",ch,obj,NULL,TO_ROOM);
	return;
}

void do_enamel( CHAR_DATA *ch, char *argument )
{
	char      arg [MAX_INPUT_LENGTH];
	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_ZOMBIE))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}
	if (IS_CLASS(ch, CLASS_ZOMBIE) && ch->pcdata->powers[ZOMB_BODY] < 4)
	{
		send_to_char("You need level 4 Body to use enamel.\n\r",ch);
		return;
	}

	if (IS_VAMPAFF(ch,VAM_FANGS) )
	{
		if (IS_CLASS(ch, CLASS_ZOMBIE))
		{
			send_to_char("Your teeth return to their normal whiteness.\n\r",ch);
			act("$n's teeth return to their normal whiteness.", ch, NULL, NULL, TO_ROOM);
		}
		REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_FANGS);
		return;
	}

	if (IS_CLASS(ch, CLASS_ZOMBIE))
	{
		send_to_char("Your teeth become dingy and yellow.\n\r",ch);
		act("$n's teeth become dingy and yellow.", ch, NULL, NULL, TO_ROOM);
	}
	SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_FANGS);
	return;
}

void do_nails( CHAR_DATA *ch, char *argument )
{
	char      arg [MAX_INPUT_LENGTH];
	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_ZOMBIE))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}

	if (IS_CLASS(ch, CLASS_ZOMBIE) && ch->pcdata->powers[ZOMB_BODY] < 5)
	{
		send_to_char("You need level 5 Body to use nails.\n\r",ch);
		return;
	}

	if (IS_VAMPAFF(ch,VAM_CLAWS) )
	{
		if (IS_CLASS(ch, CLASS_ZOMBIE))
		{
			send_to_char("Your finger nails return to normal.\n\r",ch);
			act("$n's finger nails return to normal.", ch, NULL, NULL, TO_ROOM);
		}
		REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_CLAWS);
		return;
	}

	if (IS_CLASS(ch, CLASS_ZOMBIE))
	{
		send_to_char("Your finger nails become much stronger.\n\r",ch);
		act("$n's finger nails become much stronger.", ch, NULL, NULL, TO_ROOM);
	}
	SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_CLAWS);
	return;
}

void do_chew( CHAR_DATA *ch, char *argument ) 
{
	char	arg[MAX_INPUT_LENGTH];

	argument = one_argument (argument, arg);

	if (IS_NPC(ch)) return;
	if (!IS_CLASS(ch, CLASS_ZOMBIE))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}
	if (ch->pcdata->powers[ZOMB_BODY] < 6)
	{
		send_to_char("You need level 6 Body to use chew.\n\r",ch);
		return;
	}
        if (!IS_EXTRA(ch, TIED_UP)){
        stc("Chew what? You arent tied up!!\n\r",ch);
        return;}
          
	else stc("You try to chew through your restraints.\n\r",ch); 
	act("$n chews at $s restraints.",ch,NULL,NULL,TO_ROOM);

	if ( IS_EXTRA(ch, TIED_UP) )
	{
		act("The ropes restraining you snap.",ch,NULL,NULL,TO_CHAR);
		act("The ropes restraining $n snap.",ch,NULL,NULL,TO_ROOM);
		REMOVE_BIT(ch->extra, TIED_UP);
	}
	if (is_affected(ch, gsn_web))
	{
		act("The webbing entrapping $n breaks away.",ch,NULL,NULL,TO_ROOM);
		send_to_char("The webbing entrapping you breaks away.\n\r",ch);
		affect_strip(ch, gsn_web);
	}
	if (IS_AFFECTED(ch, AFF_WEBBED))
	{
		act("The webbing entrapping $n breaks away.",ch,NULL,NULL,TO_ROOM);
		send_to_char("The webbing entrapping you breaks away.\n\r",ch);
		REMOVE_BIT(ch->affected_by, AFF_WEBBED);
	}

	//    if (IS_AFFECTED(ch, AFF2_TENDRILS))
//    {
//      	act("The tendrils entrapping $n break away.",ch,NULL,NULL,TO_ROOM);
//      	send_to_char("The tendrils entrapping you break away.\n\r",ch);
//      	REMOVE_BIT(ch->affected_by, AFF2_TENDRILS);
//    }

	return;
}

void do_brainhunt (CHAR_DATA *ch, char *argument)
{
	CHAR_DATA *victim;
	char arg[MAX_STRING_LENGTH];
	ROOM_INDEX_DATA *location;

	one_argument (argument, arg);

	if (IS_NPC(ch)) return;
	if (!IS_CLASS(ch, CLASS_ZOMBIE))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}
	if (IS_CLASS(ch, CLASS_ZOMBIE) && ch->hit < 1 )
	{
		send_to_char("You are too DEAD at the moment to Brainhunt.\n\r",ch);
		return;
	}
	if (IS_CLASS(ch, CLASS_ZOMBIE) && ch->position == POS_SLEEPING)
	{
		send_to_char("Wake up, sleepyhead... you can't Brainhunt while sleeping!\n\r",ch);
		return;
	}
	if (IS_CLASS(ch, CLASS_ZOMBIE) && ch->position == POS_RESTING)
	{
		send_to_char("Stand up so you can go Brainhunting!!\n\r",ch);
		return;
	}
	else if (ch->pcdata->powers[ZOMB_BODY] < 7 ) 
	{
		send_to_char( "You need Body level 7 to use this skill.\n\r", ch);
		return;
	}
	if ((victim = get_char_world(ch, arg)) == NULL)
	{
		send_to_char("Who's brains look tasty?\n\r", ch );
		return;
	}
    if (ch->fight_timer > 0)                                                    
    {                                                                           
      stc( "You may not travel with a fight timer.\n\r",ch);                    
      return;                                                                   
        }
	location = victim->in_room;
	act("You sniff the air, smell FRESH BRAINS, and go chasing after them!!", ch, NULL, NULL, TO_CHAR);
	act("$n sniffs the air, yells MMMMmmmm FRESH BRAINS, and runs out of the room!!", ch, NULL, NULL, TO_ROOM);
	char_from_room(ch);
	char_to_room(ch, location);
	do_look(ch, "auto");
	act("Your keen sense of smell for fresh brains has paid off!!", ch, NULL, NULL, TO_CHAR);
	act("$n walks into the room and yells FRESH BRAINS!!!!", ch, NULL, NULL, TO_ROOM);
	WAIT_STATE(ch, 2);
	return;
}

void do_flesharmor( CHAR_DATA *ch, char *argument ) 
{
	char arg [MAX_INPUT_LENGTH];
	char buf [MAX_STRING_LENGTH]; 
	int cost; 
	OBJ_INDEX_DATA *pObjIndex;
	OBJ_DATA *obj;
	int vnum = 0;

	cost = 50000;

	argument = one_argument( argument, arg );

	if ( IS_NPC( ch ) )
	{
		send_to_char( "Huh?\n\r", ch );
		return;
	}

	if ( !IS_CLASS( ch, CLASS_ZOMBIE ) )
	{
		send_to_char( "You tug at your skin but it hurts too much!\n\r", ch );
		return;
	}

	if ( ch->practice < 100 )
	{
		send_to_char( "You do not have the required 100 primal!\n\r", ch );
		return;
	}
	
	if ( ch->pcdata->powers[ZOMB_SKIN] < cost )
	{
	sprintf( buf, "It costs 50,000 skins to make this armor, and you only have %d!\n\r", ch->pcdata->powers[ZOMB_SKIN] );
	send_to_char( buf, ch );
	return;
	}
	
	if ( !str_cmp( arg, "Finger") )	vnum = 200001;
	else if ( !str_cmp( arg, "Neck"  ) ) 	vnum = 200002;
	else if ( !str_cmp( arg, "Body"  ) ) 	vnum = 200008;
	else if ( !str_cmp( arg, "Head"  ) )	vnum = 200011;
	else if ( !str_cmp( arg, "Legs"  ) )	vnum = 200005;
	else if ( !str_cmp( arg, "hands" ) )	vnum = 200004;
	else if ( !str_cmp( arg, "arms"  ) )	vnum = 200012;
	else if ( !str_cmp( arg, "about" ) )	vnum = 200010;
	else if ( !str_cmp( arg, "waist" ) )	vnum = 200007;
	else if ( !str_cmp( arg, "wrist" ) )	vnum = 200003;
	else if ( !str_cmp( arg, "face"  ) )	vnum = 200009;
	else if ( !str_cmp( arg, "feet"  ) )	vnum = 200006;
	else
	    {
		send_to_char( "You must choose one of the armor types:\n\r", ch );
		send_to_char( "Finger, Neck, Body, Head, Legs, hands, Arms,\n\r", ch );
		send_to_char( "About, Waist, Wrist, Face, Feet.\n\r", ch );
		return;
	}

	if ( vnum == 0 || (pObjIndex = get_obj_index( vnum )) == NULL)
	{
		send_to_char("Missing object, please inform an SG admin.\n\r",ch);
		return;
	}

	ch->practice -= 100;
	ch->pcdata->powers[ZOMB_SKIN] -= cost;
	obj = create_object(pObjIndex, 50);
	obj_to_char(obj, ch);
	SET_BIT(obj->spectype, SITEM_XOMBIWEAPON);
	obj->questowner = str_dup(ch->name);    	//Set owner to Victim

	obj->questmaker = str_dup(ch->name);    	//Set creator to CH

	act("You peel $p from your skin.",ch,obj,NULL,TO_CHAR);
	act("$n peels $p from $s's skin.",ch,obj,NULL,TO_ROOM);
	return;
}


/*

void do_shred( int sn, int level, CHAR_DATA *ch, void *vo )
{
    CHAR_DATA *victim = (CHAR_DATA *) vo;
    OBJ_DATA *obj_lose;
    OBJ_DATA *obj_next;
    int dam;
    int hpch;
    int hp;
    if ( number_percent( ) < 2 * level && !saves_spell( level, victim ) )
    {
	for ( obj_lose = ch->carrying; obj_lose != NULL; obj_lose = obj_next )
	{
	    int iWear;
	    obj_next = obj_lose->next_content;
	    if ( number_bits( 2 ) != 0 )
		continue;
	    switch ( obj_lose->item_type )
	    {
	    case ITEM_ARMOR:
		if ( obj_lose->value[0] > 0 )
		{
		    act( "You shred through $N's $p as though it was liquid butter!",ch, victim, obj_lose, TO_CHAR );
		    act( "$n shreds through $N's clothes as though it was nothing!",ch,victim,obj_lose,TO_NOVICT);
		    act( "$n shreds through your clothes as though it was nothing!",ch,victim,obj_lose,TO_VICT);
		    if ( ( iWear = obj_lose->wear_loc ) != WEAR_NONE ) 
	 	    victim->armor -= apply_ac( obj_lose, iWear );
		    obj_lose->value[0] -= 1;
		    obj_lose->cost      = 0;
		    if ( iWear != WEAR_NONE )
			victim->armor += apply_ac( obj_lose, iWear );
		}
		break;
	    }
	}
    }
    hpch = UMAX( 10, ch->hit );
    dam  = number_range( hpch/16+1, hpch/8 );
    if ( saves_spell( level, victim ) )
	dam /= 2;
    hp = victim->hit;
    damage( ch, victim, dam, sn );
    return;
}

*/

void do_zombie(CHAR_DATA *ch, char *argument )                                  
{                                                                               
    char buf2[MAX_STRING_LENGTH];                                               
    char buf [MAX_INPUT_LENGTH];                                                
    char arg [MAX_STRING_LENGTH];                                               
    CHAR_DATA *victim;                                                          
    AFFECT_DATA af;                                                             
    OBJ_DATA *obj;                                                              
    one_argument(argument,arg);                                                 
    if (IS_NPC(ch)) return;                                                     
    if (!IS_CLASS(ch, CLASS_VAMPIRE))                                           
     {                                                                          
     send_to_char("Huh?\n\r",ch);                                               
     return;                                                                    
     }                                                                          
    if (arg[0] == '\0')                                                         
    {                                                                           
    send_to_char("Zombie what corpse?\n\r",ch);                                 
    return;                                                                     
    }                                                                           
    if (ch->power[DISC_VAMP_NECR] < 5 && IS_CLASS(ch, CLASS_VAMPIRE))           
    {                                                                           
    send_to_char("You require level 5 Necromancy to create a
zombie.\n\r",ch);  
     return;                                                                    
    }                                                                           
    if (ch->pcdata->followers > 5)                                              
    {                                                                           
        send_to_char("Nothing happens.\n\r",ch);                                
        return;                                                                 
    }                                                                           
    if ((obj = get_obj_carry(ch,arg)) == NULL)                                  
    {                                                                           
    send_to_char("You dont have that corpse.",ch);                              
     return;                                                                    
    }                                                                           
    if (obj->item_type != ITEM_CORPSE_NPC || IS_SET(obj->quest,
QUEST_ZOMBIE))  
    {                                                                           
    send_to_char("You can only Zombie original corpses.\n\r",ch);               
    return;                                                                     
    }                                                                           
                                                                                
                                                                                
    ch->pcdata->followers++;                                                    
                                                                                
                                                                                
    victim=create_mobile( get_mob_index( obj->value[2] ) );                     
    sprintf(buf,"the zombie of %s",victim->short_descr);                        
    sprintf(buf2,"the zombie of %s is here.\n\r",victim->short_descr);          
    free_string(victim->short_descr);                                           
    victim->short_descr = str_dup(buf);                                         
    free_string(victim->name);                                                  
    SET_BIT(victim->act, ACT_NOEXP);                                            
    victim->name = str_dup(buf);                                                
    free_string(victim->long_descr);                                            
    victim->long_descr= str_dup(buf2);                                          
    SET_BIT(victim->extra, EXTRA_ZOMBIE);                                       
        victim->spec_fun = NULL;                                                
    strcpy(buf,"Rise corpse, and bow before me!");                              
    do_say( ch, buf );                                                          
    sprintf(buf, "%s clambers back up to its feet.\n\r",obj->short_descr        
);                                                                              
    act(buf,ch,NULL,NULL,TO_ROOM);                                              
    send_to_char(buf,ch);                                                       
                                                                                
                                                                                
    char_to_room( victim, ch->in_room );                                        
                                                                                
 if (victim->level < 100)                                                       
{                                                                               
    add_follower( victim, ch );                                                 
    af.type      = skill_lookup ("charm person");                               
    af.duration  = 666;                                                         
    af.location  = APPLY_NONE;                                                  
    af.modifier  = 0;                                                           
    af.bitvector = AFF_CHARM;                                                   
    affect_to_char( victim, &af );                                              
}                                                                               
WAIT_STATE(ch,10);                                                              
extract_obj(obj);                                                               
    return;                                                                     
}                                                                               

void do_rot( CHAR_DATA *ch, char *argument )                                    
{                                                                               
    CHAR_DATA *victim;                                                          
    char      arg [MAX_INPUT_LENGTH];                                           
                                                                                
    argument = one_argument( argument, arg );                                   
                                                                                
    if (IS_NPC(ch)) return;                                                     
                                                                                
    if (!IS_CLASS(ch, CLASS_VAMPIRE))                                           
    {                                                                           
        send_to_char( "Huh?\n\r", ch );                                         
        return;                                                                 
    }                                                                           
                                                                                
    if (ch->power[DISC_VAMP_VICI] < 2)                                          
    {                                                                           
        send_to_char("You must obtain at level 2 in Thanatosis to use
Putrefact$
        return;                                                                 
    }                                                                           
                                                                                
                                                                                
    if ( arg[0] == '\0' )                                                       
    {                                                                           
        send_to_char( "Who do you wish to use Putrefaction on?\n\r", ch );      
        return;                                                                 
    }                                                                           
                                                                                
    if ( ( victim = get_char_room( ch, arg ) ) == NULL )                        
    {                                                                           
        send_to_char( "They aren't here.\n\r", ch );                            
        return;                                                                 
    }                                                                           
                                                                                
    if (IS_NPC(victim))                                                         
    {                                                                           
       send_to_char("Why use Putrefaction on a mob?\n\r", ch);                 
        return;                                                                 
    }                                                                           
                                                                                
    if ( IS_EMPLOYEE(victim) && victim != ch )                                  
    {                                                                           
        send_to_char( "You can only use Putrefaction on Avatar's or
lower.\n\r"$
        return;                                                                 
    }                                                                           
   if (is_safe(ch,victim) == TRUE) return;                                     
                                                                                
    if (victim->hit < victim->max_hit)                                          
    {                                                                           
      send_to_char("They are hurt and suspicious.\n\r", ch);                    
      return;                                                                   
    }                                                                           
    act("You close your eyes and concentrate on $N.",
ch,NULL,victim,TO_CHAR);  
    act("$n closes $s eyes and concentrates on you.",
ch,NULL,victim,TO_VICT);  
    act("$n closes $s eyes and cencentrates on $N.",
ch,NULL,victim,TO_NOTVICT);
   WAIT_STATE(ch, 12);                                                         
    if (number_percent( ) < 50)                                                 
    {                                                                           
        send_to_char("You failed.\n\r",ch);                                     
        return;                                                                 
    }                                                                           
                                                                                
    act("Your flesh begins to rot!", victim,NULL,NULL,TO_CHAR);                 
    act("$n's flesh begins to rot!", victim,NULL,NULL,TO_ROOM);                 
    SET_BIT(victim->extra, EXTRA_ROT);                                          
    return;                                                                     
}                                                                               

